define(function(require, exports, module) {
	var shellPlugin = require("shellPlugin");

	function iAlert(content, type, callback, button) {
		var param = {
			content: content,
			type: type,
			button: button
		}
		shellPlugin.callShellMethod("iAlert", callback, null, param);
	}

	function iConfirm(content, callbackY, callbackN, buttonY, buttonN) {
		var param = {
			content: content,
			buttonY: buttonY,
			buttonN: buttonN
		}
		shellPlugin.callShellMethod("iConfirm", callbackY, callbackN, param);
	}

	function iMsg(type, content, time) {
		var param = {
			type: type,
			content: content,
			time: time
		}
		shellPlugin.callShellMethod("iMsg", null, null, param);
	}

	function iTips() {
	}

	function iTipsClose() {
	}

	function iCustomClose() {
		shellPlugin.callShellMethod("iCustomClose", null, null, {});
	}

	function iLayerClose() {
		shellPlugin.callShellMethod("iLayerClose", null, null, {});
	}

	function iLoading(state, content, display) {
		var param = {
			state: state,
			content: content,
			display: display
		}
		shellPlugin.callShellMethod("iLoading", null, null, param);
	}

	function layerCustom(html) {
		var param = {
			html: html
		}
		shellPlugin.callShellMethod("layerCustom", null, null, param);
	}

	function getLayerIdx() {

	}

	var layerUtils = {
			iAlert: iAlert,
			iConfirm: iConfirm,
			iMsg: iMsg,
			iTips: iTips,
			iTipsClose: iTipsClose,
			iCustomClose: iCustomClose,
			iLayerClose: iLayerClose,
			iLoading: iLoading,
			layerCustom: layerCustom,
			getLayerIdx: getLayerIdx
		};
	module.exports = layerUtils;
});