define(function(require, exports, module) {
	//var layerUtils = require("layerUtils");
	/**
	 * @param pluginName 要调用的插件名
	 * @param success 调用成功的回调函数
	 * @param fail 调用失败的回调函数
	 * @param param 参数
	 */
	function callShellMethod(pluginName, callbackS, callbackF, param) {
		if (pluginName) {
			//验证入参
			if (typeof callbackS == "function") {
				window.nativeSuccessCallback = callbackS;
				callbackS = "nativeSuccessCallback";
			} else {
				callbackS = null;
			}
			if (typeof callbackF == "function") {
				window.nativeFailedCallback = callbackF;
				callbackF = "nativeFailedCallback";
			} else {
				callbackF = null;
			}
			if (typeof param == "object") {
				param = JSON.stringify(param);
			} else {
				param = null;
			}
			//区分android和IOS平台
			if (iBrowser.android) {
				//调用android方法
				prompt('call://' + pluginName + '("' + callbackS + '"|"' + callbackF + '"|"' + param + '")');
			} else if (iBrowser.ios) {
				try {
					//调用IOS方法
					window.jsInterface[pluginName](callbackS, callbackF, param);
				} catch (e) {
					//layerUtils.iAlert("调用IOS方法失败！");
				}
			} else {
				//layerUtils.iAlert("暂时只支持Android或IOS平台！");
			}
		} else {
			alert("请输入要调用的插件名!");
		}
	}
	var shellPlugin = {
		// 标准方法
		"callShellMethod": callShellMethod
	};
	module.exports = shellPlugin;

	//android返回键触发函数
	// window.onBackButton = function() {
	// 	layerUtils.iConfirm("确定退出程序吗？", function() {
	// 		callShellMethod("closeAppPlugin", null, null, {});
	// 	});
	// };
});