/**
 * Created by lenovo on 2016/2/25.
 */
/**
 * 新开户(转户)须知
 */
define("project/scripts/account/bankList", function(require, exports, module) {
    var appUtils = require("appUtils"),
        shellPlugin = require("shellPlugin"),
        talkingdata=require("talkingdata"),
        publicMethod=require("PublicMethod"),
        gconfig = require("gconfig"),
        global = gconfig.global,
        currVersion = null, // 当前版本号
        layerUtils = require("layerUtils"),
        utils = require("utils"),
        imagesPath = gconfig.imagesPath,
        exceptBankId = ["5001", "5002", "12", "7", "2"],
        exceptBankName = ["上海银行", "兴业银行", "招商银行", "建设银行"],
        _pageId = "#account_bankList";

    function init() {
        // 解决 iPhone 4 和 iPhone 4s 页面不在一屏的问题
        if ($(document).height() > $(window).height()) {
            $(_pageId + " .ness_box").css("padding", "10px");
            $(_pageId + " .main").css("padding-bottom", "5px");
        }
        //新添加begin
        if (global.orgnizationNo != "") {
            //新添加 隐藏银行卡提示
            //$(_pageId+" .tip_1").css("display","none");
            //$(_pageId+" .zc_bankfixed").css("display","none");
            //$(_pageId+" .zc_banklist").css("display","none");
            //调用专属的logo
            showOwnBank(global.orgnizationNo);
            if (global.orgnizationNo == "5000" || global.orgnizationNo == "5100" || global.orgnizationNo == "5900") {
                //建行直接跳转到openAccount页面 ,传入welcome的参数
                appUtils.setSStorageInfo("_isStarted", "true");
                appUtils.setSStorageInfo("login_flag", "0");
            }
        } //新添加end
        else {
            initBanks();
        }
        //埋点
        if(appUtils.getSStorageInfo("login_flag") == "0") {
            talkingdata.record("OPENACCOUNT", "OPENACCOUNT_0401");
        } else if(appUtils.getSStorageInfo("login_flag") == "1") {
            talkingdata.record("OPENACCOUNT_05", "OPENACCOUNT_0501");
        }
    }
    function bindPageEvent() {

        appUtils.bindEvent($(_pageId + "  .header .icon_back"), function() {
            appUtils.pageBack();
        });
    }

    function isShown(bankId) {
        console.log();
        if (exceptBankId == null || exceptBankId.length <= 0) {
            return true;
        }
        for (var i = 0; i < exceptBankId.length; i++) {
            if ((appUtils.getSStorageInfo("login_flag") == "1") && (exceptBankId[i] == bankId)) {
                return false;
            }
        }
        return true;
    }

    function filterBanks(results) {
        if (results == null || results.length <= 0) {
            return;
        }
        for (var i = 0; i < results.length; i++) {
            if (!isShown(results[i].id)) {
                results.remove(i);
                i--;
            }
        }
    }


    function initBanks() {
        showBank();
    }

    function showBank() {
        var queryParam = {
            "funcNo": "1001002"
        };
        if (appUtils.getSStorageInfo("login_flag") == "1") {
            queryParam.opacctkind_flag = 1;
        }
        appUtils.invokeServer(global.serverPath, queryParam, function(data) {
            if (data.error_no == 0) {
                $(_pageId + " .zc_banklist").html("");
                if (data.results.length > 0) {
                    var results = data.results;
                    //filterBanks(results);
                    var length = results.length;
                    var itemElement = "";
                    var num = 0;
                    for (var i = 0; i < length; i++) {
                        var bankId = results[i].id;
                        var bankName = results[i].bankname;
                        var bankImage = imagesPath + "bank/bk_" + bankId + ".png";
                        itemElement += "<li> <div class=\"pic\" style='background: url("+bankImage+") no-repeat center center;background-size:100% auto'><p>" + bankName + "</p></li>";
                        num++;
                    }
                    //if (num <= 5) {
                    $(_pageId + " .zc_banklist").css("width", "90%");
                    //} else {
                    //$(_pageId + " .zc_banklist").css("width", num * 100 / 5 + "%");
                    //}
                    $(_pageId + " .zc_banklist").html(itemElement);
                } else {
                    layerUtils.iAlert("获取所支持的银行卡失败，请稍后重试！");
                }
            }
        });
    }

    function showOwnBank(orgnizationNoTemp) {
        var queryParam = {
            "funcNo": "1001002"
        };
        if (appUtils.getSStorageInfo("login_flag") == "1") {
            queryParam.opacctkind_flag = 1;
        }
        appUtils.invokeServer(global.serverPath, queryParam, function(data) {
            if (data.error_no == 0) {
                $(_pageId + " .zc_banklist").html("");
                if (data.results.length > 0) {
                    var results = data.results;
                    //filterBanks(results);
                    var length = results.length;
                    var itemElement = "";
                    var num = 0;
                    for (var i = 0; i < length; i++) {
                        var bankId = results[i].id;
                        var bankName = results[i].bankname;
                        var bankImage = imagesPath + "bank/bk_" + bankId + ".png";
                        if (orgnizationNoTemp == results[i]["ext_org"]) {
                            itemElement += "<li> <div class=\"pic\"><img src='" + bankImage + "'></div><p>" + bankName + "</p></li>";
                            num++;
                        }
                    }
                    //if (num <= 5) {
                    $(_pageId + " .zc_banklist").css("width", "90%");
                    //} else {
                    //$(_pageId + " .zc_banklist").css("width", num * 100 / 5 + "%");
                    //}
                    $(_pageId + " .zc_banklist").html(itemElement);
                } else {
                    layerUtils.iAlert("获取所支持的银行卡失败，请稍后重试！");
                }
            }
        });
    }

    function destroy() {}

    var bankList = {
        "init": init,
        "bindPageEvent":bindPageEvent,
        "destroy": destroy
    };

    module.exports = bankList;
});