/**
 * 手机号码验证
 */
define("project/scripts/account/msgVerify", function(require, exports, module) {
	var appUtils = require("appUtils"),
		global = require("gconfig").global,
		layerUtils = require("layerUtils"),
		shellPlugin = require("shellPlugin"),
		talkingdata = require("talkingdata"),
		layer = require("layer"),
		validatorUtil = require("validatorUtil"),
		publicMethod = require("PublicMethod"),
		utils = require("utils"),
		startCountDown = null,
		clearCountDown = null,
		_pageId = "#account_msgVerify",
		steps = [
			"uploadimg", "idconfirm", "stkacct", "setpwd",
			"tpbank", "risksurvey", "visitsurvey",
			"witness", "certintall", "success"
		],
		stepMap = {
			"uploadimg": "account/uploadPhoto",
			"idconfirm": "account/personInfo",
			"stkacct": "account/signProtocol",
			"setpwd": "account/setPwd",
			"tpbank": "account/thirdDepository",
			"risksurvey": "account/riskAssessment",
			"visitsurvey": "account/openConfirm",
			"witness": "account/videoNotice",
			"certintall": "account/accountResult",
			"success": "account/accountResult"
		},
		isSendTicket = false;
	var mobile;
	var imageCount = 1,
		systemData="",
		uuidData,
		recommenderNoId = "";
	   global.sid = "";
	   global.ouid = "";
	   global.aid = "";
	   global.recommenderNo = "";
	function init() {
		isSendTicket = false;
		hideTipsForNewUser();
		clearImageCode();
//		$(_pageId+" #image").attr("src",global.imageCode+"?mobile_no=13212121212");
		getPhoneNo();
		getConfgurate();
		///埋点
		talkingdata.record("MSGVERFIY", "MSGVERFIY_0601");
		//查询转户视频开关
		qryZhVideo();
		isSdk();
		getAccountResultLink();
	}

	//判断是否是SDK
	function isSdk(){
		if (global.isSDK == true) {
			shellPlugin.callShellMethod("toH5recommenderNoId", function (data) {
				recommenderNoId = data;
				// 回调数据中的 data 是字符串，需解析
				if(typeof (data) == "string"){
					recommenderNoId = JSON.parse(recommenderNoId);
				}
				    global.sid = recommenderNoId.sid;
					global.aid = recommenderNoId.aid;
				    global.ouid = recommenderNoId.ouid;
					global.recommenderNo = recommenderNoId.recommenderNo;
			} , null, null);
		}
	}
	function getConfgurate(){
		$.ajax({
			type:"post",
			//url:global.imageServlet,
			url:global.serverPath.substring(0,global.serverPath.length-4)+"Function800002",
			dataType: "json",
			success:function(data){
				uuidData=data;
				if(data.myCodeCount == "0"){
					$(_pageId + " #image").attr("src", global.imageCode + "?mobile_no=" + mobile +"&uuid="+uuidData.uuid+ "&r=" + Math.random());
					$(_pageId + " #imageDiv").show();
				}else{
					$(_pageId + " #imageDiv").hide();
				}
			},
			error:function(data) {
				//if(typeof(data.error_info) != "undefined"){
				//	layerUtils.iAlert(data.error_info, -1);
				//}
				layerUtils.iAlert('网络异常，请稍后重试!', -1);
			}
		});
	}
	function qryZhVideo() {
		appUtils.setSStorageInfo("zh_video", 0);
		var attr = {
			"funcNo": 600007
		};
		appUtils.invokeServer(global.serverPath, attr, function(data) {
			if (data.error_no == 0) {
				if (data.results[0].is_mobilevideo == 1 || data.results[0].is_mobilevideo == "1") {
					appUtils.setSStorageInfo("zh_video", data.results[0].is_mobilevideo);
				}
			}
		});
	}

	function clearImageCode() {
		$(_pageId + " #imageCode").val("");
		var temp = appUtils.getSStorageInfo("mobile");
		if (temp != null && temp != "") {
			$(_pageId + " .phoneNum").val(temp);
		}
		//$(_pageId+" #imageDiv").hide();
	}

	function hideTipsForNewUser() {
		if (appUtils.getSStorageInfo("login_flag") == "0") {
			$(_pageId + " .zhuyi").hide();
		} else {
			$(_pageId + " .zhuyi").show();
		}
	}
	function destroy() {
		// 清除计时器
		if (startCountDown != null) {
			window.clearInterval(startCountDown);
		}
		if (clearCountDown != null) {
			window.clearTimeout(clearCountDown);
		}
		// 显示按钮
		$(_pageId + " .getmsg").show();
		// 隐藏验证码已发出提示
		$(_pageId + " .cert_notice").hide();
		// 隐藏倒计时
		$(_pageId + " .time").hide();
		//清除手机号
		$(_pageId + " .phoneNum").val("");
		// 清除验证码
		$(_pageId + " .mobileCode").val("");
		// 设置 isSentCode 属性，true 表示已发送验证码，且验证码有效，false 为发送验证码，或者验证码无效
		$(_pageId + " .getmsg").attr("isSentCode", false);
	}
	function getPhoneNo() {
		shellPlugin.callShellMethod("getPhoneNoPlugin", function(data) {
			if(data) {
				var phoneReg = /^[1-9]\d{10}$/;
				// 返回的数据是 +86手机号时，截取
				if (data.length == 14) {
					data = data.substring(3);
				}
				// 解决出现 0 或者 6 个 0 的问题
				else if (!phoneReg.test(data)) {
					$(_pageId + " .phoneNum").val("");
					return;
				}
				$(_pageId + " .phoneNum").val(data);
				// 将光标移到输入框末尾
				utils.setCursorPosition(obj);
			}
		}, null, {});
	}
	function bindPageEvent() {
		// 绑定FAQ常见问题按钮
		publicMethod.bindProblemEvent(_pageId);
		appUtils.bindEvent($(_pageId), function() {
			$(_pageId + " .header_icon").hide();
		});

		appUtils.bindEvent($(_pageId + " #a_setting"), function(event) {
			$(_pageId + " .header_icon").toggle();
			event.stopPropagation();
		});

		appUtils.bindEvent($(_pageId + " #a_phone"), function() {
			utils.callKHRXPhone("4000-188-288");
			//埋点
			talkingdata.record("MSGVERFIY", "MSGVERFIY_0602");
		});
		appUtils.bindEvent($(_pageId + " #certNotice"), function() {
			utils.callKHRXPhone("400-100-5283");
		});
		appUtils.bindEvent($(_pageId + " #recommenderInfo"), function() {
			shellPlugin.callShellMethod("recommenderPlugin", null, null, null);
		});

		appUtils.bindEvent($(_pageId + " .mobileCode"), function() {
			utils.dealIPhoneMaxLength(this, 6);
		}, "input");

		appUtils.bindEvent($(_pageId + " .mobileCode"), function() {
			talkingdata.record("MSGVERFIY", "MSGVERFIY_0608");
		}, "focus");

		appUtils.bindEvent($(_pageId + " #imageCode"), function() {
			utils.dealIPhoneMaxLength(this, 4);
		}, "input");

		appUtils.bindEvent($(_pageId + " #imageCode"), function() {
			talkingdata.record("MSGVERFIY", "MSGVERFIY_0607");
		}, "focus");

		appUtils.bindEvent($(_pageId + " .phoneNum"), function() {
			utils.dealIPhoneMaxLength(this, 11);
			utils.showBigNo(this, 1);
		}, "input");

		appUtils.bindEvent($(_pageId + " .phoneNum"), function() {
			utils.showBigNo(this, 1);
			//埋点
			talkingdata.record("MSGVERFIY", "MSGVERFIY_0604");
		}, "focus");

		appUtils.bindEvent($(_pageId + " .header .icon_back"), function() {
			appUtils.pageBack();
		});

		/*获取图形验证码*/
		var imgCodeFlag = true;
		appUtils.bindEvent($(_pageId + " .code_send_falg"), function() {
			$(_pageId + " #image").attr("src", global.imageCode + "?mobile_no=" + mobile +"&uuid="+uuidData.uuid+ "&r=" + Math.random());
			//埋点
			talkingdata.record("MSGVERFIY", "MSGVERFIY_0606");
		});

		/* 获取短信验证码 */
		appUtils.bindEvent($(_pageId + " .getmsg"), function() {
			var phoneNum = $(_pageId + " .phoneNum").val();
			var systemVersion={
				"phoneNum":phoneNum
			}
			shellPlugin.callShellMethod("deviceInfoPlugin", function (data) {
				systemData=data;
				// 回调数据中的 data 是字符串，需解析
				if (typeof(data) == "string") {
					systemData = JSON.parse(systemData);
				}
				//获取app版本号并存储
				sessionStorage.removeItem("appVersion");
				sessionStorage.setItem("appVersion",systemData.appVersion);
			}, null , systemVersion);
			// 是手机号时才发送验证码
			if (validatorUtil.isMobile(phoneNum)) {
				mobile = phoneNum;
				appUtils.setSStorageInfo("mobile", mobile);
				if (imageCount > 0) {
					sendVerifyCode();
				} else {
					if ($(_pageId + " #imageDiv").css("display") == "none") {
						$(_pageId + " #image").attr("src", global.imageCode + "?mobile_no=" + mobile + "&r=" + Math.random());
						layerUtils.iMsg(-1, "请先输入图形验证码！");
						$(_pageId + " #imageDiv").show();
					} else {
						if ($(_pageId + " #imageCode").val().length == 0) {
							layerUtils.iMsg(-1, "请输入图形验证码！");
							return;
						} else if ($(_pageId + " #imageCode").val().length < 4) {
							layerUtils.iMsg(-1, "图形验证码输入不正确！");
							return;
						} else if ($(_pageId + " #imageCode").val().length = 4) {
							sendVerifyCode();
						}
					}
				}
			}else {
				// 手机号没通过前端校验，弹出提示，并终止发送验证码的过程
				var times = phoneNum.length - 11;
				if (phoneNum.length > 11) {
					layerUtils.iMsg(-1, "您多输入&nbsp;" + times + "&nbsp;位电话号码，请重新输入！");
					return;
				} else if (phoneNum.length < 11) {
					layerUtils.iMsg(-1, "您少输入&nbsp;" + Math.abs(times) + "&nbsp;位电话号码，请重新输入！");
					return;
				}
				layerUtils.iMsg(-1, "请输入正确的手机号！");
				return;
			}
			//埋点
			talkingdata.record("MSGVERFIY", "MSGVERFIY_0605");
		});

		/* 下一步(继续开户) */
		appUtils.bindEvent($(_pageId + " .fix_bot .ct_btn"), function() {
			// 关闭提示层
			layer.closeAll();
			if ($(_pageId + " .phoneNum").val().length == 0) {
				layerUtils.iMsg(-1, "请输入手机号！");
				return;
			}
			if ($(_pageId + " .mobileCode").val().length == 0) {
				layerUtils.iMsg(-1, "请输入验证码！");
				return;
			}
			submitVerifyCode();
			//埋点
			talkingdata.record("MSGVERFIY", "MSGVERFIY_0609");
		});

		//小安机器人
		publicMethod.bindXiaoAnEvent(_pageId,false);
	}
	/*发送验证码*/
	function sendVerifyCode() {
		var param = {
			"funcNo": 700002,
			"ydkh_image_code": $(_pageId + " #imageCode").val(),
			"mobile": mobile,
			"uuid": uuidData.uuid
		};
		appUtils.invokeServer(global.serverPath, param, function(data) {
			if (data.error_no == "0") {
				layerUtils.iLoading(false);
				var countStr = data.results[0].mycodecount;
				imageCount = parseInt(countStr);
				isSendTicket = true;
				if (showVeirfyCode(data)) {
					showCountDown();
				}
			} else if (data.error_no == "2") {
				imageCount = 0;
				$(_pageId + " #image").attr("src", global.imageCode + "?mobile_no=" + mobile + "&r=" + Math.random());
				layerUtils.iMsg(-1, "请先输入图形验证码！");
				$(_pageId + " #imageDiv").show();
			} else {
				if ($(_pageId + " #imageDiv").css("display") == "none") {
					if (data.error_info == "验证码已过期，请刷新重新输入" || data.error_info == "图形验证码输入不正确") {
						$(_pageId + " #image").attr("src", global.imageCode + "?mobile_no=" + mobile + "&r=" + Math.random());
						$(_pageId + " #imageCode").val("");
						layerUtils.iMsg(-1, "请先输入图形验证码！");
						$(_pageId + " #imageDiv").show();
						$(_pageId + " #imageCode").val("");
					}
				} else {

					if (data.error_info == "验证码已过期，请刷新重新输入") {
						layerUtils.iAlert("图形验证码已过期，请重新输入", -1);
						$(_pageId + " #image").attr("src", global.imageCode + "?mobile_no=" + mobile + "&r=" + Math.random());
						$(_pageId + " #imageCode").val("");
						return;
					}
					layerUtils.iAlert(data.error_info, -1);
				}
			}
		});
		/*var mac = iBrowser.pc ? "02:00:5E:00:00:14" : "",
		 ip = iBrowser.pc ? "192.168.1.109" : "";
		 // 只有当不是 pc 时，才调用壳子获取 ip 和 mac
		 if (!iBrowser.pc) {
		 shellPlugin.callShellMethod("getIpMacPLugin", function(data) {
		 data = data.split("|");
		 mac = data[0];
		 ip = data[1];
		 }, null);
		 }
		 // 将 mac 和 ip 保存到 sessionStorage 里面
		 appUtils.setSStorageInfo("ip", ip);
		 appUtils.setSStorageInfo("mac", mac);*/
	}

	function showCountDown() {
		var sumTime = 120;
		// 设置 isSentCode 属性，true 表示已发送验证码，且验证码有效，false 为发送验证码，或者验证码无效
		$(_pageId + " .getmsg").attr("isSentCode", true);
		// 获取验证码之后按钮隐藏
		$(_pageId + " .getmsg").hide();
		// 显示倒计时
		$(_pageId + " .time").html("120&nbsp;秒后重发");
		$(_pageId + " .time").show();
		// 显示提示
		$(_pageId + " .cert_notice").show();
		startCountDown = window.setInterval(function() {
			$(_pageId + " .time").html(--sumTime + "&nbsp;秒后重发");
		}, 1000);
		// 120 秒之后清除计时器
		clearCountDown = window.setTimeout(function() {
			// 显示按钮
			$(_pageId + " .getmsg").show();
			// 隐藏倒计时
			$(_pageId + " .time").hide();
			$(_pageId + " .cert_notice").hide();
			window.clearInterval(startCountDown);
			// 设置 isSentCode 属性，true 表示已发送验证码，且验证码有效，false 为发送验证码，或者验证码无效
			$(_pageId + " .getmsg").attr("isSentCode", false);
		}, 120000);
	}

	// 回显验证码
	function showVeirfyCode(data) {
		// result 是 1 ，回显，否则不回显
		if (data.results.length != 0 && data.results[0].result == 1 && data.results[0].random.length > 2) {
			$(_pageId + " .mobileCode").val(data.results[0].random);
		}
		if (data.results.length != 0 && isNaN(data.results[0].random)) {
			layerUtils.iAlert(data.results[0].random);
			return false;
		}
		return true;
	}
	/*提交验证码*/
	function submitVerifyCode() {
		// 登录业务标准，新开户：0 转户：  1
		var login_flag = appUtils.getSStorageInfo("login_flag");
		var param = {
			"funcNo": 501521,
			"s_version": 2,
			"mobile_no": $(_pageId + " .phoneNum").val(),
			"mobile_code": $(_pageId + " .mobileCode").val(),
			// 	登录业务标准，新开户：0 转户：  1
			"login_flag": login_flag,
			"ouid":global.ouid,
			"aid": global.aid,
			"sid": global.sid,
			"channel_flag": global.ouid,
			"web_device": global.ouid,
			"h5RecommenderNoId" :recommenderNoId.recommenderNo+"-"+recommenderNoId.aid+"-"
			+recommenderNoId.sid+"-"+recommenderNoId.ouid,
			"app_platform":systemData.systemVersion+"-"+systemData.phoneNum+
			"-"+systemData.systemName+"-"+systemData.browser+"-"+systemData.screenSize+"-"
			+systemData.appVersion+"-"+systemData.h5Version+"-"+systemData.model+"-"+systemData.px+"-"+systemData.ownerId+"-"+systemData.sdkVersion
		};
		appUtils.invokeServer(global.serverPath, param, function(data) {

			if (data.error_no == "0" && data.results != "") {
				// 将 身份证号 和 移动电话 保存到 session 中，用来做设置密码时的弱密校验
				if (data.results[0].idno != undefined) {
					appUtils.setSStorageInfo("idCardNo", data.results[0].idno);
				}
				if (data.results[0].opacctkind_flag != undefined && data.results[0].opacctkind_flag != "") {
					appUtils.setSStorageInfo("login_flag", data.results[0].opacctkind_flag);
				}
				appUtils.setSStorageInfo("mobileNo", data.results[0].mobileno);

				// 将 clientinfo 和 jsessionid 两个参数保存到 session 中，用于解决壳子上传照片的权限问题
				appUtils.setSStorageInfo("clientinfo", data.results[0].clientinfo);
				appUtils.setSStorageInfo("jsessionid", data.results[0].jsessionid);
				//用于加密的iv
				appUtils.setSStorageInfo("aesKey",data.results[0].jsessionid.substr(data.results[0].jsessionid.length-16));
				appUtils.setSStorageInfo("aesIv",data.results[0].iv);

				// 将客户姓名保存到 session 中，用于在开户结果中做展示
				if (data.results[0].custname != undefined) {
					appUtils.setSStorageInfo("custname", data.results[0].custname);
				}
				//将密钥保存到session中，用于在sdk开户结果中做展示
				if (data.results[0].identityvalue != "") {
					appUtils.setSStorageInfo("identityvalue", data.results[0].identityvalue);
				}
				// 将 user_id 存到 session 中
				var userInfo = data.results[0];
				appUtils.setSStorageInfo("user_id", userInfo.user_id);
				var currentStep = userInfo["lastcomplete_step"];
				if (data.results[0].need_photo == 1) {
					appUtils.setSStorageInfo("needPhoto", data.results[0].need_photo);
					appUtils.pageInit("account/msgVerify", "account/uploadPhoto", {});
					return;
				}
				if (data.results[0].need_third_deposit == 1) {
					appUtils.setSStorageInfo("needThirdDeposit", data.results[0].need_third_deposit);
					appUtils.pageInit("account/msgVerify", "account/thirdDepository", {});
					return;
				} else if (appUtils.getSStorageInfo("needThirdDeposit")) {
					//清空sessionStorage缓存
					appUtils.setSStorageInfo("needThirdDeposit", "");
				}
				var pageCode = "";
				if (currentStep && currentStep.length > 0) {
					if(currentStep=="visitsurvey" && appUtils.getSStorageInfo("login_flag")=="1"&&appUtils.getSStorageInfo("zh_video")==0){
						pageCode = "certintall";
						pageCode = stepMap[pageCode];
					} else {
						var index = steps.indexOf(currentStep);
						if (index < (steps.length - 1)) {
							currentStep = steps[index + 1];
						}
						pageCode = stepMap[currentStep];
					}
				}
				if (pageCode && pageCode.length > 0) {
					if(pageCode == "account/accountResult"){
						publicMethod.openAccountResult("account/msgVerify");
					}else{
						appUtils.pageInit("account/msgVerify", pageCode, {});
					}
				} else {
					appUtils.pageInit("account/msgVerify", "account/uploadPhoto", {});
				}
			} else {
				if(data.error_info != ""){
					layerUtils.iAlert(data.error_info);
				}else if(data.error_info == ""){
					layerUtils.iAlert("服务器异常，请稍候重试！",-1);
				}
				if(data.error_info == "您的申请已经处理完成！" || data.error_info == "您的新开户申请在审批中，请不要进行其他操作！"){
					$(_pageId + " #imageCode").val("");
					$(_pageId + " #mobildCode").val("");
				}
				return;
			}
		});
	}

	function getAccountResultLink(){

		$.ajax({
			type: "GET",
			url: global.serverPath + '?funcNo=700017&channel_name=jyappkh',
			dataType: "json",
			success: function(data) {
				if(data && data.results[0]){
					var targetUrl = global.serverPath.substring(0,global.serverPath.length-13)+ data.results[0].resultUrl;
					appUtils.setSStorageInfo("accountResultPage",targetUrl);
					//预加载结果页
					setTimeout(function() {
						var lastOpenTime = 0;
						var nowTime = (new Date()).getTime();
						try {
							lastOpenTime = sessionStorage.getItem('pageOpenTime');
						} catch (e) {
							console.log(e)
						}

						if (lastOpenTime > 0 && (nowTime - lastOpenTime < 0.5 * 3600 * 1000)) {
							// 3小时打开一次iframe
							return;
						}

						var iframe = $('<iframe>').css('display', 'none');
						iframe
							.attr('src', targetUrl)
							.appendTo(document.body);
						try {
							appUtils.setSStorageInfo("pageOpenTime", nowTime);
						} catch (e) {}
					}, 200);
				}
			}
		})
	}

	var msgVerify = {
		"init": init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = msgVerify;
});