﻿/**
 * 新开户(转户)须知
 */
define("project/scripts/account/openAccount", function(require, exports, module) {
	var appUtils = require("appUtils"),
		shellPlugin = require("shellPlugin"),
		talkingdata=require("talkingdata"),
		publicMethod=require("PublicMethod"),
		gconfig = require("gconfig"),
		global = gconfig.global,
		currVersion = null, // 当前版本号
		layerUtils = require("layerUtils"),
		utils = require("utils"),
		imagesPath = gconfig.imagesPath,
		exceptBankId = ["5001", "5002", "12", "7", "2"],
		exceptBankName = ["上海银行", "兴业银行", "招商银行", "建设银行"],
		_pageId = "#account_openAccount";
	var uuiqueIdData = "";
	function init() {
		// 解决 iPhone 4 和 iPhone 4s 页面不在一屏的问题
		if ($(document).height() > $(window).height()) {
			$(_pageId + " .ness_box").css("padding", "10px");
			$(_pageId + " .main").css("padding-bottom", "5px");
		}
		if (appUtils.getSStorageInfo("login_flag") == "1") {
			$(_pageId + " .timeZhuyi").hide();
		} else {
			$(_pageId + " .timeZhuyi").show();
		}
		//埋点
		if(appUtils.getSStorageInfo("login_flag") == "0") {
			talkingdata.record("OPENACCOUNT", "OPENACCOUNT_0401");
		} else if(appUtils.getSStorageInfo("login_flag") == "1") {
			talkingdata.record("OPENACCOUNT_05", "OPENACCOUNT_0501");
		}
	}
	//公告弹窗
	function showAds() {
		$.ajax({
			type: "get",
			async: false,
			//url : "http://sis-pa18-content.paic.com.cn/main/huodong/khgg/khad.jsonp",  //生产
			url: "http://10.25.153.175:30088/main/huodong/khgg/khad.jsonp", //FAT
			dataType: "jsonp",
			jsonp: "callback",
			jsonpCallback: "getAd",
			success: function(ads) {
				if (ads) {
					var endFlag = true;
					if (ads.endDate != "") {
						var endDateT = ads.endDate.replace(/-/g, "/");
						var currDate = new Date();
						var endDate = new Date(endDateT);
						if (endDate < currDate) {
							endFlag = false;
						}
					}
					//在日期范围内，且包含当前渠道channel：5：app 6：pc  7.保单app 8.新开web 9.保单web
					var channelArr = ads.channel.split(",");
					if (jQuery.inArray("5", channelArr) != -1 && endFlag) {
						var adsContent = "<div id='adsContent' style='padding:0 20px;color:#ccc;'>" + ads.content + "<div style='text-align:right;margin-top:10px;'>" + ads.footer + "</div></div>";
						layerUtils.iAlert(ads.title + adsContent, '', '', "知道了");
						var resetCss = setInterval(function() {
							if ($("#adsContent").length > 0) {
								if ($("#adsContent").height() > 66) {
									$("#adsContent").css("text-align", "left");
								}
								clearInterval(resetCss);
							}
						}, 10);
					}
				}
			}
		});
	}

	function bindPageEvent() {
		// 绑定FAQ常见问题按钮
		publicMethod.bindProblemEvent(_pageId);

		appUtils.bindEvent($(_pageId), function() {
			$(_pageId + " .header_icon").hide();
		});

		appUtils.bindEvent($(_pageId + " #a_setting"), function(event) {
			$(_pageId + " .header_icon").toggle();
			event.stopPropagation();
		});

		appUtils.bindEvent($(_pageId + " #a_phone"), function() {
			utils.callKHRXPhone("4000-188-288");
			//埋点
			if(appUtils.getSStorageInfo("login_flag") == "0") {
				talkingdata.record("OPENACCOUNT", "OPENACCOUNT_0402");
			} else if(appUtils.getSStorageInfo("login_flag") == "1") {
				talkingdata.record("OPENACCOUNT_05", "OPENACCOUNT_0502");
			}
		});

		appUtils.bindEvent($(_pageId + " #recommenderInfo"), function() {

			shellPlugin.callShellMethod("recommenderPlugin", null, null, null);

		});

		appUtils.bindEvent($(_pageId + " .header .icon_back"), function() {
			shellPlugin.callShellMethod("showDoorPlugin", null, null, null);
			appUtils.pageBack();
			//埋点
			if(appUtils.getSStorageInfo("login_flag") == "0") {
				talkingdata.record("OPENACCOUNT", "OPENACCOUNT_0404");
			}  else if(appUtils.getSStorageInfo("login_flag") == "1") {
				talkingdata.record("OPENACCOUNT_05", "OPENACCOUNT_0504");
			}
		});

		appUtils.bindEvent($(_pageId + " .fix_bot .ct_btn"), function() {
			appUtils.pageInit("account/openAccount", "account/msgVerify", {});
			//埋点
			if(appUtils.getSStorageInfo("login_flag") == "0") {
				talkingdata.record("OPENACCOUNT", "OPENACCOUNT_0405");
			}  else if(appUtils.getSStorageInfo("login_flag") == "1") {
				talkingdata.record("OPENACCOUNT_05", "OPENACCOUNT_0505");
			}
		});
		appUtils.bindEvent($(_pageId + " #query_a"), function() {
			appUtils.pageInit("account/openAccount", "account/bankList", {});
		});

		//小安机器人
		publicMethod.bindXiaoAnEvent(_pageId,false);

	}

	function destroy() {}

	var openAccount = {
		"init": init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};

	module.exports = openAccount;
});