/**
* 风险测评
*/
define("project/scripts/account/riskAssessment",function(require,exports,module){
	var appUtils = require("appUtils"),
		global = require("gconfig").global,
		layerUtils = require("layerUtils"),
		Map = require("map"),
		utils = require("utils"),
		shellPlugin = require("shellPlugin"),
		talkingdata = require("talkingdata"),
		publicMethod=require("PublicMethod"),
		fristMap = null,
		_pageId = "#account_riskAssessment";
	
	function init(){
		fristMap = new Map();
		getRiskAssessQuestions();
		//埋点
		talkingdata.record("RISKASSESSMENT", "RISKASSESSMENT_1201");
	}
	function bindPageEvent(){
	
		// 绑定FAQ常见问题按钮
		publicMethod.bindProblemEvent(_pageId);

		appUtils.bindEvent($(_pageId),function(){
			$(_pageId+" .header_icon").hide();
		});
		
		appUtils.bindEvent($(_pageId+" #a_setting"),function(event){
			$(_pageId+" .header_icon").toggle();
			event.stopPropagation();
		});
		
		appUtils.bindEvent($(_pageId+" #a_phone"),function(){
			utils.callKHRXPhone("4000-188-288");
			//埋点
			talkingdata.record("RISKASSESSMENT", "RISKASSESSMENT_1202");
		});
		
		appUtils.bindEvent($(_pageId+" #recommenderInfo"),function(){
			
			shellPlugin.callShellMethod("recommenderPlugin", null,null,null);
			
		});
		
		
		appUtils.bindEvent($(_pageId+" .header .icon_back"),function(){
			appUtils.pageBack();
		});
		
		appUtils.bindEvent($(_pageId+" .fix_bot .ct_btn"),function(){
			postAnswers();
			//埋点
			talkingdata.record("RISKASSESSMENT", "RISKASSESSMENT_1205");
		});
		//小安机器人
		publicMethod.bindXiaoAnEvent(_pageId,true);
	}
	function getRiskAssessQuestions(){
		var getRiskQueParam = {
				"funcNo" : 1001008,
				"userid" : appUtils.getSStorageInfo("user_id"),
				"clientinfo" : appUtils.getSStorageInfo("clientinfo"),
				"jsessionid" : appUtils.getSStorageInfo("jsessionid")
			};
		appUtils.invokeServer(global.serverPath,getRiskQueParam,function(data){
			if(data.error_no == 0)	
			{
				var questions = data.results[0].questions,
					questionHtml = "";
				$(_pageId+" .test_main").html("");
				questions = JSON.parse(questions);
				for(var i =0; i<questions.length; i++)
				{
					var oneQuestion = {
							"question_no" : questions[i].question_no,
							"question_desc" : questions[i].question_desc,
							"answers" : questions[i].answers,
							"opt" : questions[i].opt
						};
					fristMap.put("question"+i, oneQuestion);	
				}
				
				var keys = fristMap.keys();
				for(var i=0; i<keys.length; i++)
				{
					var currentQuestion = fristMap.get(keys[i]);
					var opt = currentQuestion.opt;
					var opt_name;
					if(opt=="0")
					{
						opt_name="单选";	
					}
					else
					{
						opt_name="多选";
					}
					questionHtml += "<div class=\"test_box\" question-id=\"question"+i+"\"><h5>"+(i+1)+"、"+
						currentQuestion.question_desc+"("+opt_name+")</h5>";
						questionHtml += createQuestionAnswers(currentQuestion,opt);
						questionHtml += "</div>";
				}
				$(_pageId+" .test_main").html(questionHtml);
				appUtils.bindEvent($(_pageId+" .input_list p a"),function(){
					var opt_m = $(this).attr("opt_n");
					if(opt_m=="0")
					{
						$(this).parent("p").siblings().children("a").removeClass("checked");
						$(this).toggleClass("checked");
					}
					else
					{
						$(this).toggleClass("checked");
					}
					//埋点
					talkingdata.record("RISKASSESSMENT", "RISKASSESSMENT_1204");
				});
				setDefaultAnswer();
			}
			else
			{
				layerUtils.iAlert(data.error_info);
			}
		});
	}
	
	function setDefaultAnswer()
	{
		// 获取所有问题的集合
		var questionList = $(_pageId+" .input_list");
		// 处理每一个问题
		questionList.each(
			function(){
				var scoreArray = new Array(),
					currentScore = "";
				for(var i=0;i<$(this).children("p").length;i++)
				{
					currentScore = Number($(this).children("p").eq(i).children("a").attr("answer-score"));
					scoreArray.push(currentScore);
				}
				// js 的 sort 方法是在原数组的基础上进行排序，不会生成副本，按数值升序
				scoreArray.sort(function(a,b){
					return a - b;
				});
					$(".test_box").each(function(index){
					$(this).find(".input_list").each(function(indexj){
						$(this).find("p").each(function(indexk){
							if(indexk == 0){
								$(this).find("a").addClass("checked");
							}
						});
					
					});
				});
			}
		);
	}
	
	function createQuestionAnswers(currentQuestion,opt_n)
	{
		var answers = currentQuestion.answers,
    		oneElementStr = "<div class=\"input_list\">";
    	for(var i = 0 ; i < answers.length ; i++)
    	{
    		var answerNo = "";
    		switch(i)
    		{
    			case 0 : answerNo = "A";break;
    			case 1 : answerNo = "B";break;
    			case 2 : answerNo = "C";break;
    			case 3 : answerNo = "D";break;
    			case 4 : answerNo = "E";break;
    			case 5 : answerNo = "F";break;
    		}
    		oneElementStr += "<p><a href=\"javascript:void(0);\" class=\"icon_radio\" opt_n=\""+opt_n+"\" answer-score=\""+answers[i].answers_score+"\">"
	    		+answerNo+"、"+answers[i].answers_desc+"</a></p>";
    	}
    	oneElementStr += "</div>";
    	return oneElementStr;
	}
	
	function postAnswers()
	{
		var answersValStr = "";
			questionsArray = $(_pageId+" .input_list");
		var	answeredSum=0;
		var answersValStr1 = "";
		$(".test_box").each(function(index){
					$(this).find(".input_list").each(function(indexj){
						$(this).find("p").each(function(indexk){
							$(this).find("a").each(function(indexl){
								var  classstr=$(this).attr("class");
								if(classstr == 'icon_radio checked' ){
									if($(this).attr("opt_n")==1){
										answersValStr1  +=$(this).attr("answer-score")+",";
										answeredSum++;
									}else{
										answersValStr1  +=$(this).attr("answer-score");
									 	answeredSum++;
									}
									
								}
							});
						});
					});
					
					answersValStr1 +=';';
					answersValStr = answersValStr + answersValStr1;
					answersValStr1 = "";
					
				});
		var submitAnswersParam = {
				"funcNo" : 1001009,
				"rating_value" : answersValStr,
				"userid" : appUtils.getSStorageInfo("user_id"),
				"clientinfo" : appUtils.getSStorageInfo("clientinfo"),
				"jsessionid" : appUtils.getSStorageInfo("jsessionid")
			};
		
		var questionNum = true;
		
		$(".test_box").each(function(index){
					$(this).find(".input_list").each(function(indexj){
						var i = 0; var t = 0;
						$(this).find("p").each(function(indexk){
							$(this).find("a").each(function(indexm){
								i++;
								if($(this).hasClass("checked")){
									t=i;
								}
							});
							
						});
							if(t==0){
								layerUtils.iAlert("请完成所有的题目！");
								questionNum = false;
							}
					});
				});	
		
//		if(answeredSum < questionsArray.length)
//		{
			
//		}
		if(questionNum){
			appUtils.invokeServer(global.serverPath,submitAnswersParam,function(data){
				if(data.error_no == 0)
				{
					appUtils.pageInit("account/riskAssessment","account/openConfirm",{});
				}
				else
				{
					layerUtils.iAlert(data.error_info);
				}
			});
		}
	}
	
	function destroy(){
		
	}
	
	var riskAssessment = {
		"init" : init,
		"bindPageEvent" : bindPageEvent,
		"destroy" : destroy
	};
	
	module.exports = riskAssessment;
});