/**
 * 查看数字证书的协议
 */
define("project/scripts/account/showDigitalProtocol",function(require, exports, module){ 
	var appUtils = require("appUtils"),
		global = require("gconfig").global,
		layerUtils = require("layerUtils"),
		shellPlugin = require("shellPlugin"),
		publicMethod=require("PublicMethod"),
		utils = require("utils"),
		_pageId = "#account_showDigitalProtocol";
	
	function init()
	{
		// 查询证书内容
		var param = {
				"funcNo" : "501524",
				"protocol_id" : appUtils.getPageParam("protocolId"),
				"clientinfo" : appUtils.getSStorageInfo("clientinfo"),
				"jsessionid" : appUtils.getSStorageInfo("jsessionid")
		};
		// 设置协议标题
		$(_pageId+" .top_title h3").text("");
		// 清空协议内容
		$(_pageId+" .upload_main #contenttxt").text("");
		appUtils.invokeServer(global.serverPath,param,function(data){
			// 设置协议标题
			$(_pageId+" .top_title h3").text(data.results[0].protocol_name);
			$(_pageId+" .upload_main #contenttxt").append(data.results[0].contenthtml);
		});
	}
	
	function bindPageEvent()
	{
		// 绑定FAQ常见问题按钮
		publicMethod.bindProblemEvent(_pageId);

		appUtils.bindEvent($(_pageId),function(){
			$(_pageId+" .header_icon").hide();
		});
		
		appUtils.bindEvent($(_pageId+" #a_setting"),function(event){
			$(_pageId+" .header_icon").toggle();
			event.stopPropagation();
		});
		
		appUtils.bindEvent($(_pageId+" #a_phone"),function(){
			utils.callKHRXPhone("4000-188-288");
		});
		
		appUtils.bindEvent($(_pageId+" #recommenderInfo"),function(){
			
			shellPlugin.callShellMethod("recommenderPlugin", null,null,null);
			
		});
	
		/* 绑定返回 */
		appUtils.bindEvent($(_pageId+" .header .icon_back"),function(){
			appUtils.pageBack();
		});
		/* 绑定下一步 */
		appUtils.bindEvent($(_pageId+" .fix_bot .ct_btn"),function(){
			appUtils.pageBack();
		});
	}
	
	function destroy()
	{
		// 将协议内容置空
		$(_pageId+" #contenttxt").text("");
	}
	
	var showDigitalProtocol = {
		"init" : init,
		"bindPageEvent" : bindPageEvent,
		"destroy" : destroy
	};
	
	module.exports = showDigitalProtocol;
});