/**
 * 三方存管
 */
define("project/scripts/account/thirdDepository", function(require, exports, module) {
    var appUtils = require("appUtils"),
        global = require("gconfig").global,
        layerUtils = require("layerUtils"),
        validatorUtil = require("validatorUtil"),
        shellPlugin = require("shellPlugin"),
        talkingdata = require("talkingdata"),
        publicMethod = require("PublicMethod"),
        utils = require("utils"),
        layer = require("layer"),
        zzispwd = 1,
        _pageId = "#account_thirdDepository";
    var unvalidBankNo;
    var unvalidBankTime = 0;
    var text_prompt = " ";
    var otherBanks = [];
    function init() {
        window.getInput = getInput;
        var mobiletips = "";
        //从本地存储中或者名称
        var userName = '';
        if(sessionStorage.getItem("userName")){
            userName = sessionStorage.getItem("userName");
        }else if(sessionStorage.getItem("custname")){
            userName = sessionStorage.getItem("custname")
        }
        $(_pageId + " #thisTips").html("绑定的银行卡必须为您本人<strong>\""+userName+"\"</strong>的<strong>借记卡</strong>");
        getBankList();
        sixBankList();
        $(_pageId + " #bankcardPwd").removeAttr("readonly");
        //埋点
        talkingdata.record("THIRDDEPOSITORY", "THIRDDEPOSITORY_1101");
    }

    function bindPageEvent() {
        // 绑定FAQ常见问题按钮
        publicMethod.bindProblemEvent(_pageId);

        appUtils.bindEvent($(_pageId), function() {
            $(_pageId + " .header_icon").hide();
            // 隐藏银行下拉列表
            $(_pageId + " #bankListPage").slideUp("fast");
        });

        appUtils.bindEvent($(_pageId + " #a_setting"), function(event) {
            $(_pageId + " .header_icon").toggle();
            // 隐藏银行下拉列表
            $(_pageId + " #bankListPage").slideUp("fast");
            event.stopPropagation();
        });

        appUtils.bindEvent($(_pageId + " #a_phone"), function() {
            utils.callKHRXPhone("4000-188-288");
            //埋点
            talkingdata.record("THIRDDEPOSITORY", "THIRDDEPOSITORY_1102");
        });

        appUtils.bindEvent($(_pageId + " #recommenderInfo"), function() {

            shellPlugin.callShellMethod("recommenderPlugin", null, null, null);

        });
        appUtils.bindEvent($(_pageId + " .header .icon_back"), function() {
            appUtils.pageBack();
        });

        appUtils.bindEvent($(_pageId + " #bankcardPwd"), function() {
            utils.dealIPhoneMaxLength(this, 6);
        }, "input");

        appUtils.bindEvent($(_pageId + " #bankcard"), function() {
            utils.dealIPhoneMaxLength(this, 21);
            utils.showBigNo(this, 2);
        }, "input");

        appUtils.bindEvent($(_pageId + " #bankcard"), function() {
            utils.showBigNo(this, 2);
        }, "focus");

        appUtils.bindEvent($(_pageId + " .header .icon_back"), function() {
            appUtils.pageBack();
        });

        // 限制只能输入数字
        appUtils.bindEvent($(_pageId + " #bankcardPwd"), function() {
            var regNum = /^[0-9]*$/,
                pwd = $(this).val();
            // 如果不是数字，禁止输入
            if (!regNum.test(pwd)) {
                $(this).val(pwd.substring(0, pwd.length - 1));
            }
        }, "input");

        appUtils.bindEvent($(_pageId + " #bankcardPwd"), function() {
            layer.closeAll();
        }, "focus");

        // 签署《券商银行投资者三方协议》
        appUtils.bindEvent($(_pageId + " .rule_check a"), function() {
            $(this).toggleClass("checked");
            //埋点
            talkingdata.record("THIRDDEPOSITORY", "THIRDDEPOSITORY_1106");
        });

        // 选择银行绑定事件显示银行列表
        appUtils.bindEvent($(_pageId + " #selectBank"), function(e) {
            if ($(_pageId + " #bankListPage ul li").length == 0) {
                getBankList();
            }
            // 显示银行下拉列表
            //$(_pageId+" #bankListPage").slideDown("fast");
            //新修改begin
            // 显示银行下拉列表，固定填充建行，工行，阻止显示下拉列表
            if (global.orgnizationNo == "") {
                $(_pageId + " #bankListPage").slideDown("fast");
            } //新修改end

            $(_pageId + " .header_icon").hide();
            // 阻止冒泡
            e.stopPropagation();
        });

        // 银行卡绑定选择银行验证
        appUtils.bindEvent($(_pageId + " #bankcard"), function() {
            validateSelectBank();
            //埋点
            talkingdata.record("THIRDDEPOSITORY", "THIRDDEPOSITORY_1104");
        });

        // 银行卡密码绑定选择银行验证
        appUtils.bindEvent($(_pageId + " #bankcardPwd"), function() {
            validateSelectBank();
            //埋点
            talkingdata.record("THIRDDEPOSITORY", "THIRDDEPOSITORY_1105");
        });

        //开通三方存管按钮绑定事件
        appUtils.bindEvent($(_pageId + " .ct_btn"), function() {
            // 关闭提示层
            layer.closeAll();
            postThirdDepositoryData();
            //埋点
            talkingdata.record("THIRDDEPOSITORY", "THIRDDEPOSITORY_1107");
        });

        //小安机器人
        publicMethod.bindXiaoAnEvent(_pageId,true);
    }
    function sixBankList(){
        var sixBankParam = {
            "funcNo" : 501505,
            "enum_type" : "sfcgdesc"
        };
        appUtils.invokeServer(global.serverPath, sixBankParam, function(data) {
            text_prompt = data;
            if (data.error_no == 0){
                text_prompt = data.results[0].item_value;
            } else {
                layerUtils.iAlert(data.error_info, -1) ;
            }
        });
    }

    function destroy() {
        // 清空密码框
        $(_pageId + " #bankcardPwd").val("");
        //签署协议取消选中
        //		$(_pageId+" .rule_check a").removeClass("checked");
    }

    // 对外暴露的模块方法 end

    //为选择银行列表添加选中银行数据
    /**
     *
     */
    function addBankItem(banckName, organizationNo, bindtype, bankId, mobiletips) {
        $(_pageId + " #selectBank").html(banckName);
        $(_pageId + " #selectBank").attr("bind-type", bindtype);
        $(_pageId + " #selectBank").attr("organization-no", organizationNo);
        $(_pageId + " #selectBank").attr("bank-id", bankId);
        $(_pageId + " #mobiletips").html(mobiletips);
        if (mobiletips.length > 0) {
            $(_pageId + " #span_tishi").show();
        } else {
            $(_pageId + " #span_tishi").hide();
        }
        // 获取银行协议内容
        getDepositoryAgreement(organizationNo);
        var organizationNoTemp;
        var signRuleTemp;
        if (global.orgnizationNo != "") {
            for (var i = 0; i < bankList.length; i++) {
                // 0 一步式，1 两步式
                signRuleTemp = bankList[i].signrule,
                    organizationNoTemp = bankList[i].ext_org;
                if (global.orgnizationNo == organizationNoTemp) {
                    zzispwd = signRuleTemp;
                    break;
                }
            }
        }

        // 0 不需要密码，1 需要密码，2 电话银行密码
        if (zzispwd == 0) {
            // 隐藏银行密码输入框
            $(_pageId + " #bankcardPwd").parent().hide();
        } else if (zzispwd == 1) {
            // 显示银行密码输入框
            $(_pageId + " #bankcardPwd").parent().show();
            $(_pageId + " #bankcardPwd").attr("placeholder", "请输入银行密码");
            $(_pageId + " #bankcardPwd").parent().find("span").html("银行密码");
            $(_pageId + " .user_form .input_form strong").css("margin-left", "0px");
            $(_pageId + " .user_form .input_form input").css("margin-left", "0px");
            $(_pageId + " .user_form .input_form span").css("width", "80px");
        } else if (zzispwd == 2) {
            // 显示银行密码输入框
            $(_pageId + " #bankcardPwd").parent().show();
            $(_pageId + " #bankcardPwd").attr("placeholder", "请输入电话银行密码");
            $(_pageId + " #bankcardPwd").parent().find("span").html("电话银行密码");
            $(_pageId + " .user_form .input_form strong").css("margin-left", "20px");
            $(_pageId + " .user_form .input_form input").css("margin-left", "20px");
            $(_pageId + " .user_form .input_form span").css("width", "100px");
        }
        bankListSelect();
    }

    function bankListSelect(){
        $(_pageId + " #bankListPage").slideUp("fast");
        var bankLinkNo = $(_pageId + " #selectBank").attr("organization-no");
        if(appUtils.getSStorageInfo("login_flag") == "1") {
            for(var i=0;i<otherBanks.length;i++){
                var bank_num = otherBanks[i];
                if(bank_num.ext_org && bankLinkNo == bank_num.ext_org){
                    layerUtils.iConfirm(text_prompt, null, null, "确认", "取消");
                    break;
                }
            }
        }
    }

    function validateSelectBank() {
        var obj = $(_pageId + " #selectBank"),
            value = obj.html();
        if (validatorUtil.isEmpty(value) || value == "请选择银行") {
            //请选择银行
            layerUtils.iMsg(-1, "请选择银行");
            return false;
        } else {
            appUtils.bindEvent($(_pageId + " #bankcard"), function() {
                var bankCardNo = $(this).val();
                if (bankCardNo) {
                    validateBankCorrect();
                }
            }, "blur");
            return true;
        }
    }

    /**
     * 检验银行卡填写是否正确
     */
    function validateBankCorrect() {
        var bankCardNo = $(_pageId + " #bankcard").val();
        if (bankCardNo == "") {
            layerUtils.iMsg(-1, "银行卡号不能为空!");
            return false;
        }
        if (!validatorUtil.isNumeric(bankCardNo)) {
            layerUtils.iMsg(-1, "银行卡号格式不正确!");
            return false;
        }
        return true;
    }

    /**
     * 银行卡号校验
     */
    function checkCardId(){
        var bankcard = $(_pageId + " #bankcard").val().replace(/\s*/g, "");
        var checkCardParam={
            "funcNo": 700016,
            "bankNo":bankcard,
            "bankid":$(_pageId + " #selectBank").attr("bank-id"),
            "luhn": 1,
            "bin": 1
        }
        appUtils.invokeServer(global.serverPath, checkCardParam, function(data) {
            if (data.error_no == 0) {
                if (unvalidBankNo != bankcard) {
                    unvalidBankTime = 0;
                }
                if(data.results[0].flag == 0){
                    bindBankCard();
                } else if(data.results[0].flag == 1){
                    if (unvalidBankTime < 2) {
                        layerUtils.iAlert("您的银行卡号填写错误，不符合三方存管绑卡要求，建议换用其他银行卡");
                        unvalidBankNo = bankcard;
                        unvalidBankTime++;
                        return;
                    }else {
                        layerUtils.iConfirm("您的银行卡号填写错误，不符合三方存管绑卡要求，建议换用其他银行卡", function() {
                            bindBankCard();
                        }, null, "确认不改", "返回修改");
                    }
                }else if(data.results[0].flag == 2){
                    bankNumValidate = false;
                    if (unvalidBankTime < 2) {
                        layerUtils.iMsg(-1, "您的卡号填写错误，请重新填写");
                        unvalidBankNo = bankcard;
                        unvalidBankTime++;

                        return;
                    } else {
                        layerUtils.iConfirm("您的卡号填写错误，请重新填写", function() {
                            bindBankCard();
                        }, null, "确认不改", "返回修改");
                    }
                }else{
                    if (unvalidBankTime < 2) {
                        layerUtils.iAlert("您的银行卡号不符合三方存管绑卡要求，建议换用其他银行卡");
                        unvalidBankNo = bankcard;
                        unvalidBankTime++;
                    }else{
                        layerUtils.iConfirm("您的银行卡号不符合三方存管绑卡要求，建议换用其他银行卡", function() {
                            bindBankCard();
                        }, null, "确认不改", "返回修改");
                    }
                }
            }
        });

    }

    /**
     * 验证银行密码
     */
    function validateBankPwd() {
        //验证不通过
        var cardPwd = $(_pageId + " #bankcardPwd").val();
        if (!validatorUtil.isNumeric(cardPwd) || cardPwd.length != 6) {
            layerUtils.iMsg(-1, "您输入的密码有误，请重新输入!");
            return false;
        }
        return true;
    }

    function validateDepositProtocolSelect() {
        if (!$(_pageId + " .icon_check").hasClass("checked")) {
            layerUtils.iMsg(-1, "请阅读并勾选三方存管协议!");
            return false;
        }
        return true;
    }

    function getBankList() {
        var getBankListParam = {
            "funcNo": 1001002,
            "userid": appUtils.getSStorageInfo("user_id"),
            "clientinfo": appUtils.getSStorageInfo("clientinfo"),
            "jsessionid": appUtils.getSStorageInfo("jsessionid")
        };
        //if (appUtils.getSStorageInfo("login_flag") == "1") {
        //    getBankListParam.opacctkind_flag = 1;
        //}
        appUtils.invokeServer(global.serverPath, getBankListParam, function(data) {
            //清除页面的银行列表
            $(_pageId + " #bankListPage").html("");
            if (data.error_no == 0) //调用成功
            {
                var newBankListParam = getBankListParam;
                newBankListParam.opacctkind_flag = 1;
                setDiffBankList(newBankListParam,data,function(data){
                    getBankListSuccess(data);
                });

            } else {
                layerUtils.iAlert(data.error_info, -1);
            }
        });
    }

    //计算新开户和允许一人多户银行的差值集合
    function setDiffBankList(param,allList,callBack){

        appUtils.invokeServer(global.serverPath, param, function(datas) {
            if (datas.error_no == 0) //调用成功
            {
                var onePersonBanks = datas.results;
                var allBanks = allList.results.concat();
                for(var i=0;i<onePersonBanks.length;i++){
                    var targetBank = onePersonBanks[i];
                    for(var j=0;j<allBanks.length;j++){
                        var allTargetBank = allBanks[j];
                        if(allTargetBank.ext_org == targetBank.ext_org){
                            allBanks.splice(j,1);
                            break;
                        }
                    }
                }
                otherBanks = allBanks;
                callBack(allList);
            } else {
                layerUtils.iAlert(datas.error_info, -1);
            }
        })
    }


    var bankList;

    function getBankListSuccess(data) {
        var results = data.results,
            itemElement = "<ul>";
        bankList = results;
        for (var i = 0; i < results.length; i++) {
            var bankId = results[i].id,
                bankname = results[i].bankname,
                signRule = results[i].signrule,
            // 0 一步式，1 两步式
                bindtype = results[i].openacct,
            // 机构代码
                organizationNo = results[i].ext_org,
            // 银行带出的提示
                mobiletips = results[i].mobiletips;

            itemElement += "<li><span bank-id='" + bankId + "' organization-no='" + organizationNo + "' " +
            "bindtype=\"" + bindtype + "\"" + "mobiletips=\"" + mobiletips + "\"" +
            "sign-rule=\"" + signRule + "\">" + bankname + "</span></li>";
            //新修改begin
            //填充表单为建行 bankId = 2; bankName = 中国建设银行; organizationNo = 5000;
            //工行 bankId = 1; bankName = 中国工商银行； organizationNo = 5200;
            if (global.orgnizationNo != "") {
                if (global.orgnizationNo == organizationNo) {
                    addBankItem(bankname, organizationNo, bindtype, bankId, mobiletips);
                }
            } //新修改end
        }
        itemElement += "</ul>";
        $(_pageId + " #bankListPage").html(itemElement);
        // 选择银行添加银行事件
        appUtils.bindEvent($(_pageId + " #bankListPage ul li span"), function(e) {
            var banckName = $(this).text(),
                organizationNo = $(this).attr("organization-no"),
                bindtype = $(this).attr("bindtype"),
                bankId = $(this).attr("bank-id"),
                signRule = $(this).attr("sign-rule"),
                mobiletips = $(this).attr("mobiletips");
            // 0 不需要密码，1 需要密码，2 电话银行密码
            zzispwd = signRule;
            addBankItem(banckName, organizationNo, bindtype, bankId, mobiletips);
            e.stopPropagation();
        });
    }

    /**
     * 获取存管银行签约电子协议列表 接口号 501537
     */
    function getDepositoryAgreement(organizationNo) {
        // 获取银行协议的参数
        var protocolParam = {
            "funcNo": 501537,
            "bank_code": organizationNo,
            "clientinfo": appUtils.getSStorageInfo("clientinfo"),
            "jsessionid": appUtils.getSStorageInfo("jsessionid")
        };
        appUtils.invokeServer(global.serverPath, protocolParam, function(data) {
            $(_pageId + " #protocolName").html("");
            if (data.error_no == 0) {
                if (data.results.length > 0) {
                    //若为交行，显示交通银行三方存管协议及确认函
                    if (organizationNo == '5400') {
                        $(_pageId + " #protocolName").html("《" + data.results[0].protocol_name + "三方存管协议及确认函》");
                    } else {
                        $(_pageId + " #protocolName").html("《" + data.results[0].protocol_name + "三方存管协议》");
                    }
                    $(_pageId + " #protocolName").attr("protocolId", data.results[0].protocol_id);
                    $(_pageId + " #protocolName").attr("protocolMd5", data.results[0].protocol_md5);
                    // 预绑定查看银行协议内容的事件
                    appUtils.bindEvent($(_pageId + " #protocolName"), function(e) {
                        appUtils.pageInit("account/thirdDepository", "account/showProtocol", {
                            "protocol_id": $(_pageId + " #protocolName").attr("protocolId")
                        });
                        // 阻止冒泡
                        e.stopPropagation();
                    });
                }
            } else if (data.error_no != 0) {
                layerUtils.iAlert(data.error_info, -1);
            }
        });
    }

    function postThirdDepositoryData() {
        // 切页面之前触发 blur 事件，确保提示消失
        $(_pageId + " #bankcard").blur();
        var bankName = $(_pageId + " #selectBank").html(),
            bankcard = $(_pageId + " #bankcard").val().replace(/\s*/g, ""),
            bankcardPwd = $(_pageId + " #bankcardPwd").val();
        if ((validatorUtil.isEmpty(bankName) || bankName == "请选择银行") && bankcard == "" && (!validatorUtil.isNumeric(bankcardPwd) || bankcardPwd.length != 6)) {
            layerUtils.iMsg(-1, "您尚未完成三方存管信息填写!");
            return;
        }
        //验证是否全部通过
        if (!validateBankCorrect() || !validateSelectBank() || !validateDepositProtocolSelect()) {
            return;
        }

        //判断银行卡位数
        if (bankcard.length < 11 || bankcard.length > 21) {
            layerUtils.iMsg(-1, "银行卡号长度必须在11-21位，请重新填写!");
            return;
        }
        var postServer = function() {
            var verifyBankNoParam = {
                "funcNo": 1001003,
                "bankNo": bankcard.substring(0, 6),
                "bankid": $(_pageId + " #selectBank").attr("bank-id"),
                "userid": appUtils.getSStorageInfo("user_id"),
                "clientinfo": appUtils.getSStorageInfo("clientinfo"),
                "jsessionid": appUtils.getSStorageInfo("jsessionid")
            };
            appUtils.invokeServer(global.serverPath, verifyBankNoParam, function(data) {
                if (data.error_no == 0) {
                    if (data.results[0].flag != 0) {
                        layerUtils.iLoading(false);
                        layerUtils.iAlert("您输入的不是" + $(_pageId + " #selectBank").text() + "的银行卡！");
                    } else {
                        checkCardId();
                    }
                } else {
                    layerUtils.iLoading(false);
                    layerUtils.iAlert(data.error_info);
                }
            }, false);
        };

        postServer();
    }

    function bindBankCard() {
        if(appUtils.getSStorageInfo("login_flag") == "1"){
            var bankLinkNo = $(_pageId + " #selectBank").attr("organization-no");
            var bankArry=["5900","5400","5100","5000","5800","7500"];
            if (bankArry.indexOf(bankLinkNo) > -1) {
                appUtils.setSStorageInfo("login_flag", "0");
                appUtils.pageInit("account/thirdDepository", "account/riskAssessment");
            }
        }
        var userid = appUtils.getSStorageInfo("user_id"),
            organizationNo = $(_pageId + " #selectBank").attr("organization-no"),
            bankaccount = $(_pageId + " #bankcard").val().replace(/\s*/g, ""),
            bankpwd = $(_pageId + " #bankcardPwd").val(),
            thirdDepositParam = {
                "funcNo": 501538,
                "user_id": userid,
                "acct_clientid": "",
                "acct_fndacct": "",
                "bank_code": organizationNo,
                "bank_account": bankaccount,
                "bank_pwd": bankpwd,
                "op_type": $(_pageId + " #selectBank").attr("bind-type"),
                "clientinfo": appUtils.getSStorageInfo("clientinfo"),
                "jsessionid": appUtils.getSStorageInfo("jsessionid")
            };
        appUtils.invokeServer(global.serverPath, thirdDepositParam, function(data) {
            if (data.error_no == 0) {
                // 如果需要密码，并且密码不合格，无法继续
                if (zzispwd != "0" && !validateBankPwd()) {
                    return;
                }
                if (appUtils.getSStorageInfo("needThirdDeposit") == 1) {
                    //appUtils.pageInit("account/thirdDepository", "account/accountResult", {});
                    publicMethod.openAccountResult("account/thirdDepository");
                    return;
                }
                appUtils.pageInit("account/thirdDepository", "account/riskAssessment", {});
            } else {
                layerUtils.iAlert(data.error_info, -1);
            }
        });
    }

    function getInput(data) {
        data = JSON.parse(data);
        $(_pageId + " #" + data.selector).val(data.value);
    }

    var thirdDepository = {
        "init": init,
        "bindPageEvent": bindPageEvent,
        "destroy": destroy
    };

    module.exports = thirdDepository;
});