/**
 * 上传身份证照片
 */
define("project/scripts/account/uploadPhoto",function(require, exports, module){ 
	/* 私有业务模块的全局变量 begin */
	var appUtils = require("appUtils"),
		   layerUtils = require("layerUtils"),
		   shellPlugin = require("shellPlugin"),
		   talkingdata = require("talkingdata"),
		   publicMethod=require("PublicMethod"),
		   gconfig = require("gconfig"),
		   utils = require("utils"),
		   global = gconfig.global,
		   serverPath = global.serverPath,
		   _pageId = "#account_uploadPhoto",
		   // 填写资料的页面入参，属性由 imgState 方法赋值
			fillInformationInParam = {
					// 身份证号
					"idNo" : "",	
					// 客户姓名
					"custname" : "",	
					// 证件地址
					"native" : "",		
					// 签发机关
					"policeorg" : "",	
					// 出生日期
					"borthday" : "",	
					// 证件开始日期
					"idBeginDate" : "",	
					// 证件结束日期
					"idEndDate" : "",	
					// 用户性别
					"gender" : "",	
					// 邮编
					"zipCode" : ""
			};
	/* 私有业务模块的全局变量 end */	
	function init()
	{
		/* 照片上传完成后自动调用该方法*/
		window.imgState = imgState;
		//获取设备信息
		getDeviceInfo();
		isSdk();
		//埋点
		talkingdata.record("UPLOADPHOTO", "UPLOADPHOTO_0701");
	}
	//判断是否是SDK
	function isSdk(){
		if (global.isSDK == true) {
			$(_pageId+" .icon_back").show();
		} else {
			$(_pageId+" .icon_back").hide();
		}
	}
	function getDeviceInfo() {
		var mac = iBrowser.pc ? "02:00:5E:00:00:14" : "",
			ip = iBrowser.pc ? "192.168.1.109" : "";
		// 只有当不是 pc 时，才调用壳子获取 ip 和 mac
		if (!iBrowser.pc) {
			shellPlugin.callShellMethod("getIpMacPLugin", function(data) {
				data = data.split("|");
				mac = data[0];
				ip = data[1];
			}, null);
		}
		// 将 mac 和 ip 保存到 sessionStorage 里面
		appUtils.setSStorageInfo("ip", ip);
		appUtils.setSStorageInfo("mac", mac);
	}

	function bindPageEvent()
	{
		// 绑定FAQ常见问题按钮
		publicMethod.bindProblemEvent(_pageId);

		/*appUtils.bindEvent($(_pageId),function(){
			$(_pageId+" .header_icon").hide();
		});*/
		
		appUtils.bindEvent($(_pageId+" #a_setting"),function(event){
			$(_pageId+" .header_icon").toggle();
			$(_pageId+" .upload_btn").slideUp("fast");
			event.stopPropagation();
		});
		appUtils.bindEvent($(_pageId+" .header .icon_back"),function(){
			shellPlugin.callShellMethod("closeAppPlugin",null,null,{});
		});
		//小安机器人
		publicMethod.bindXiaoAnEvent(_pageId,true);
		appUtils.bindEvent($(_pageId+" #a_phone"),function(){
			utils.callKHRXPhone("4000-188-288");
			//埋点
			talkingdata.record("UPLOADPHOTO", "UPLOADPHOTO_0702");
		});
		
		appUtils.bindEvent($(_pageId+" #recommenderInfo"),function(){
			
			shellPlugin.callShellMethod("recommenderPlugin", null,null,null);
			
		});
		
	
		// 点击页面隐藏按钮
		appUtils.bindEvent($(_pageId),function(){
			//点击空白处隐藏
			$(_pageId+" .header_icon").hide();
			// 将按钮的自定义属性  last-media-id 设为 当前的 media-id
			$(_pageId+" .upload_btn ul li").attr("last-media-id",$(_pageId+" .upload_btn ul li:eq(0)").attr("media-id"));
			// 将按钮的自定义属性 media-id 设为 null
			$(_pageId+" .upload_btn ul li").attr("media-id","null");
			// 隐藏照片上传按钮
			$(_pageId+" .upload_btn").slideUp("fast");
		});
		
		/* 绑定返回 */
//		appUtils.bindEvent($(_pageId+" .header .icon_back"),function(){
//			appUtils.pageBack();
//		});
		
		// 上传正面
		appUtils.bindEvent($(_pageId+" .upload_main .upload_box:eq(0)"),function(e){
			// 点击页面其他元素时，按钮会被隐藏，属性 media-id 的值为 null
			if($(_pageId+" .upload_btn ul li:eq(0)").attr("media-id") == "null")
			{
				// 显示照片上传按钮
				$(_pageId+" .upload_btn").slideDown("fast");
				$(_pageId+" .upload_btn h5").text("上传身份证正面");
				// 设置媒体协议 id
				$(_pageId+" .upload_btn ul li").attr("media-id","4");
			}
			else
			{
				// 隐藏照片上传按钮
				$(_pageId+" .upload_btn").slideUp("fast");
				// 将按钮的自定义属性 media-id 设为 null
				$(_pageId+" .upload_btn ul li").attr("media-id","null");
			}
			$(_pageId+" .header_icon").hide();
			// 阻止冒泡
			e.stopPropagation();

			//埋点
			talkingdata.record("UPLOADPHOTO", "UPLOADPHOTO_0704");
		});
		
		// 上传反面
		appUtils.bindEvent($(_pageId+" .upload_main .upload_box:eq(1)"),function(e){
			// 点击页面其他元素时，按钮会被隐藏，属性 media-id 的值为 null
			if($(_pageId+" .upload_btn ul li:eq(0)").attr("media-id") == "null")
			{
				// 显示照片上传按钮
				$(_pageId+" .upload_btn").slideDown("fast");
				$(_pageId+" .upload_btn h5").text("上传身份证反面");
				// 设置媒体协议 id
				$(_pageId+" .upload_btn ul li").attr("media-id","5");
			}
			else
			{
				// 隐藏照片上传按钮
				$(_pageId+" .upload_btn").slideUp("fast");
				// 将按钮的自定义属性 media-id 设为 null
				$(_pageId+" .upload_btn ul li").attr("media-id","null");
			}
			$(_pageId+" .header_icon").hide();
			// 阻止冒泡
			e.stopPropagation();

			//埋点
			talkingdata.record("UPLOADPHOTO", "UPLOADPHOTO_0709");
		});
		
		// 人像正面
		appUtils.bindEvent($(_pageId+" .upload_main .upload_box:eq(2)"),function(e){
			// 点击页面其他元素时，按钮会被隐藏，属性 media-id 的值为 null
			if($(_pageId+" .upload_btn ul li:eq(0)").attr("media-id") == "null")
			{
				// 显示照片上传按钮
				$(_pageId+" .upload_btn").slideDown("fast");
				$(_pageId+" .upload_btn h5").text("上传客户人脸正像");
				// 设置媒体协议 id
				$(_pageId+" .upload_btn ul li").attr("media-id","3");
			}
			else
			{
				// 隐藏照片上传按钮
				$(_pageId+" .upload_btn").slideUp("fast");
				// 将按钮的自定义属性 media-id 设为 null
				$(_pageId+" .upload_btn ul li").attr("media-id","null");
			}
			$(_pageId+" .header_icon").hide();
			// 阻止冒泡
			e.stopPropagation();

			//埋点
			talkingdata.record("UPLOADPHOTO", "UPLOADPHOTO_0714");
		});
		
		// 相册
		appUtils.bindEvent($(_pageId+" .upload_btn ul li:eq(0)"),function(){
			// 如果更换图片，要将 fillInformationInParam 中对应的值置空
			// 更换正面照
//			if($(_pageId+" .upload_main .upload_box:eq(0)").attr("uploaded") == "true" && $(this).attr("media-id") == "4")
//			{
//				fillInformationInParam.idNo = "";
//				fillInformationInParam.custname = "";
//				fillInformationInParam.borthday = "";
//				fillInformationInParam.native = "";
//				fillInformationInParam.gender = "";
//			}
//			// 更换反面照
//			if($(_pageId+" .upload_main .upload_box:eq(1)").attr("uploaded") == "true" && $(this).attr("media-id") == "5")
//			{
//				fillInformationInParam.policeorg = "";
//				fillInformationInParam.idBeginDate = "";
//				fillInformationInParam.idEndDate = "";
//			}
			// 相册上传的参数
			var phoneConfig = {
					"uuid" : "pingan",
					"r" : Math.random(),
					"user_id" : appUtils.getSStorageInfo("user_id"),
					// 影像名称
					"phototype" : $(this).attr("media-id") == "3" ? "人像正面" : "身份证",
					// 照片来源类别，phone 相册，pai 相机
					"action" : "phone",
					"img_type" : $(this).attr("media-id"),
					// key 和 uuid 只需要写一个
					"key" : "pingan",
					"url" : global.serverPath,
					// 从 session 中将 clientinfo 取出
					"clientinfo" : appUtils.getSStorageInfo("clientinfo"),
					// 从 session 中将 jsessionid 取出
					"jsessionid" : appUtils.getSStorageInfo("jsessionid")
			};
			// ios 嵌 air 要打开等待层
			if(require("gconfig").platform == 3)
			{
				layerUtils.iLoading(true);
			}
			shellPlugin.callShellMethod("carmeraPlugin",null,null,phoneConfig);

			//埋点
			var mId = $(this).attr("media-id");
			if(mId == "4") {
				talkingdata.record("UPLOADPHOTO","UPLOADPHOTO_0706");
			}else if(mId == "5"){
				talkingdata.record("UPLOADPHOTO","UPLOADPHOTO_0711");
			}else if(mId == "3"){
				talkingdata.record("UPLOADPHOTO","UPLOADPHOTO_0716");
			}
		});
		
		// 拍照
		appUtils.bindEvent($(_pageId+" .upload_btn ul li:eq(1)"),function(){
			// 如果更换图片，要将 fillInformationInParam 中对应的值置空
			// 更换正面照
//			if($(_pageId+" .upload_main .upload_box:eq(0)").attr("uploaded") == "true" && $(this).attr("media-id") == "4")
//			{
//				fillInformationInParam.idNo = "";
//				fillInformationInParam.custname = "";
//				fillInformationInParam.borthday = "";
//				fillInformationInParam.native = "";
//				fillInformationInParam.gender = "";
//			}
//			// 更换反面照
//			if($(_pageId+" .upload_main .upload_box:eq(1)").attr("uploaded") == "true" && $(this).attr("media-id") == "5")
//			{
//				fillInformationInParam.policeorg = "";
//				fillInformationInParam.idBeginDate = "";
//				fillInformationInParam.idEndDate = "";
//			}
			// 相机上传的参数
			var paiConfig = {
				"uuid" : "pingan",
				"r" : Math.random(),
				"user_id" : appUtils.getSStorageInfo("user_id"),
				// 影像名称
				"phototype" : $(this).attr("media-id") == "3" ? "人像正面" : "身份证",
				// 照片来源类别，phone 相册，pai 相机
				"action" : "pai",
				"img_type" : $(this).attr("media-id"),
				// key 和 uuid 只需要写一个
				"key" : "pingan",
				"url" : global.serverPath,
				"clientinfo" : appUtils.getSStorageInfo("clientinfo"),
				"jsessionid" : appUtils.getSStorageInfo("jsessionid")
			};
			// ios 嵌 air 要打开等待层
			if(require("gconfig").platform == 3)
			{
				layerUtils.iLoading(true);
			}
			shellPlugin.callShellMethod("carmeraPlugin",null,null,paiConfig);

			//埋点
			var mId = $(this).attr("media-id");
			if(mId == "4") {
				talkingdata.record("UPLOADPHOTO","UPLOADPHOTO_0705");
			}else if(mId == "5"){
				talkingdata.record("UPLOADPHOTO","UPLOADPHOTO_0710");
			}else if(mId == "3"){
				talkingdata.record("UPLOADPHOTO","UPLOADPHOTO_0715");
			}
		});

		/* 绑定同意签署协议 */
		appUtils.bindEvent($(_pageId+" .upload_main .icon_check"),function(){
			$(this).toggleClass("checked");
		});
		
		/* 绑定下一步 */
		appUtils.bindEvent($(_pageId+" .fix_bot .ct_btn"),function(){
			// 隐藏照片按钮
			$(_pageId+" .upload_btn").hide();
			if($(_pageId+" .upload_main .upload_box:eq(0) img").length == 0)
			{
				layerUtils.iMsg(-1,"请先上传正面照！");
				return false;
			}
			if($(_pageId+" .upload_main .upload_box:eq(1) img").length == 0)
			{
				layerUtils.iMsg(-1,"请先上传反面照！");
				return false;
			}
			if($(_pageId+" .upload_main .upload_box:eq(2) img").length == 0)
			{
				layerUtils.iMsg(-1,"请先上传人像正面！");
				return false;
			}
			// 查询邮编
			var zipCodeParam = {
					"funcNo" : 501557,
					"addr" : fillInformationInParam.native,
					"clientinfo" : appUtils.getSStorageInfo("clientinfo"),
					"jsessionid" : appUtils.getSStorageInfo("jsessionid")
				};
			appUtils.invokeServer(global.serverPath,zipCodeParam,function(data){
				// 查邮编失败了，不需要弹出提示
				if(data.error_no == 0 && data.results[0] != undefined)
				{
					fillInformationInParam.zipCode = data.results[0].post;
				}
				appUtils.pageInit("account/uploadPhoto","account/personInfo",fillInformationInParam);
			});

			//埋点
			talkingdata.record("UPLOADPHOTO", "UPLOADPHOTO_0719");
		});
	}
	
	/* 清理界面元素
	 * 不能写在 destroy 方法里面，写在 destroy 里面，查看协议的时候，界面的元素也会被清理掉
	 */
	function cleanPageElement(){
		// 设置 uploaded 属性为 false
		$(_pageId+" .upload_main .upload_box").attr("uploaded",false);
		// 恢复上传照片的提示
		$(_pageId+" .upload_main .upload_box:eq(0)").html("<dd><p>点击上传身份证</p><h5>正 面</h5></dd>");
		$(_pageId+" .upload_main .upload_box:eq(1)").html("<dd><p>点击上传身份证</p><h5>背面</h5></dd>");
		$(_pageId+" .upload_main .upload_box:eq(2)").html("<dd><p>点击上传身份证</p><h5>人脸正像</h5></dd>");
	}
	
	/**
	 * 照片上传完成后，会自动调用 imgState 方法，但是该方法只能写在 m/index.html 或者暴露给 window ，否则无法调用
	 * 已在 init 中暴露给 window 
	 */ 
	function imgState(mediaId,data)
	{
		// ios 嵌 air 要打开等待层
		if(require("gconfig").platform == 3)
		{
			layerUtils.iLoading(false);
			data = unescape(data);
		}
		// 返回的是 json 串
		data = JSON.parse(data);
		var base64Str = (data.base64).replace(/[\n\r]*/g,"");
		data.base64 = base64Str;
		if(data.error_no != 0)
		{
			layerUtils.iAlert(data.error_info);
			return;
		}
		// 填充 fillInformationInParam
		setValueForFillParam(data);
	}
	
	function destroy()
	{
		
	}
	
	// 填充 fillInformationInParam
	function setValueForFillParam(data)
	{
		/**
		 * 只有当返回的数据不为空时，才设置 fillInformationInParam 的属性，确保取识别出来的并集
		 */
		// 当上传是身份证时
		if($(_pageId+" .upload_btn ul li:eq(0)").attr("last-media-id") == 4 || $(_pageId+" .upload_btn ul li:eq(0)").attr("last-media-id") == 5)
		{
			// 身份证号
			if(data.results[0].idno.length != 0){
				fillInformationInParam.idNo = data.results[0].idno;
			}
			// 客户姓名
			if(data.results[0].custname.length != 0)
			{
				fillInformationInParam.custname = data.results[0].custname;
			}
			// 证件地址
			if(data.results[0].native.length != 0)
			{
				fillInformationInParam.native = data.results[0].native;
			}
			// 签发机关
			if(data.results[0].policeorg.length != 0)
			{
				fillInformationInParam.policeorg = data.results[0].policeorg;
			}
			// 出生日期
			if(data.results[0].borthday.length != 0)
			{
				fillInformationInParam.borthday = data.results[0].borthday;
			}
			// 证件开始日期
			if(data.results[0].idbegindate.length != 0)
			{
				fillInformationInParam.idBeginDate = data.results[0].idbegindate;
			}
			// 证件结束日期
			if(data.results[0].idenddate.length != 0)
			{
				fillInformationInParam.idEndDate = data.results[0].idenddate;
			}
			// 用户性别
			if(data.results[0].usersex.length != 0)
			{
				fillInformationInParam.gender = data.results[0].usersex;
			}
		}
		// 显示照片
		showPhoto(data.base64);
	}
	
	// 显示照片
	function showPhoto(base64Str)
	{
		var width = "",
			height = $(window).height();
		height = (height - 160 - 12 * 2 - 60)/3;
		switch(Number($(_pageId+" .upload_btn ul li:eq(0)").attr("last-media-id")))
		{
			// 人像正面
			case 3 : 
				width = $(_pageId+" .upload_main .upload_box:eq(2)").width();
				$(_pageId+" .upload_main .upload_box:eq(2) dd").text("");
				// 显示照片
				$(_pageId+" .upload_main .upload_box:eq(2) dd").append("<img src=\""+base64Str+"\"/>");
				$(_pageId+" .upload_main .upload_box:eq(2) dd img").css({"width":width*0.9+"px","height":height+"px"});
				break;
			// 正面照
			case 4 : 
				if(fillInformationInParam.idNo.length == 0)
				{
					layerUtils.iAlert("身份证号码识别失败，需重新拍摄，请注意拍摄的角度和光线！");
					$(_pageId+" .upload_main .upload_box:eq(0)").text("");
					// 设置 uploaded 属性，标识图片是否已经上传
					$(_pageId+" .upload_main .upload_box:eq(0)").attr("uploaded","false");
					$(_pageId+" .upload_main .upload_box:eq(0)").append("<dd><p>点击上传身份证</p><h5>正面</h5></dd>");
					break;
				}
				else if(fillInformationInParam.gender.length == 0)
				{
					layerUtils.iAlert("性别识别失败，需重新拍摄，请注意拍摄的角度和光线！");
					$(_pageId+" .upload_main .upload_box:eq(0)").text("");
					// 设置 uploaded 属性，标识图片是否已经上传
					$(_pageId+" .upload_main .upload_box:eq(0)").attr("uploaded","false");
					$(_pageId+" .upload_main .upload_box:eq(0)").append("<dd><p>点击上传身份证</p><h5>正面</h5></dd>");
					break;
				}
				width = $(_pageId+" .upload_main .upload_box:eq(0)").width();
				$(_pageId+" .upload_main .upload_box:eq(0) dd").text("");
				// 设置 uploaded 属性，标识图片是否已经上传
				$(_pageId+" .upload_main .upload_box:eq(0)").attr("uploaded","true");
				// 显示照片
				$(_pageId+" .upload_main .upload_box:eq(0) dd").append("<img src=\""+base64Str+"\"/>");
				$(_pageId+" .upload_main .upload_box:eq(0) dd img").css({"width":width*0.9+"px","height":height+"px"});
				break;
			// 反面照
			case 5 : 
				if(fillInformationInParam.idBeginDate.length == 0)
				{
					layerUtils.iAlert("身份证的有效期限识别失败，需重新拍摄，请注意拍摄的角度和光线！");
					// 先将  li 置空
					$(_pageId+" .upload_main .upload_box:eq(1)").text("");
					// 设置 uploaded 属性，标识图片是否已经上传
					$(_pageId+" .upload_main .upload_box:eq(1)").attr("uploaded","false");
					// 显示上传照片
					$(_pageId+" .upload_main .upload_box:eq(1)").append("<dd><p>点击上传身份证</p><h5>背面</h5></dd>");
					break;
				}
				else if(fillInformationInParam.idEndDate.length == 0)
				{
					layerUtils.iAlert("身份证的有效期限识别失败，需重新拍摄，请注意拍摄的角度和光线！");
					// 先将  li 置空
					$(_pageId+" .upload_main .upload_box:eq(1)").text("");
					// 设置 uploaded 属性，标识图片是否已经上传
					$(_pageId+" .upload_main .upload_box:eq(1)").attr("uploaded","false");
					// 显示上传照片
					$(_pageId+" .upload_main .upload_box:eq(1)").append("<dd><p>点击上传身份证</p><h5>背面</h5></dd>");
					break;
				}
				width = $(_pageId+" .upload_main .upload_box:eq(1)").width();
				$(_pageId+" .upload_main .upload_box:eq(1) dd").text("");
				// 设置 uploaded 属性，标识图片是否已经上传
				$(_pageId+" .upload_main .upload_box:eq(1)").attr("uploaded","true");
				// 显示照片
				$(_pageId+" .upload_main .upload_box:eq(1) dd").append("<img src=\""+base64Str+"\"/>");
				$(_pageId+" .upload_main .upload_box:eq(1) dd img").css({"width":width*0.9+"px","height":height+"px"});
				break;
		}
	}
	
	var uploadPhotoChange = {
		"init" : init,
		"bindPageEvent" : bindPageEvent,
		"destroy" : destroy
	};
	
	/* 暴露对外的接口 */
	module.exports = uploadPhotoChange;
});