/**
 * 视频见证注意事项
 */
define("project/scripts/account/videoNotice",function(require, exports, module){
	var appUtils = require("appUtils"),
		gconfig = require("gconfig"),
		global = gconfig.global,
		layerUtils = require("layerUtils"),
		shellPlugin = require("shellPlugin"),
		talkingdata = require("talkingdata"),
		publicMethod = require("PublicMethod"),
		utils = require("utils"),
		waitTime = {},  // 等待时长，连接上到视频见证开始的时间
		stratTimeData="",
		endTimeData="",
		_pageId = "#account_videoNotice",
		steps = [
			"uploadimg", "idconfirm", "stkacct", "setpwd",
			"tpbank", "risksurvey", "visitsurvey",
			"witness", "certintall", "success"
		],
		stepMap = {
			"uploadimg": "account/uploadPhoto",
			"idconfirm": "account/personInfo",
			"stkacct": "account/signProtocol",
			"setpwd": "account/setPwd",
			"tpbank": "account/thirdDepository",
			"risksurvey": "account/riskAssessment",
			"visitsurvey": "account/openConfirm",
			"witness": "account/videoNotice",
			"certintall": "account/accountResult",
			"success": "account/accountResult"
		};
	var isVideoNotice = true,
		timeOut = 0;
	var hasMatchSuccess = false;
	function init()
	{
		window.videoSuccess = videoSuccess;
		window.videoFail = videoFail;
		window.listenVideoState = listenVideoState;
		getVideoTime();
		promptLangue();
		//埋点
		talkingdata.record("VIDEONOTICE", "VIDEONOTICE_1401");
	}
	function promptLangue(){
		if(gconfig.platform == "1"){
			$(_pageId+" #prompt_text,.image_text").text("请允许调用“摄像头”与“录音”");
		}else{
			$(_pageId+" #prompt_text,.image_text").text("请允许访问“麦克风”与“相机”");
		}
	}
	function getVideoTime()
	{
		layerUtils.iLoading(true);
		var getVideoTimeParam = {
			"funcNo" : "1001007",
			"userid" : appUtils.getSStorageInfo("user_id"),
			"clientinfo" : appUtils.getSStorageInfo("clientinfo"),
			"jsessionid" : appUtils.getSStorageInfo("jsessionid")
		};
		appUtils.invokeServer(global.serverPath,getVideoTimeParam,function(data){
			if(data.error_no == 0)
			{
				layerUtils.iLoading(false);
				var startTime = data.results[0].starttime,
					endTime = data.results[0].endtime,
					videoTime = startTime+"~"+endTime;
				stratTimeData = startTime;
				endTimeData = endTime;
				$(_pageId+" #videoTime").html(videoTime);
			}
			else
			{
				layerUtils.iLoading(false);
				layerUtils.iAlert(data.error_info);
				isVideoNotice=false;
			}
		});
	}
	function videoSuccess01()
	{
		if (appUtils.getSStorageInfo("login_flag") == "1"){
			var attr={
				"funcNo" : 600008,
				"userid" : appUtils.getSStorageInfo("user_id"),
				"clientinfo" : appUtils.getSStorageInfo("clientinfo"),
				"jsessionid" : appUtils.getSStorageInfo("jsessionid")
			};
			appUtils.invokeServer(global.serverPath, attr, function(data) {
				if (data.error_no == 0) {
					layerUtils.iLoading(true);
					//跳转到安装证书界面
					setTimeout(function(){
						layerUtils.iLoading(false);
						//appUtils.pageInit("account/videoNotice","account/accountResult",{});
						publicMethod.openAccountResult("account/videoNotice");
					},50);
				}else{
					layerUtils.iAlert(data.error_info);
				}
			});
		}else{
			layerUtils.iLoading(true);
			//跳转到安装证书界面
			setTimeout(function(){
				layerUtils.iLoading(false);
				//appUtils.pageInit("account/videoNotice","account/accountResult",{});
				publicMethod.openAccountResult("account/videoNotice");
			},50);
		}
	}
	/*	//视频驳回状态
	 function videoReject(){
	 layerUtils.iLoading(true);
	 //跳转到上传身份证页面
	 setTimeout(function(){
	 layerUtils.iLoading(false);
	 appUtils.pageInit("account/videoNotice","account/uploadPhoto",{});
	 },50);
	 }*/
	/**
	 *见证通过
	 */
	function videoSuccess()
	{

	}

	/**
	 *见证不通过
	 */
	function videoFail() {}

	/**
	 * 监听视频状态
	 * "connection_succeed"   成功连接视频服务器  waitBegin
	 * “mate_agent_succeed”   成功匹配坐席   mate_agent_succeed
	 * “start_video_witness”   开始视频见证  waitEnd
	 * "witness_complete"    见证完成   matchSucess
	 * "client_disconnect"     客户端断开连接，取消排队 dequeue 为 true ，断开连接为 false  connectSucess
	 * "agent_disconnect"     坐席端断开连接   matchFailed
	 *
	 * "state=client_disconnect&videoId=4356&PA://job_id=220232_3y66788_20140508140412&branch_id=yycyy1
	 * &cust_id=220232&cust_name=td0651&srv_id=3y66788&srv_name=周海4r&
	 * cust_stream=mp4>2014|0508|yycyy1|3y66788|cust22023220140508140412.mp4&
	 * srv_stream=2014|0508|yycyy1|3y66788|srv22023220140508140412&create_time=2014-05-08 14>04>12&result=1&dequeue=true"
	 */
	function listenVideoState(data)
	{
		var oVideoState = getVideoStateByData(data),  // 视频状态的对象
			videoState = oVideoState["state"],  // 状态
			dequeue = oVideoState["dequeue"];  // 是否是取消排队
		if(videoState == "waitBegin")  // 成功连接视频服务器
		{
			waitTime.waitBegin = new Date().getTime();   // 等待的开始时间
		}
		else if(videoState == "connectSucess" && waitTime.waitEnd == undefined)  // 客户端主动断开连接并且是未开始见证的
		{
			waitTime.waitEnd = new Date().getTime();  // 等待的结束时间
		}
		else if(videoState == "waitEnd")  // 开始视频见证
		{
			waitTime.waitEnd = new Date().getTime();   // 等待的结束时间
		}
		// 见证完成、客户端断开连接、座席端断开连接
		var sendArray = ["matchSucess", "connectSucess", "matchFailed"];  // 发送请求的数组

		var result = oVideoState["result"]; // 见证状态
		if(sendArray.indexOf(videoState) != -1)  // 在 发送请求的数组 中存在时，才发送请求
		{
			if(videoState == "matchSucess" && result == "0")  // 审核完成
			{
				if(!hasMatchSuccess){
					collectVideoState(oVideoState, videoState, videoSuccess01);  // 统计视频状态，统计之后跳转页面
					hasMatchSuccess = true;
				}
			}else{
				// 其他状态
				var pageCode="";
				if(result == "needPhoto"){
					result = "uploadimg";
					pageCode = stepMap[result];
				}else{
					for(var i=0;i<steps.length;i++){
						if(steps[i] == result){
							pageCode = steps[i+1]
							pageCode = stepMap[pageCode];
						}
					}
				}
				if(pageCode){
					if(pageCode == "account/accountResult"){
						publicMethod.openAccountResult("account/videoNotice");
					}else{
						appUtils.pageInit("account/videoNotice",pageCode, {});
					}
				} else {
					// 当客户端主动断开连接，并且是取消排队时，videoState 为 sonnectSucess
					videoState = (videoState == "connectSucess" && dequeue == "true") ? "connectSucess" : videoState;
					// 当客户端主动断开连接，并且不是取消排队时，videoState 为 matchFailed
					videoState = (videoState == "connectSucess" && dequeue == "false") ? "matchFailed" : videoState;
				}
				collectVideoState(oVideoState, videoState, null);  // 统计视频状态
			}
		}
	}

	/**
	 * 统计视频状态
	 * @param data flash 传过来的数据
	 * @param videoState 转换成接口所需数据之后的视频状态
	 * @param callbackFunc 发送请求之后的回调函数
	 */
	function collectVideoState(data, videoState ,callbackFunc) {
		// 统计视频状态
		var collectVideoStateParam = {
			//"funcNo" : "1001021",
			"funcNo": "1001032",
			"state": videoState,  // 视频状态
			// "videoId": getVedioIdByData(data),  // 视频 id
			// "phone": "1",   // 手机
			"flowsn":data.videoId,   //流水号
			"waittime": "",  // 等待时间
			"userid": appUtils.getSStorageInfo("user_id"),
			"clientinfo": appUtils.getSStorageInfo("clientinfo"),
			"jsessionid": appUtils.getSStorageInfo("jsessionid")
		};
		collectVideoStateParam.waittime = parseInt((waitTime.waitEnd - waitTime.waitBegin) / 1000);  // 转换为 秒 之后发给后台
		//等待时间为NaN或者小于0时，将置为0
		if(isNaN(collectVideoStateParam.waittime)|| collectVideoStateParam.waittime < 0){
			collectVideoStateParam.waittime = 0;
		}
		if(videoState != "matchSucess")  // 不是见证完成时
		{
			collectVideoStateParam.videoId = "";  // videoId 置空
		}
		$.ajax({
			type : "post",
			url : global.serverPath,
			data : collectVideoStateParam,
			dataType : "json",
			//timeout : 5000,
			success: function(data){
				// 不管请求成功，还是失败，都执行回调函数
				if (callbackFunc) // 当回调函数不为空时
				{
					callbackFunc();   // 执行回调函数
				}
			},
			error : function(xhr,errorType){
				if(timeOut<3){
					collectVideoState(data, videoState ,callbackFunc);
					timeOut++;
				}else{
					layerUtils.iAlert("请求超时！");
					timeOut = 0;
				}
				// 不管请求成功，还是失败，都执行回调函数
				if (callbackFunc) // 当回调函数不为空时
				{
					callbackFunc();   // 执行回调函数
				}
			}

		});
		/* appUtils.invokeServer(global.serverPath, collectVideoStateParam,function(data) {
		 // 不管请求成功，还是失败，都执行回调函数
		 if (callbackFunc) // 当回调函数不为空时
		 {
		 callbackFunc();   // 执行回调函数
		 }
		 });*/
	}

	/*根据 data 设置传给后台的 videoState*/
	function getVideoStateByData(data)
	{
//		data = data.toLowwerCase();  // 转换为小写
		// 视频状态对象
		/*var oVideoState = {
		 state : "",  // 状态
		 dequeue : ""  // 是否取消排队
		 };
		 var	stateBeginIndex = data.indexOf("state");
		 var	stateEndIndex = data.indexOf("&", stateBeginIndex);
		 var	state = data.slice(stateBeginIndex+6, stateEndIndex);  // 获取 state 的值
		 var	dequeueBeginIndex = data.indexOf("dequeue");
		 var	dequeueEndIndex = 0;
		 var	dequeue = ""; // dequeue 值
		 var resultIndex = data.indexOf("result");
		 var result = data.slice(resultIndex+7,resultIndex+8);
		 oVideoState["result"] = result;
		 if(dequeueBeginIndex != -1)  // 如果有 dequeue
		 {
		 dequeueEndIndex = data.indexOf("&", dequeueBeginIndex);
		 }
		 if(dequeueEndIndex == -1)
		 {
		 dequeueEndIndex = data.length;
		 }
		 if(dequeueEndIndex != 0)
		 {
		 dequeue = data.slice(dequeueBeginIndex+8, dequeueEndIndex);  // 获取 dequeue 值
		 }*/
		var oVideoState = JSON.parse(data),
			state = oVideoState.state;
		switch(state)
		{
			case "connection_succeed" :
				oVideoState["state"] = "waitBegin";  // 成功连接视频服务器
				break;
			case "mate_agent_succeed" :
				oVideoState["state"] = "mate_agent_succeed";  // 成功匹配坐席
				break;
			case "start_video_witness" :
				oVideoState["state"] = "waitEnd";  // 开始视频见证
				break;
			case "witness_complete" :
				oVideoState["state"] = "matchSucess";  // 见证完成
				break;
			case "client_disconnect" :
				oVideoState["state"] = "connectSucess";  // 客户端主动断开连接
				break;
			case "agent_disconnect" :
				oVideoState["state"] = "matchFailed";  // 坐席端断开连接
				break;
		}
		return oVideoState;
	}


	/*根据 flash 传递过来的数据获取 videoId*/
	function getVedioIdByData(data)
	{
		data = data.toUpperCase(data);  // 见证成功时，返回的是 videoID ，其他状态返回的是 videoId 
		var beginIndex = data.indexOf("VIDEOID"),
			endIndex = data.indexOf("&",beginIndex);
		if(beginIndex != -1)
		{
			return data.slice(beginIndex+8,endIndex);  // 返回 videoId
		}
		else
		{
			return "";  // 没有查到 videoId 时返回空
		}
	}

	function bindPageEvent()
	{
		//进入此页面时，调用native视频注册插件
		shellPlugin.callShellMethod("regVideoPlugin", null, null, {
			"user_id" : appUtils.getSStorageInfo("user_id"),
			"url" : global.serverPath
		});

		// 绑定FAQ常见问题按钮
		publicMethod.bindProblemEvent(_pageId);

		appUtils.bindEvent($(_pageId),function(){
			$(_pageId+" .header_icon").hide();
		});

		appUtils.bindEvent($(_pageId+" #a_setting"),function(event){
			$(_pageId+" .header_icon").toggle();
			event.stopPropagation();
		});
		//小安机器人
		publicMethod.bindXiaoAnEvent(_pageId,true);
		appUtils.bindEvent($(_pageId+" #a_phone"),function(){
			utils.callKHRXPhone("4000-188-288");
			//埋点
			talkingdata.record("VIDEONOTICE", "VIDEONOTICE_1402");
		});

		appUtils.bindEvent($(_pageId+" #recommenderInfo"),function(){

			shellPlugin.callShellMethod("recommenderPlugin", null,null,null);

		});

		//绑定返回
		appUtils.bindEvent($(_pageId+" .header .icon_back"),function(){
			appUtils.pageBack();
		});

		//在线视频视频见证
		appUtils.bindEvent($(_pageId+" .ct_btn"),function(){
			var nowHours = new Date().getHours(),
				nowMinutes = new Date().getMinutes();
			var stratArray = stratTimeData.split(":"),
				endArray = endTimeData.split(":");
			if(parseInt(nowHours) < parseInt(stratArray[0]) || parseInt(nowHours) > parseInt(endArray[0])){
				layerUtils.iAlert("当前不在视频服务时间");
				isVideoNotice = false;
			}else{
				if(parseInt(nowHours) == parseInt(stratArray[0]) && parseInt(nowMinutes) < parseInt(stratArray[1])){
					layerUtils.iAlert("当前不在视频服务时间");
					isVideoNotice = false;
				}else if(parseInt(nowHours) ==  parseInt(endArray[0]) && parseInt(nowMinutes) > parseInt(endArray[1])){
					layerUtils.iAlert("当前不在视频服务时间");
					isVideoNotice = false;
				}else{
					isVideoNotice = true;
				}

			}
			// getVideoAddress()
			if(isVideoNotice==true){
				startVideoVerify();
			}
			//埋点
			talkingdata.record("VIDEONOTICE", "VIDEONOTICE_1404");
		});
	}

	function destroy(){}

	function getVideoAddress()
	{
		var getVideoAddressParam = {
			"funcNo" : "501562",
			"userid" : appUtils.getSStorageInfo("user_id"),
			"branchno" : "3099",
			"clientinfo" : appUtils.getSStorageInfo("clientinfo"),
			"jsessionid" : appUtils.getSStorageInfo("jsessionid")
		};
		appUtils.invokeServer(global.serverPath,getVideoAddressParam,function(data){
			if(data.error_no == 0)
			{
				var ip = data.results[0].ip,
					port = data.results[0].port,
					folder = data.results[0].folder;  // 视频服务器的 名字，如 ： vod
				startVideoVerify(ip, port, folder);
			}
			else
			{
				layerUtils.iAlert(data.error_info);
			}
		});
	}

	/*开始视频见证*/
	function startVideoVerify(ip, port, folder)
	{
		var param = {
			"user_id" : appUtils.getSStorageInfo("user_id"),
			"tel_num" : appUtils.getSStorageInfo("mobileNo"),
			"ip" : ip,
			"port" : port,
			"folder" : folder,
			"cust_name" : appUtils.getSStorageInfo("custname"),
			"branch_id" : "3099",
			"idCardNo" : appUtils.getSStorageInfo("idCardNo")
		};
		shellPlugin.callShellMethod("videoPlugin",null,null,param);
	}

	var videoNotice = {
		"init" : init,
		"bindPageEvent" : bindPageEvent,
		"destroy" : destroy
	};

	module.exports = videoNotice;
});