/**
 * 新开户(转户)须知
 */
define("project/scripts/account/welcome",function(require, exports, module){
	var appUtils = require("appUtils"),
		shellPlugin = require("shellPlugin"),
		talkingdata=require("talkingdata"),
		publicMethod=require("PublicMethod"),
		gconfig = require("gconfig"),
		global = gconfig.global,
		utils=require("utils"),
		currVersion = null, // 当前版本号
		layerUtils = require("layerUtils"),
		_pageId = "#account_welcome";
	var recommenderNoId = "";
	function init()
	{
		//弹出式广告
		showAds();
		// 解决 iPhone 4 和 iPhone 4s 页面不在一屏的问题
		if($(document).height() > $(window).height())
		{
			//$(_pageId+" .ness_box").css("padding","10px");
			//$(_pageId+" .main").css("padding-bottom","5px");
		}
		$(_pageId).css("padding-bottom","100px");
		if(appUtils.getSStorageInfo("_isStarted") != "true")
		{
			//queryVersAndAddr(); // 查询服务器上的版本号和下载地址
			appUtils.setSStorageInfo("_isStarted", "true");
		}
		

	
		talkingdata.changeColor();
		//广告位
		setTimeout(function(){
			if(sessionStorage.getItem("skinColor") != "ljs"){
				getBanner();
			}
		});

		//埋点
		talkingdata.record("WELCOME", "WELCOME_0101");
		//获取设备号
		getDevInfo();
		//获取系统信息
		setTimeout(function(){
			isSdk();
		},200)
	}
	//判断是否是SDK
	function isSdk(){
		if (global.isSDK == true) {
			$(_pageId+" .icon_back").show();
			shellPlugin.callShellMethod("toH5recommenderNoId", function (data) {
				recommenderNoId = data;
				// 回调数据中的 data 是字符串，需解析
				if(typeof (data) == "string"){
					recommenderNoId = JSON.parse(recommenderNoId);
				}
				sdkRecommender();
			} , null, null);
		} else {
			$(_pageId+" .icon_back").hide();
			setRecommendInfo();
		}
	}
	//根据时间戳计算出一个随机数
	function getDevInfo() {
		var dateStr = Date.parse(new Date()).toString();
		var randStr = Math.round(Math.random()*10000).toString();
		uuiqueIdData = dateStr + randStr;
		appUtils.setSStorageInfo("userIdCardNo",uuiqueIdData);
	}


	//添加首页广告位
	function showAuto(){
		var bannerWidth=$("body").width();
		$(".slideBanner").MobileSlider({width:bannerWidth,height:85,during:5000});
	}
	function getBanner(){
		var queryParam={
			"funcNo": 700019,
			"banner_page": 2
		};
		appUtils.invokeServer(global.serverPath, queryParam, function(data){
			if(data.error_no == "0"){
				var imgAds=data.results;
				var bNum=imgAds.length;
				if(bNum > 0){
					$("#imgBanners").show();
					var bannerWidth=$("body").width();
					$("#imgBanners ul").width(bannerWidth*bNum);
					var bannerHtml = '';
					bannerHtml += renderBannerItem(imgAds,bNum-1,0);
					for(var i=0;i<bNum;i++){
						bannerHtml += renderBannerItem(imgAds,i,i+1);
					}
					bannerHtml += renderBannerItem(imgAds,0,bNum+1);
					$("#imgBanners ul").append(bannerHtml);
					showAuto();
				}
			}
		});

		function renderBannerItem(imgAds,i,targetId){
			var imgDom='<li><img src="'+imgAds[i].banner_image+'" alt="banner"  style="height:5.3rem;" id="imgAds'+targetId+'"  url-link="'+imgAds[i].banner_url+'"></li>';
			$("#imgBanners ul li").width($("body").width()).height(85);
			appUtils.preBindEvent($("#imgBanners ul"),"#imgAds"+targetId,function(e){
				var param = {
					"url" : $(this).attr("url-link"),
					"background-color": publicMethod.getThemeNo()

				};
				shellPlugin.callShellMethod("webViewPlugin", null,null,param);
			});
			return imgDom;
		}
	}
	//公告弹窗
	function showAds() {
		$.ajax({
			type: "get",
			async: false,
			url: "http://stock.pingan.com/huodong/khgg/khad.jsonp", //生产
			//url:"http://1.nativeapp.sinaapp.com/jsons/khad.jsonp", //FAT     
			dataType: "jsonp",
			jsonp: "callback",
			jsonpCallback: "getAd",
			success: function(ads) {
				if (ads) {
					var endFlag = true;
					if (ads.endDate != "") {
						var endDateT = ads.endDate.replace(/-/g, "/");
						var startDateT = ads.startDate.replace(/-/g, "/");
						var currDate = new Date();
						var endDate = new Date(endDateT);
						var startDate = new Date(startDateT);
						if (endDate < currDate || startDate > currDate) {
							endFlag = false;
						}
					}
					//在日期范围内，且包含当前渠道channel：5：app 6：pc  7.保单app 8.新开web 9.保单web
					var channelArr = ads.channel.split(",");
					if (jQuery.inArray("5", channelArr) != -1 && endFlag) {
						var adsContent = "<div id='adsContent' style='padding:0 20px;color:#ccc;'>" + ads.content + "<div style='text-align:right;margin-top:10px;'>" + ads.footer + "</div></div>";
						layerUtils.iAlert(ads.title + adsContent, '', '', "知道了");
						var resetCss = setInterval(function() {
							if ($("#adsContent").length > 0) {
								if ($("#adsContent").height() > 66) {
									$("#adsContent").css("text-align", "left");
								}
								clearInterval(resetCss);
							}
						}, 10);
					}
				}
			}
		});
	}
	function sdkRecommender(){
		var sdkVersion = recommenderNoId.sdkVersion;
		var aid = recommenderNoId.aid;
		var sid = recommenderNoId.sid;
		var ouid = recommenderNoId.ouid;
		var recommenderNo = recommenderNoId.recommenderNo;
		$(_pageId + " #version").html(sdkVersion);
		$(_pageId + " #aid").html(aid);
		$(_pageId + " #sid").html(sid);
		$(_pageId + " #ouid").html(ouid);
		$(_pageId + " #recommenderNo").html(recommenderNo);
	}
	function setRecommendInfo() {
		var version = global.version;
		var aid = global.aid;
		var sid = global.sid;
		var ouid = global.ouid;
		var recommenderNo = global.recommenderNo;
		$(_pageId + " #version").html(version);
		$(_pageId + " #aid").html(aid);
		$(_pageId + " #sid").html(sid);
		$(_pageId + " #ouid").html(ouid);
		$(_pageId + " #recommenderNo").html(recommenderNo);
	}

	function bindPageEvent(){

		var queryAllUrl=global.serverPath;
		var queryUrl=global.serverPath.substring(0,queryAllUrl.length-12)+"query/queryStatus.html?WT.mc_id=KHJD01&WT.srch=1&aid=57&sid=685&ouid=KHJD01&webview=true&fromArea=KHAPP";
		//绑定FAQ常见问题按钮
		publicMethod.bindProblemEvent(_pageId);
		//联系电话
		appUtils.bindEvent($(_pageId+" .header .icon_back"),function(){
			shellPlugin.callShellMethod("closeAppPlugin",null,null,{});
		});
		appUtils.bindEvent($(_pageId),function(){
			$(_pageId+" .header_icon").hide();
		});
		//小安机器人

		publicMethod.bindXiaoAnEvent(_pageId,false);

		appUtils.bindEvent($(_pageId+" #a_setting"),function(event){
			$(_pageId+" .header_icon").toggle();
			event.stopPropagation();
		});

		appUtils.bindEvent($(_pageId+" #a_phone"),function(){
			utils.callKHRXPhone("4000-188-288");
			//埋点
			talkingdata.record("WELCOME", "WELCOME_0102");
		});

		appUtils.bindEvent($(_pageId+" #recommenderInfo"),function(){
			shellPlugin.callShellMethod("recommenderPlugin", null,null,null);
			//埋点
			talkingdata.record("WELCOME", "WELCOME_0104");
		});



		// 查询进度
		appUtils.bindEvent($(_pageId+" #queryOpenAccount"),function(){
			var webUrl = queryUrl;
			var param = {
				"url" : webUrl,
				"title" : "平安证券-开户进度查询",
				"background-color": publicMethod.getThemeNo()
			};
			shellPlugin.callShellMethod("webViewPlugin", null,null,param);
			//埋点
			talkingdata.record("WELCOME", "WELCOME_0111");
		});

		appUtils.bindEvent($(_pageId+" #version"),function(){
			$(_pageId+" .recommenderNo").toggle();
		});

		appUtils.bindEvent($(_pageId+" #openNewAccount"),function(){
			appUtils.setSStorageInfo("login_flag", "0");
			openAndTransferAccount(0);
			hideRym();
			//埋点
			talkingdata.record("WELCOME", "WELCOME_0109");
		});

		appUtils.bindEvent($(_pageId+" #transferAccount"),function(){
			appUtils.setSStorageInfo("login_flag", "1");
			openAndTransferAccount(1);
			hideRym();
			//埋点
			talkingdata.record("WELCOME", "WELCOME_0110");
		});
	}
	//隐藏任意门插件
	function hideRym(){
		shellPlugin.callShellMethod("hideDoorPlugin", null,null,null);
	}
	function openAndTransferAccount(type){
		if(gconfig.platform == 3){
			var terminal_type;
			if(gconfig.platform == "1"){
				terminal_type = "android_new";
			}else{
				terminal_type = "ios_new";
			}
			var queryParam = {
				"funcNo" : 501560,
				"terminal_type" : terminal_type // 类型
			};
			appUtils.invokeServer(global.serverPath, queryParam, function(data){
				if(data.error_no == 0)
				{
					if(data.results.length != 0 && data.results[0].update_url != undefined)  // 服务器有数据返回时
					{
						var results_n = data.results;
						//if(results_n[0].enforcement == 1){
						//	execUpdate(results_n);
						//}else{
						appUtils.pageInit("account/welcome","account/openAccount",{});
						//}
					}else{
						appUtils.pageInit("account/welcome","account/openAccount",{});
					}
				}
				else  // 查询地址失败
				{
					layerUtils.iAlert("版本检查失败，请稍后重试！");
				}
			});
		}
		else
		{
			var terminal_type;
			if(gconfig.platform == "1"){
				terminal_type = "android_new";
			}else{
				terminal_type = "ios_new";
			}
			var queryParam = {
				"funcNo" : 501560,
				"terminal_type" : terminal_type  // 类型
			};
			appUtils.invokeServer(global.serverPath, queryParam, function(data){
				if(data.error_no == 0)
				{
					if(data.results.length != 0 && data.results[0].update_url != undefined)  // 服务器有数据返回时
					{
						var results_n = data.results;
						//if(results_n[0].enforcement == 1){
						//	execUpdate(results_n);
						//}else{
						appUtils.pageInit("account/welcome","account/openAccount",{});
						//}
					}else{
						appUtils.pageInit("account/welcome","account/openAccount",{});
					}
				}
				else  // 查询地址失败
				{
					layerUtils.iAlert("版本检查失败，请稍后重试！");
				}
			});
		}
	}

	function destroy()
	{
	}

	// 查询服务器上的版本号和下载地址
	function queryVersAndAddr()
	{
		var terminal_type;
		if(gconfig.platform == "1"){
			terminal_type = "android_new";
		}else{
			terminal_type = "ios_new";
		}
		// 查询服务器上最新的版本号
		var queryParam = {
			"funcNo" : 501560,
			"terminal_type" : terminal_type   // 类型
		};
		appUtils.invokeServer(global.serverPath, queryParam, function(data){
			if(data.error_no == 0)
			{
				if(data.results.length != 0 && data.results[0].update_url != undefined)  // 服务器有数据返回时
				{
					var results_n = data.results;
					if(results_n[0].enforcement == 1){
						//execUpdate(results_n);
					}
				}
			}
			else  // 查询地址失败
			{
				layerUtils.iAlert("版本检查失败，请稍后重试！");
			}
		});
	}

	/*IOS 自动更新的提示*/
	function updateTipsForIOS(results)
	{
		var length = results.length;
		var	versionLatest = results[0].version;  // 最新版本号  
		var	versionLowest = results[0].version == results[length-1].version ? "0.0.0" : results[length-1].version;  // 只有一条记录取 0
		var	firstEnforcement = results[0].enforcement;  // 第一条记录是否是强制更新
		if((!compareCurrAndOther(currVersion, versionLatest) && firstEnforcement == 1) || !compareCurrAndOther(currVersion,versionLowest))  // 如果第一条记录是强制更新或者当前版本小于最低版本
		{
			layerUtils.iAlert("您的当前版本过低，无法正常使用，请升级安装新版【V"+versionLatest+"】。",-1,function(){
				//execUpdate(results);  // 执行升级
			},"升级");
		}
		// 当前版本大于最低版本，小于最新版本
		else if(compareCurrAndOther(currVersion, versionLowest) && !compareCurrAndOther(currVersion, versionLatest))
		{
			layerUtils.iConfirm("检测到新版本,是否更新?", function(){
				//execUpdate(results);  // 执行升级
			},null, "升级", "忽略");
		}
	}

	/**
	 * 比较当前版本其他版本
	 * 当前版本比其他版大或者相等返回 true ，否则返回 false
	 */
	function compareCurrAndOther(currVersion, otherVersion)
	{
		var currVersionArr = currVersion.split("."),
			otherVersionArr = otherVersion.split(".");  // 最低版本拆分后
		if(currVersionArr[0] > otherVersionArr[0])
		{
			return true;
		}
		else if(currVersionArr[0] < otherVersionArr[0])
		{
			return false;
		}
		else
		{
			currVersionArr.shift(); // 移除数组中第一个元素
			otherVersionArr.shift(); // 移除数组中第一个元素
			var currVersionNum = Number(currVersionArr.join(".")); // 去除第一组数字后的版本号数值表示
			var otherVersionNum = Number(otherVersionArr.join(".")); // 去除第一组数字后的版本号数值表示
			if(currVersionNum >= otherVersionNum)
			{
				return true;
			}
			else
			{
				return false;
			}
		}
		return false;  // 上述条件都不符合，返回 false
	}


	// 执行更新
	function execUpdate(results)
	{
		var length = results.length,
			updateParam = {
				"url" : results[0].update_url,  // 更新地址
				"versionLatest" : results[0].version,  // 最新版本号  
				// 只有一条记录取 0
				"versionLowest" : results[0].version == results[length-1].version ? "0" : results[length-1].version,
				"firstEnforcement" : results[0].enforcement  // 第一条记录是否是强制更新
			};
		shellPlugin.callShellMethod("updateManagerPlugin", null, function(data){
			layerUtils.iAlert("调用版本更新插件失败，失败原因：" + data);
		},updateParam);
	}

	var welcome = {
		"init" : init,
		"bindPageEvent" : bindPageEvent,
		"destroy" : destroy
	};

	module.exports = welcome;
});