﻿/**
 * 程序入口配置读取
 * 项目开发时需要的自定义配置
 * 另外：configuration为系统配置模块或者配置模板
 * 这里可以扩展，支持多个系统共用一个项目：
 * 思路：在最开始的地方做一个sysCode的获取，然后在这个模块初始化时赋不同系统的configuration配置模块的引用，
 * 当然还要做修改的地方，比如地址栏hash处理，需要增加sysCode（涉及到的模块main和appUtils）
 */
define(function(require, exports, module) {
	var configuration = {
		/**
		 * 平台，不传默认为0：
		 * 0：pc或者手机浏览器、1：android壳子嵌phonegap、2：ios壳子嵌phonegap、3：ios壳子嵌AIR
		 */
		"platform": "1",
		"defaultPage": {"pageCode": "account/welcome", "jsonParam":{}}, //项目的默认页面
		"firstLoadCss": ["/m/project/css/style.css","/m/project/css/style_pingan.css"], //项目中的需要先加载的css样式文件，如果多个，添加在数组里面
		"layerTheme" : "c",
		//项目中模块的别名配置
		"pAlias": {
			"utils" : "project/scripts/common/utils"
		},
		/**
		 * 项目中需要调用到的常量、变量这里配置
		 * 调用方式，通过require("gconfig").global.*来调用
		 */
		
		//新修改orgnizationNo 5200 工商银行MKT-ICBC2015,ICBC120419; 5000 建设银行MKT-CCB2015，建行的defaultPage为openAccount; welcome
		//平安银行定制包 6100  新增10-23，农业银行专属定制包， 5100    华夏银行 5900 只有新开openAccount 天津银行 7400

		"global": {
		    "recommenderNo" : "",
		    "aid" : "0",
		    "sid" : "0",
		    "ouid" : "android",
		    "orgnizationNo":"",
			"FAQurl" : "http://mp.weixin.qq.com/s?__biz=MzA4ODA2NDY4Ng==&mid=201832082&idx=1&sn=e3dd91c68a98d4b7308d0551945f8f85#rd",

			// "serverPath" : "http://119.145.10.72:30075/ydkh/servlet/json",  // 公网测试地址
			// "imagesPath" : "http://119.145.10.72:30075/ydkh/servlet/getImage"

			// "serverPath" : "https://ay.pingan.com/ydkh/servlet/json", // 生产地址
			// "imagesPath" : "https://ay.pingan.com/ydkh/servlet/getImage"

			// "serverPath" : "http://10.17.171.17:30075/ydkh/servlet/json",  // 内网测试地址
			// "imagesPath" : "http://10.17.171.17:30075ydkh/servlet/getImage"

			// "serverPath" : "http://10.25.152.138:30075/ydkh/servlet/json"  // 测试 app 环境
			// "imagesPath" : "http://10.25.152.138:30075/ydkh/servlet/getImage"

			// "serverPath" : "http://10.25.153.174:30082/ydkh/servlet/json",  // FAT
			// "imagesPath" : "http://10.25.153.174:30082/ydkh/servlet/getImage"

			"serverPath" : "http://10.243.245.103:8028/ydkh/servlet/json",  // 本地环境
			"imagesPath" : "http://10.243.245.103:8028/ydkh/servlet/getImage"

		}
	};
	
	//暴露对外的接口
	module.exports = window.configuration = configuration;
});