define(function(require, exports, module) {
	var layerUtils = require("layerUtils"),
		gconfig = require("gconfig"),
		appUtils = require("appUtils");

	/**
	 * @param pluginName 要调用的插件名
	 * @param success 调用成功的回调函数
	 * @param fail 调用失败的回调函数
	 * @param param 参数
	 */
	function callShellMethod(pluginName, callbackS, callbackF, param) {
		if (pluginName) {
			//验证入参
			if (typeof callbackS == "function") {
				window.nativeSuccessCallback = callbackS;
				callbackS = "nativeSuccessCallback";
			} else {
				callbackS = null;
			}
			if (typeof callbackF == "function") {
				window.nativeFailedCallback = callbackF;
				callbackF = "nativeFailedCallback";
			} else {
				callbackF = null;
			}
			if (typeof param == "object") {
				param = JSON.stringify(param);
			} else {
				param = null;
			}
			//区分android和IOS平台
			if (gconfig.platform == "1") {
				//调用android方法
				prompt('call://' + pluginName + '("' + callbackS + '"|"' + callbackF + '"|"' + param + '")');
				layerUtils.iLoading(false);
			} else if (gconfig.platform == "2") {
				try {
					//调用IOS方法
					window.jsInterface[pluginName](callbackS, callbackF, param);
				} catch (e) {
					layerUtils.iLoading(false);
					layerUtils.iAlert("调用IOS方法失败！");
				}
			} else {
				// 关闭等待层
				layerUtils.iLoading(false);
				layerUtils.iAlert("该平台不支持NATIVE方法！");
			}
		} else {
			alert("请输入要调用的插件名!");
		}
	}
	var shellPlugin = {
		// 标准方法
		"callShellMethod": callShellMethod
	};
	module.exports = shellPlugin;

	//android返回键触发函数
	window.onBackButton = function() {
		//if (appUtils.getSStorageInfo("_curPageCode") == gconfig.defaultPage.pageCode) {
			layerUtils.iConfirm("确定退出程序吗？", function() {
				callShellMethod("closeAppPlugin", null, null, {});
			});
		// } else {
		// 	appUtils.pageBack();
		// }
	};
});