﻿define(function(require,exports,module){
	var layerUtils = require("layerUtils"),
		appUtils = require("appUtils");
	
	/**
	 * @param pluginName 要调用的插件名
	 * @param success 调用成功的回调函数
	 * @param fail 调用失败的回调函数
	 * @param param 参数
	 */
	function callShellMethod(pluginName,success,fail,param)
	{
		try
		{
			cordova.exec(function(echoValue)
				{
					if(success != null)
					{
						success(echoValue);
					}
				}, function(echoValue)
				{
					if(fail != null)
					{
						fail(echoValue);
					}
					else
					{
						layerUtils.iAlert("插件调用失败:" + echoValue);
					}
					
				}, pluginName, pluginName, [param]);
		}
		catch(e)
		{
			// 关闭等待层
			layerUtils.iLoading(false);
			layerUtils.iAlert("不支持phonegap！");
		}
	}
	
	/*****************************************监控的事件处理*************************************************/
	/**
	 * 控制手机键盘输入时，定位input域在手机键盘正上方
	 */
	function controlMobileInput()  
	{
		
	}

	/**
	 * 手机锁屏处理 
	 */
	function onLockScreen()
	{
		
	}
	
	/**
	 * 手机断网处理
	 */
	function onOffline()
	{
		callShellMethod("isNetAvailablePlugin",function(data){
			if(data.available == "false")
			{
				layerUtils.iAlert("请检查网络是否正常！");
			}
		},null,{});
	}
	
	/**
	 * 手机联网处理
	 */
	function onOnline()
	{
		
	}
	
	/**
	 * 手机键盘返回键
	 */
	function onBackKeyDown() 
	{
		//判断是否直接退出
		if(!require("gconfig").isDirectExit) {
			//弹出层消失，弹出层抽象利于处理，返回上一级页面，page增加上一级页面
			appUtils.pageBack();
		} else {
//			navigator.app.exitApp();
			// 调用 phonegap 的退出方法直接退出系统
			layerUtils.iConfirm("确定退出程序吗？",function(){
				callShellMethod("closeAppPlugin",null,null,{});
			});
		}

	}
	
	/**
	 * deviceready触发事件处理函数
	 * 当PhoneGap加载完毕后会触发"deviceready"事件。此时，可以开始与手机设备进行通讯
	 * 
	 * 添加phonegap监听：document.addEventListener("deviceready", onDeviceReady, false);
	 * 直接退出系统：navigator.app.exitApp();
	 */
	function onDeviceReady()
	{
		
		// 锁屏，锁屏可能只是登录之后或者一段时间不操作之后才粗触发，按需要提到相应位置
		document.addEventListener("pause", onLockScreen, false); 
		// 断网
		document.addEventListener('offline', onOffline, false); 
		// 联网
		document.addEventListener('online', onOnline, false); 
		// 返回键
		document.addEventListener("backbutton", onBackKeyDown, false); 
		
	}
	
	var shellPlugin = {
		"onDeviceReady" : onDeviceReady,
		// 标准方法
		"callShellMethod" : callShellMethod
	};
	module.exports =  shellPlugin;
});
