/**
 * 开|转户结果
 */
define("project/scripts/account/accountResult",function(require,exports,module){
	var appUtils = require("appUtils"),
		gconfig = require("gconfig"),
		layerUtils = require("layerUtils"),
		utils=require("utils"),
		global = gconfig.global,
		sshellPlugin = require("plugins/native/scripts/native"),
		_pageId = "#account_accountResult";
	var SynRegister=2;
	
	function init()
	{
		// ios 没有退出功能
		if(gconfig.platform == 2 || gconfig.platform == 3)
		{
			$(_pageId+" #finishOut").hide();
		}
		$(_pageId+" .header .icon_back").hide();
		$(_pageId+" .order_succes h5:eq(0)").text("开户申请成功！");
		copyDataToCustInfo();
		starRate();
		//联合注册一帐通
		SynRegisterAccount();
	}
	
	//是否联合注册一帐通（700004）1-未选择 2-选择
	function SynRegisterAccount(){
		if($("#sysAccount").hasClass("checked")){
			SynRegister=2;
		}else{
			SynRegister=1;
		}
		var param = {
				"funcNo" : 700004,
				"user_id" : appUtils.getSStorageInfo("user_id"),
				"toa_select" : SynRegister,
				"clientinfo" : appUtils.getSStorageInfo("clientinfo"),
				"jsessionid" : appUtils.getSStorageInfo("jsessionid")
		};
		appUtils.invokeServer(global.serverPath,param,function(data){
			if(data.error_no != 0)
			{
				layerUtils.iAlert(data.error_info);
			}
		});
	}
	
	// 复制数据到 t_custom_info 表
	function copyDataToCustInfo()
	{
		var vedioPassParam = {
				"funcNo" : 501599,
				"user_id" : appUtils.getSStorageInfo("user_id"),
				"canBatch" : 1,
				"clientinfo" : appUtils.getSStorageInfo("clientinfo"),
				"jsessionid" : appUtils.getSStorageInfo("jsessionid")
		};
		appUtils.invokeServer(global.serverPath,vedioPassParam,function(data){
			if(data.error_no != 0)
			{
				layerUtils.iAlert(data.error_info);
			}
		});
	}
	
	
	//评分系统
	function starRate(){	
		var oStar = document.getElementById("star");
		var aLi = oStar.getElementsByTagName("li");
		var oUl = oStar.getElementsByTagName("ul")[0];
		var oSpan = oStar.getElementsByTagName("span")[0];
		oSpan.innerHTML = "5 分";
		var i = iScore = iStar = 5;
		for (i = 1; i <= aLi.length; i++){
			aLi[i - 1].index = i;
			//鼠标移过显示分数
			aLi[i - 1].onmouseover = function (){
				//分数赋值
				iScore = this.index || iStar;
				for (i = 0; i < aLi.length; i++) aLi[i].className = i < iScore ? "on" : "";	
			};
			//鼠标离开后恢复上次评分
			aLi[i - 1].onmouseout = function (){
				iScore = iStar;
				for (i = 0; i < aLi.length; i++) aLi[i].className = i < iScore ? "on" : "";	
			};
			//点击后进行评分处理
			aLi[i - 1].onclick = function (){
				iStar = this.index;
				console.log(oSpan);
				oSpan.innerHTML = (this.index) + " 分";
			};
		}
	}
	
	function bindPageEvent(){
		
		// 绑定FAQ常见问题按钮
		appUtils.bindEvent($(_pageId+" #a_faq"),function(){
			var webUrl = global.FAQurl;
			var param = {
				"url" : webUrl
			};
			shellPlugin.callShellMethod("webViewPlugin", null,null,param);
		});
		appUtils.bindEvent($(_pageId),function(){
			$(_pageId+" .header_icon").hide();
		});
		
		appUtils.bindEvent($(_pageId+" #a_setting"),function(event){
			$(_pageId+" .header_icon").toggle();
			event.stopPropagation();
		});
		
		appUtils.bindEvent($(_pageId+" #a_phone"),function(){
			utils.callKHRXPhone("4000-188-288");
		});
		
		appUtils.bindEvent($(_pageId+" #recommenderInfo"),function(){
			
			shellPlugin.callShellMethod("recommenderPlugin", null,null,null);
			
		});
		
		
				//注册一帐通
		appUtils.bindEvent($(_pageId+" a.icon_check2"),function(){
			$(this).toggleClass("checked");
			SynRegisterAccount();
		});
		
		//一帐通协议
		appUtils.bindEvent($(_pageId+" #linkProtocal"),function(){
			var webUrl = "https://member.pingan.com.cn/pinganone/pa/paoasp.screen?shbtn=1";
			var param = {
				"url" : webUrl
			}
			shellPlugin.callShellMethod("webViewPlugin", null,null,param);
		});
		
		appUtils.bindEvent($(_pageId+" .header .icon_back"),function(){
			appUtils.pageBack();
		});
		
		appUtils.bindEvent($(_pageId+" .fix_bot .ct_btn"),function(){
			shellPlugin.callShellMethod("closeAppPlugin",null,null,{});
		});
		
		if(gconfig.platform == 2 || gconfig.platform == 3)
		{
			appUtils.bindEvent($(_pageId+" #btn_download"),function(){
				var webViewParam = 
				{
				"url" : "http://itunes.apple.com/cn/app/ane-li-cai-gao-duan-ban/id636344719?mt=8"
				};
				shellPlugin.callShellMethod("webViewPlugin",null,null,webViewParam);
			});
		}
		else
		{
			appUtils.bindEvent($(_pageId+" #btn_download"),function(){
				shellPlugin.callShellMethod("startThirdAppPlugin",null,null,{});
			});
		}

	}
	
	function destroy(){
		
	}
	
	var accountResult = {
		"init" : init,
		"bindPageEvent" : bindPageEvent,
		"destroy" : destroy
	};
	
	module.exports = accountResult;
});