﻿/**
 * 新开户(转户)须知
 */
define("project/scripts/account/openAccount", function(require, exports, module) {
	var appUtils = require("appUtils"),
		shellPlugin = require("plugins/native/scripts/native"),
		gconfig = require("gconfig"),
		global = gconfig.global,
		currVersion = null, // 当前版本号
		layerUtils = require("layerUtils"),
		utils = require("utils"),
		imagesPath = gconfig.imagesPath,
		exceptBankId = ["5001", "5002", "12", "7", "2"],
		exceptBankName = ["上海银行", "兴业银行", "招商银行", "建设银行"],
		_pageId = "#account_openAccount";

	function init() {
		// 解决 iPhone 4 和 iPhone 4s 页面不在一屏的问题
		if ($(document).height() > $(window).height()) {
			$(_pageId + " .ness_box").css("padding", "10px");
			$(_pageId + " .main").css("padding-bottom", "5px");
		}
		//新添加begin
		if (global.orgnizationNo != "") {
			//新添加 隐藏银行卡提示
			//$(_pageId+" .tip_1").css("display","none");
			//$(_pageId+" .zc_bankfixed").css("display","none");
			//$(_pageId+" .zc_banklist").css("display","none");
			//调用专属的logo
			showOwnBank(global.orgnizationNo);
			if (global.orgnizationNo == "5000" || global.orgnizationNo == "5100" || global.orgnizationNo == "5900") {
				//建行直接跳转到openAccount页面 ,传入welcome的参数
				appUtils.setSStorageInfo("_isStarted", "true");
				appUtils.setSStorageInfo("login_flag", "0");
				//弹出式广告
				showAds();
			}
		} //新添加end
		else {
			initBanks();
		}
		if (appUtils.getSStorageInfo("login_flag") == "1") {
			$(_pageId + " .zhuyi").hide();
		} else {
			$(_pageId + " .zhuyi").show();
		}
	}

	//公告弹窗
	function showAds() {
		$.ajax({
			type: "get",
			async: false,
			//url : "http://sis-pa18-content.paic.com.cn/main/huodong/khgg/khad.jsonp",  //生产
			url: "http://10.25.153.175:30088/main/huodong/khgg/khad.jsonp", //FAT     
			dataType: "jsonp",
			jsonp: "callback",
			jsonpCallback: "getAd",
			success: function(ads) {
				if (ads) {
					var endFlag = true;
					if (ads.endDate != "") {
						var endDateT = ads.endDate.replace(/-/g, "/");
						var currDate = new Date();
						var endDate = new Date(endDateT);
						if (endDate < currDate) {
							endFlag = false;
						}
					}
					//在日期范围内，且包含当前渠道channel：5：app 6：pc  7.保单app 8.新开web 9.保单web
					var channelArr = ads.channel.split(",");
					if (jQuery.inArray("5", channelArr) != -1 && endFlag) {
						var adsContent = "<div id='adsContent' style='padding:0 20px;color:#ccc;'>" + ads.content + "<div style='text-align:right;margin-top:10px;'>" + ads.footer + "</div></div>";
						layerUtils.iAlert(ads.title + adsContent, '', '', "知道了");
						var resetCss = setInterval(function() {
							if ($("#adsContent").length > 0) {
								if ($("#adsContent").height() > 66) {
									$("#adsContent").css("text-align", "left");
								}
								clearInterval(resetCss);
							}
						}, 10);
					}
				}
			}
		});
	}

	function isShown(bankId) {
		console.log();
		if (exceptBankId == null || exceptBankId.length <= 0) {
			return true;
		}
		for (var i = 0; i < exceptBankId.length; i++) {
			if ((appUtils.getSStorageInfo("login_flag") == "1") && (exceptBankId[i] == bankId)) {
				return false;
			}
		}
		return true;
	}

	function filterBanks(results) {
		if (results == null || results.length <= 0) {
			return;
		}
		for (var i = 0; i < results.length; i++) {
			if (!isShown(results[i].id)) {
				results.remove(i);
				i--;
			}
		}
	}

	function bindPageEvent() {
		// 绑定FAQ常见问题按钮
		appUtils.bindEvent($(_pageId + " #a_faq"), function() {
			var webUrl = global.FAQurl;
			var param = {
				"url": webUrl
			};
			shellPlugin.callShellMethod("webViewPlugin", null, null, param);
		});
		appUtils.bindEvent($(_pageId), function() {
			$(_pageId + " .header_icon").hide();
		});

		appUtils.bindEvent($(_pageId + " #a_setting"), function(event) {
			$(_pageId + " .header_icon").toggle();
			event.stopPropagation();
		});

		appUtils.bindEvent($(_pageId + " #a_phone"), function() {
			utils.callKHRXPhone("4000-188-288");
		});

		appUtils.bindEvent($(_pageId + " #recommenderInfo"), function() {

			shellPlugin.callShellMethod("recommenderPlugin", null, null, null);

		});

		appUtils.bindEvent($(_pageId + " .header .icon_back"), function() {
			appUtils.pageBack();
		});

		appUtils.bindEvent($(_pageId + " .fix_bot .ct_btn"), function() {
			appUtils.pageInit("account/openAccount", "account/msgVerify", {});
		});
	}

	function initBanks() {
		showBank();
	}

	function showBank() {
		var queryParam = {
			"funcNo": "1001002",
		};
		if (appUtils.getSStorageInfo("login_flag") == "1") {
			queryParam.opacctkind_flag = 1;
		}
		appUtils.invokeServer(global.serverPath, queryParam, function(data) {
			if (data.error_no == 0) {
				$(_pageId + " .zc_banklist").html("");
				if (data.results.length > 0) {
					var results = data.results;
					//filterBanks(results);
					var length = results.length;
					var itemElement = "";
					var num = 0;
					for (var i = 0; i < length; i++) {
						var bankId = results[i].id;
						var bankName = results[i].bankname;
						var bankImage = imagesPath + "bank/bk_" + bankId + ".png";
						itemElement += "<li> <div class=\"pic\"><img src='" + bankImage + "'></div><p>" + bankName + "</p></li>";
						num++;
					}
					if (num <= 5) {
						$(_pageId + " .zc_banklist").css("width", "100%");
					} else {
						$(_pageId + " .zc_banklist").css("width", num * 100 / 5 + "%");
					}
					$(_pageId + " .zc_banklist").html(itemElement);
				} else {
					layerUtils.iAlert("获取所支持的银行卡失败，请稍后重试！");
				}
			}
		});
	}

	function showOwnBank(orgnizationNoTemp) {
		var queryParam = {
			"funcNo": "1001002",
		};
		if (appUtils.getSStorageInfo("login_flag") == "1") {
			queryParam.opacctkind_flag = 1;
		}
		appUtils.invokeServer(global.serverPath, queryParam, function(data) {
			if (data.error_no == 0) {
				$(_pageId + " .zc_banklist").html("");
				if (data.results.length > 0) {
					var results = data.results;
					//filterBanks(results);
					var length = results.length;
					var itemElement = "";
					var num = 0;
					for (var i = 0; i < length; i++) {
						var bankId = results[i].id;
						var bankName = results[i].bankname;
						var bankImage = imagesPath + "bank/bk_" + bankId + ".png";
						if (orgnizationNoTemp == results[i]["ext_org"]) {
							itemElement += "<li> <div class=\"pic\"><img src='" + bankImage + "'></div><p>" + bankName + "</p></li>";
							num++;
						}
					}
					if (num <= 5) {
						$(_pageId + " .zc_banklist").css("width", "100%");
					} else {
						$(_pageId + " .zc_banklist").css("width", num * 100 / 5 + "%");
					}
					$(_pageId + " .zc_banklist").html(itemElement);
				} else {
					layerUtils.iAlert("获取所支持的银行卡失败，请稍后重试！");
				}
			}
		});
	}


	function destroy() {}

	var openAccount = {
		"init": init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};

	module.exports = openAccount;
});