/**
 * 填写个人信息
 */
define(function(require, exports, module) {
	var appUtils = require("appUtils"),
		global = require("gconfig").global,
		layerUtils = require("layerUtils"),
		shellPlugin = require("plugins/native/scripts/native"),
		validatorUtil = require("validatorUtil"),
		utils = require("utils"),
		_pageId = "#account_personInfo";

	function init() {
		getRecommender();
		fillDataByInParam();
	}

	function fillDataByInParam() {
		$(_pageId + " #name").val(appUtils.getPageParam("custname"));
		$(_pageId + " #idCardNo").val(appUtils.getPageParam("idNo"));
		$(_pageId + " #signDepartment").val(appUtils.getPageParam("policeorg"));
		// 证件地址
		$(_pageId + " #idCardAddress").val(appUtils.getPageParam("native"));
		// 联系地址和证件地址设置相同的
		$(_pageId + " #address").val(appUtils.getPageParam("native"));
		$(_pageId + " #idBeginDate").val(appUtils.getPageParam("idBeginDate"));
		$(_pageId + " #idEndDate").val(appUtils.getPageParam("idEndDate"));
		$(_pageId + " #zipCode").val(appUtils.getPageParam("zipCode"));
		//如果已有推荐人编码，则不用再查询
		if ($(_pageId + " #recommenderNo").val() == "") {
			getRecoInfo();
		}
		fillOccupation();
	}
	/**
	 * 获取app中的推荐人信息并显示
	 */
	function getRecommender() {
		shellPlugin.callShellMethod("getRecommenderPlugin", function(data) {
			// 回调数据中的 data 是字符串，需解析
			if (typeof(data) == "string") {
				data = JSON.parse(data);
			}
			if (data.recommenderName != "") {
				$(_pageId + " #recommenderName").val(data.recommenderName).attr("readonly", true);
				$(_pageId + " #recommenderNo").val(data.recommenderNo).attr("readonly", true);
			}
		}, null, null);
	}

	/**
	 @author zhengjinguang
	 @date 2015-02-11
	 增加显示推荐人的信息功能
	 */
	function getRecoInfo() {
		var attr = {
			funcNo: "600003",
			customer_mobile_number: appUtils.getSStorageInfo("mobileNo")
		};
		appUtils.invokeServer(global.serverPath, attr, function(data) {
			if (data.error_no == "0") {
				if (data.results.length > 0) { //有数据的情况下
					$(_pageId + " #recommenderName").val(data.results[0].name).attr("readonly", true);
					$(_pageId + " #recommenderNo").val(data.results[0].code + data.results[0].commission_rate).attr("readonly", true);
					//$(_pageId + " #recommenderName").val(data.results[0].name);
					//$(_pageId + " #recommenderNo").val(data.results[0].code + data.results[0].commission_rate);
				} else { //没有数据
					//console.log("没有推荐人");
					setRecommendInfo();
				}
			} else {
				layerUtils.iLoading(false);
				layerUtils.iAlert(data.error_info);
			}
		});
	}

	/* 预绑定选择职业的事件 */
	function BindSelectOccupation(i) {
		appUtils.bindEvent($(_pageId + " #occupation0" + i), function(e) {
			$(_pageId + " #selectOccupation").attr("value", $(this).attr("value"));
			//绑定点击确定
			$(_pageId + " #selectOccupation").text($(this).text());
			$(_pageId + " .sel_list:eq(0)").slideUp("fast");
			// 隐藏选择学历列表
			e.stopPropagation();
			// 阻止冒泡
		});
	}

	/*  预绑定选择学历的事件 */
	function BindSelectDegree(i) {
		appUtils.bindEvent($(_pageId + " #degree0" + i), function(e) {
			$(_pageId + " #selectDegree").attr("value", $(this).attr("value"));
			$(_pageId + " #selectDegree").text($(this).text());
			$(_pageId + " .sel_list:eq(1)").slideUp("fast");
			// 隐藏选择学历列表
			e.stopPropagation();
			// 阻止冒泡
		});
	}

	/*  预绑定选择行业的事件 */
	function BindSelectProfession(i) {
		appUtils.bindEvent($(_pageId + " #profession0" + i), function(e) {
			$(_pageId + " #selectProfession").attr("value", $(this).attr("value"));
			$(_pageId + " #selectProfession").text($(this).text());
			$(_pageId + " .sel_list:eq(3)").slideUp("fast");
			// 隐藏选择营业部列表
			e.stopPropagation();
			// 阻止冒泡
			// 获取行业代码  根据行业代码查询此行业内的职业放到职业栏
			var ProFessionCode = $(_pageId + " #selectProfession").val();
			var ProFessionParam = {
				"funcNo": 1001024,
				"tradeCode": ProFessionCode,
				"clientinfo": appUtils.getSStorageInfo("clientinfo"),
				"jsessionid": appUtils.getSStorageInfo("jsessionid")
			};
			appUtils.invokeServer(global.serverPath, ProFessionParam, function(data) {
				if (data.error_no == 0) {
					var occupational = data.results;
					// 首先移除数据
					$(_pageId + " .sel_list:eq(0) ul li").remove();
					for (var i = 0; i < occupational.length; i++) {
						var str = "<li><span id='occupation0" + i + "' value='" + occupational[i].item_value + "'>" + occupational[i].item_name + "</span></li>";
						$(_pageId + " .sel_list:eq(0) ul").append(str);
						BindSelectOccupation(i);
						// 预绑定选择职业的事件
					}
					$(_pageId + " #selectOccupation").attr("value", $(_pageId + " #sel_job ul li:eq(0) span").attr("value"));
					$(_pageId + " #selectOccupation").text($(_pageId + " #sel_job ul li:eq(0)").text());
				} else {
					layerUtils.iLoading(false);
					layerUtils.iAlert(data.error_info);
				}
			});
		});
	}

	/*  预绑定选择营业部的事件 */
	function BindSelectBranch(i) {
		appUtils.bindEvent($(_pageId + " #branch0" + i), function(e) {
			$(_pageId + " #selectBranch").attr("value", $(this).attr("value"));
			$(_pageId + " #selectBranch").text($(this).text());
			$(_pageId + " .sel_list:eq(2)").slideUp("fast");
			// 隐藏选择营业部列表
			e.stopPropagation();
			// 阻止冒泡
		});
	}

	function setRecommendInfo() {
		var recommenderNo = global.recommenderNo;
		if (recommenderNo != "" && $(_pageId + " #recommenderNo").val() == "") {
			$(_pageId + " #recommenderNo").val(recommenderNo).attr("readonly", true);
			$(_pageId + " #recommenderName").attr("readonly", true);
			//$(_pageId + " #recommenderNo").val(recommenderNo);
		}
	}

	//最长不超过25个汉字或50个字符
	function deteRecomm() {
		var recommTemp = $(_pageId + " #recommenderName").val();
		var lengthT = $(_pageId + " #recommenderName").val().length;
		if (getStrLength(recommTemp) > 50) {
			var recomName = "";
			var sum = 0;
			for (i = 0; i < recommTemp.length; i++) {
				if ((recommTemp.charCodeAt(i) >= 0) && (recommTemp.charCodeAt(i) <= 255))
					sum = sum + 1;
				else
					sum = sum + 2;
				if (sum > 50) {
					break;
				} else {
					recomName += recommTemp.charAt(i);
				}
			}
			$(_pageId + " #recommenderName").val(recomName);
		}
	}

	function bindPageEvent() {
		// 绑定FAQ常见问题按钮
		appUtils.bindEvent($(_pageId + " #a_faq"), function() {
			var webUrl = global.FAQurl;
			var param = {
				"url": webUrl
			};
			shellPlugin.callShellMethod("webViewPlugin", null, null, param);
		});
		appUtils.bindEvent($(_pageId), function() {
			$(_pageId + " .header_icon").hide();
		});

		appUtils.bindEvent($(_pageId + " #a_setting"), function(event) {
			$(_pageId + " .header_icon").toggle();
			event.stopPropagation();
		});

		appUtils.bindEvent($(_pageId + " #a_phone"), function() {
			utils.callKHRXPhone("4000-188-288");
		});

		appUtils.bindEvent($(_pageId + " #recommenderInfo"), function() {

			shellPlugin.callShellMethod("recommenderPlugin", null, null, null);

		});


		//setRecommendInfo();
		// 绑定推荐人不可修改  渠道-同花顺（THS）  渠道-hanjunjie299  百度-SEM-BAIDU2015 AD-china渠道包-INAPP-ADCHINA2015
		//		$(_pageId+" #recommenderNo").val("LJS2015");
		//		$(_pageId+" #recommenderNo").removeAttr("readonly");

		// 绑定选择日期的事件
		appUtils.bindEvent($(_pageId + " input[date-plugin='true']"), function() {
			utils.selectDate(this);
		});

		//推荐人姓名最长不超过25个汉字或50个字符
		appUtils.bindEvent($(_pageId + " #recommenderName"), function() {
			deteRecomm();
		}, "keyup");

		//推荐人姓名最长不超过25个汉字或50个字符
		appUtils.bindEvent($(_pageId + " #recommenderName"), function() {
			deteRecomm();
		}, "blur");


		// 绑定身份证点击事件
		//		$(_pageId+" #idCardNo").removeAttr("readonly");
		appUtils.bindEvent($(_pageId + " #idCardNo"), function() {
			layerUtils.iMsg(-1, "身份证号不可更改！");
		});

		// 邮编格式的提示
		appUtils.bindEvent($(_pageId + " #zipCode"), function() {
			var zipCode = $(_pageId + " #zipCode").val();
			if (zipCode.length != 6 || !validatorUtil.isNumeric(zipCode)) {
				layerUtils.iMsg(-1, "请输入正确的邮编");
				return false;
			}
			if (zipCode == "000000") {
				layerUtils.iMsg(-1, "请输入正确的邮编");
				return false;
			}
		}, "blur");

		appUtils.bindEvent($(_pageId + " #zipCode"), function() {
			utils.dealIPhoneMaxLength(this, 6);
		}, "input");

		appUtils.bindEvent($(_pageId + " #address"), function() {
			// 查询邮编
			var zipCodeParam = {
				"funcNo": 501557,
				"addr": $(this).val(),
				"clientinfo": appUtils.getSStorageInfo("clientinfo"),
				"jsessionid": appUtils.getSStorageInfo("jsessionid")
			};
			appUtils.invokeServer(global.serverPath, zipCodeParam, function(data) {
				if (data.error_no == 0 && data.results[0]) {
					$(_pageId + " #zipCode").val(data.results[0].post);
				}
			});
		}, "blur");

		appUtils.bindEvent($(_pageId + " .header .icon_back"), function() {
			appUtils.pageBack();
		});

		/* 点击页面其他元素隐藏下拉列表 */
		appUtils.bindEvent($(_pageId), function(e) {
			// 隐藏下拉列表
			$(_pageId + " .sel_list").slideUp("fast");
			e.stopPropagation();
		});

		/* 选择职业 */
		appUtils.bindEvent($(_pageId + " #selectOccupation"), function(e) {
			if ($(_pageId + " .sel_list:eq(0) ul li").length == 0) {
				fillOccupation();
			}
			$(_pageId + " .sel_list").slideUp("fast");
			$(_pageId + " .sel_list:eq(0)").slideDown("fast");
			// 显示选择职业的下拉列表
			e.stopPropagation();
		});

		/* 根据推荐人身份证查询推荐人手机号*/
		appUtils.bindEvent($(_pageId + " #recommenderNo"), function(e) {
			var recommenderNo = $(this).val();
			if (recommenderNo && (recommenderNo.length == 15 || recommenderNo.length == 18)) {
				queryBranch(recommenderNo);
			}
		}, "blur");

		// 推荐人身份证15或18位控制
		//		appUtils.bindEvent($(_pageId+" #recommenderNo"),function(e){
		//			var idnoLen = $(_pageId+" #recommenderNo").val().length;
		//			if(idnoLen!=15 && idnoLen!=18 && idnoLen!=0){
		//				layerUtils.iMsg(-1,"请输入15位或18位的正确号码");
		//			}
		//		},"blur");

		/* 选择学历 */
		appUtils.bindEvent($(_pageId + " #selectDegree"), function(e) {
			if ($(_pageId + " .sel_list:eq(1) ul li").length == 0) {
				fillDegree();
			}
			$(_pageId + " .sel_list").slideUp("fast");
			$(_pageId + " .sel_list:eq(1)").slideDown("fast");
			// 显示选择学历的下拉列表
			e.stopPropagation();
		});

		/* 选择营业部 */
		appUtils.bindEvent($(_pageId + " #selectBranch"), function(e) {
			if ($(_pageId + " .branch ul li").length == 0) {
				fillBranch();
			}
			$(_pageId + " .sel_list").slideUp("fast");
			$(_pageId + " .branch").slideDown("fast");
			// 显示选择营业部的下拉列表
			e.stopPropagation();
		});

		/*选择行业*/
		appUtils.bindEvent($(_pageId + " #selectProfession"), function(e) {
			if ($(_pageId + " .profession ul li").length == 0) {
				fillProfession();
			}
			$(_pageId + " .sel_list").slideUp("fast");
			$(_pageId + " .profession").slideDown("fast");
			// 显示选择行业的下拉列表
			e.stopPropagation();
		});

		/* 绑定下一步 */
		appUtils.bindEvent($(_pageId + " .fix_bot .ct_btn"), function() {

			var Ustatus = "",
				Uname = "",
				Ubaranch = "";

			// 校验数据
			if (verifyInfo()) {
				var recommenderNo = trimAll(ToCDB($(_pageId + " #recommenderNo").val()), "g");
				var checkRecommenderNo = {
					"funcNo": 1001027,
					"umNum": recommenderNo,
					"clientinfo": appUtils.getSStorageInfo("clientinfo"),
					"jsessionid": appUtils.getSStorageInfo("jsessionid")
				};
				appUtils.invokeServer(global.serverPath, checkRecommenderNo, function(data) {

					var name = $(_pageId + " #name").val(),
						idaddres = $(_pageId + " #idCardAddress").val(),
						idCardNo = $(_pageId + " #idCardNo").val();
					var addhtml = "<br>姓名：<span style='color:blue;font-weight:bold;'>" + name + "</span><br>身份证号码：" + idCardNo + "<br>地址：" + idaddres;

					if (data.error_no == 0) {
						layerUtils.iLoading(false);
						Ustatus = data.results[0].status;
						Uname = data.results[0].name;
						Ubranch = data.results[0].branch;

						if (Ustatus == "0") {
							layerUtils.iConfirm("温馨提示：<br>您输入的推荐人编号查不到对应信息，请确认。", function() {
								if (appUtils.getSStorageInfo("needPhoto") == 1) {
									appUtils.pageInit("account/personInfo", "account/accountResult", {});
									return;
								}
								idCardIsUsed();
							}, null);
						} else if (Ustatus == "1") {
							layerUtils.iConfirm("温馨提示：<br>1.因信息来源于图片识别&nbsp;,&nbsp;请确认信息是否准确。" + addhtml + "<br>2.您输入的营销员是 <span style='font-weight:bold'>" + Ubranch + " </span>的 <span style='font-weight:bold'>" + Uname + " </span>，是否确认营销关系？", function() {
								if (appUtils.getSStorageInfo("needPhoto") == 1) {
									appUtils.pageInit("account/personInfo", "account/accountResult", {});
									return;
								}
								idCardIsUsed();
							}, null);
						} else if (Ustatus == "2") {
							layerUtils.iConfirm("温馨提示：<br>1.因信息来源于图片识别&nbsp;,&nbsp;请确认信息是否准确。" + addhtml + "<br>2.您输入的推荐人是 <span style='font-weight:bold'>" + Uname + " ，请确认。", function() {
								if (appUtils.getSStorageInfo("needPhoto") == 1) {
									appUtils.pageInit("account/personInfo", "account/accountResult", {});
									return;
								}
								idCardIsUsed();
							}, null);
						} else if (Ustatus == "3") {
							layerUtils.iConfirm("温馨提示：<br>因信息来源于图片识别&nbsp;,&nbsp;请确认信息是否准确。" + addhtml, function() {
								if (appUtils.getSStorageInfo("needPhoto") == 1) {
									appUtils.pageInit("account/personInfo", "account/accountResult", {});
									return;
								}
								idCardIsUsed();
							}, null);

						} else {
							layerUtils.iAlert("网络异常，请稍后重试!", -1);
						}

					}
				}, false);

			}
		});

	}

	function idCardIsUsed() {
		// 身份证要有存在性判断，一张身份证只能开户一次
		var idCardExistParam = {
			"funcNo": 501527,
			"idtype": "00",
			"idno": $(_pageId + " #idCardNo").val(),
			"clientinfo": appUtils.getSStorageInfo("clientinfo"),
			"jsessionid": appUtils.getSStorageInfo("jsessionid")
		};
		appUtils.invokeServer(global.serverPath, idCardExistParam, function(data) {
			if (data.error_no == 0 && data.results[0].client_id.length != 0) {
				layerUtils.iLoading(false);
				layerUtils.iAlert("您的身份证号已被使用，请换张身份证重试!", -1);
			} else if (data.error_no == 0 && data.results[0].client_id.length == 0) {
				// 提交数据
				var submitDataParam = setSubmitData();
				appUtils.invokeServer(global.serverPath, submitDataParam, function(data) {
					if (data.error_no == 0) {
						switchPage();
					} else {
						layerUtils.iLoading(false);
						layerUtils.iAlert(data.error_info);
					}
				}, false);
			}
		}, false);
	}

	function switchPage() {
		if (appUtils.getSStorageInfo("idCardNo") == null) {
			appUtils.setSStorageInfo("idCardNo", $(_pageId + " #idCardNo").val());
		}
		// 将姓名保存到 session 中，用于问卷回访页面展示姓名
		appUtils.setSStorageInfo("custname", $(_pageId + " #name").val());
		// 将营业部编号保存到 session 中
		appUtils.setSStorageInfo("branchNo", $(_pageId + " #selectBranch").val());
		appUtils.pageInit("account/personInfo", "account/signProtocol", {});
	}

	//var regHan="^[\u4E00-\u9FFF-A-Za-z0-9-\-]+$";
	function validateWords(words) {
		//var reg=new RegExp(regHan);
		//if(reg.test(words)){
		if (words.indexOf(">") > 0 || words.indexOf("<") > 0 || words.indexOf("\n") > 0 || words.indexOf("%") > 0 || words.indexOf("×") > 0 || words.indexOf("÷") > 0 || words.indexOf("+") > 0 || words.indexOf("_") > 0 || words.indexOf("{") > 0 || words.indexOf("}") > 0 || words.indexOf("[") > 0 || words.indexOf("]") > 0) {
			return true;
		} else {
			return false;
		}
	}

	/**
	 *  获取字符串长度，按字符计算
	 */
	function getStrLength(strTemp) {
		var i, sum = 0;
		if (strTemp) {
			for (i = 0; i < strTemp.length; i++) {
				if ((strTemp.charCodeAt(i) >= 0) && (strTemp.charCodeAt(i) <= 255))
					sum = sum + 1;
				else
					sum = sum + 2;
			}
		}

		return sum;
	}

	function verifyInfo() {
		var name = $(_pageId + " #name").val(),
			idCardNo = $(_pageId + " #idCardNo").val(),
			signDepartment = $(_pageId + " #signDepartment").val(),
			idCardAddress = $(_pageId + " #idCardAddress").val(),
			address = $(_pageId + " #address").val(),
			idBeginDate = $(_pageId + " #idBeginDate").val().replace(/-/g, "/"),
			idEndDate = $(_pageId + " #idEndDate").val().replace(/-/g, "/"),
			zipCode = $(_pageId + " #zipCode").val(),
			selectOccupation = $(_pageId + " #selectOccupation").text(),
			selectDegree = $(_pageId + " #selectDegree").text(),
			selectProfession = $(_pageId + " #selectProfession").text(),
			idnoLen = $.trim($(_pageId + " #recommenderNo").val()).length,
			nowDate = new Date();
		var ExgDate = nowDate.getTime();
		// 获取当前时间

		if (name == "") {
			layerUtils.iMsg(-1, "姓名不能为空");
			return false;
		}
		if (idCardNo == "") {
			layerUtils.iMsg(-1, "身份证不能为空");
			return false;
		}
		// 验证身份证的格式
		var isIdCardResult = utils.isIdCardNo(idCardNo);
		if (!isIdCardResult || typeof(isIdCardResult) == "string") {
			layerUtils.iMsg(-1, "请输入正确的身份证号码!");
			return false;
		}
		if (signDepartment == "") {
			layerUtils.iMsg(-1, "签发机关不能为空");
			return false;
		}
		if (idCardAddress == "") {
			layerUtils.iMsg(-1, "证件地址不能为空");
			return false;
		}
		if (address == "") {
			layerUtils.iMsg(-1, "联系地址不能为空");
			return false;
		}
		if (idBeginDate == "") {
			layerUtils.iMsg(-1, "身份证起始期限不能为空");
			return false;
		}
		if (idEndDate == "") {
			layerUtils.iMsg(-1, "身份证结束期限不能为空");
			return false;
		}
		if (zipCode == "") {
			layerUtils.iMsg(-1, "邮编不能为空");
			return false;
		} else if (zipCode.length != 6 || !validatorUtil.isNumeric(zipCode)) {
			layerUtils.iMsg(-1, "请输入正确的邮编");
			return false;
		} else if (zipCode == "000000") {
			layerUtils.iMsg(-1, "请输入正确的邮编");
			return false;
		}
		if (selectOccupation == "请选择职业") {
			layerUtils.iMsg(-1, "职业不能为空");
			return false;
		}
		if (selectDegree == "请选择学历") {
			layerUtils.iMsg(-1, "学历不能为空");
			return false;
		}
		if (selectProfession == "请选择行业") {
			layerUtils.iMsg(-1, "请选择行业");
			return false;
		}
		//证件地址必须超过12个字符
		if (getStrLength(idCardAddress) < 12) {
			layerUtils.iMsg(-1, "您的“证件地址”字数太少，请与身份证核对并修改！");
			return false;
		}
		if (idCardAddress.length > 64) {
			layerUtils.iMsg(-1, "证件地址长度不能大于&nbsp;64&nbsp;位");
			return false;
		}
		if (address.length < 10) {
			layerUtils.iMsg(-1, "联系地址长度不能小于&nbsp;10&nbsp;位");
			return false;
		}
		if (address.length > 64) {
			layerUtils.iMsg(-1, "联系地址长度不能大于&nbsp;64&nbsp;位");
			return false;
		}
		// 验证有效期的格式
		if (!validatorUtil.isDate(idBeginDate)) {
			layerUtils.iMsg(-1, "有效期的起始时间不符合格式!");
			return false;
		}
		if (!validatorUtil.isDate(idEndDate)) {
			layerUtils.iMsg(-1, "有效期的结束时间不符合格式!");
			return false;
		}
		if (Date.parse(idBeginDate) > Date.parse(idEndDate)) {
			layerUtils.iMsg(-1, "有效期的起始时间不能大于结束时间");
			return false;
		}
		var currentDate = new Date();
		/*有效期的开始日期，结束日期不能大于或等于今天*/
		var bDate = idBeginDate.split('/');
		var eDate = idEndDate.split('/');
		var eqbDate = (currentDate.getFullYear() == bDate[0] && currentDate.getMonth() + 1 == bDate[1] && currentDate.getDate() == bDate[2]);
		var eqeDate = (currentDate.getFullYear() == eDate[0] && currentDate.getMonth() + 1 == eDate[1] && currentDate.getDate() == eDate[2]);
		if (eqbDate || Date.parse(currentDate) < Date.parse(idBeginDate)) {
			layerUtils.iMsg(-1, "有效期的起始时间不能大于或等于当前日期");
			return false;
		}
		if (eqeDate || Date.parse(idEndDate) < ExgDate) {
			layerUtils.iMsg(-1, "有效期的结束时间不能小于或等于当前日期");
			return false;
		}
		var beginMonth = new Date(idBeginDate).getMonth(),
			beginDay = new Date(idBeginDate).getDate(),
			endMonth = new Date(idEndDate).getMonth(),
			endDay = new Date(idEndDate).getDate();
		//		if(beginMonth != endMonth || beginDay != endDay)
		//		{
		//			layerUtils.iMsg(-1,"证件有效期开始的月和日必须与结束的月和日保持一致");
		//			return false;
		//		}
		// 对不满 18 周岁进行控制
		// 只考虑 18 为身份证
		if (idCardNo.length == 18) {
			var dateStr = idCardNo.substring(6, 10) + "/" + idCardNo.substring(10, 12) + "/" + idCardNo.substring(12, 14),
				userAge = new Date().getTime() - Date.parse(dateStr);
			userAge = userAge / (365 * 24 * 60 * 60 * 1000);
			if (parseInt(userAge) < 18) {
				layerUtils.iAlert("您的年龄未满 18 周岁，不允许开户!", -1);
				return false;
			}
		}
		if (validateWords(name)) {
			layerUtils.iAlert("姓名有异常字符，请修正后在提交!", -1);
			return false;
		}
		if (validateWords(signDepartment)) {
			layerUtils.iAlert("签发机关有异常字符，请修正后在提交!", -1);
			return false;
		}
		if (validateWords(idCardAddress)) {
			layerUtils.iAlert("证件地址有异常字符，请修正后在提交!", -1);
			return false;
		}
		if (validateWords(address)) {
			layerUtils.iAlert("联系地址有异常字符，请修正后在提交!", -1);
			return false;
		}
		// 对15或18位身份证控制
		//			if(idnoLen!=15 && idnoLen!=18 && idnoLen!=0){
		//				layerUtils.iMsg(-1,"请输入15位或18位的推荐人号码");
		//				return false;
		//			}

		//		    var reg =/^[0-9a-zA-Z]*$/g;
		//		    if (reg.test($.trim($(_pageId+" #recommenderNo").val()))){
		//		        var reg1 = new RegExp("^[0-9]$");
		//		        var reg2 = new RegExp("^[0-9]*$");
		//		        var recIndex = $.trim($(_pageId+" #recommenderNo").val()).substring(0,1);
		//		        if(reg1.test(recIndex)){
		//		            if(idnoLen!=10 || !reg2.test($.trim($(_pageId+" #recommenderNo").val()))){
		//		                layerUtils.iMsg(-1,"推荐人编号格式不正确");
		//		                return false;
		//		            }
		//		        }
		//		    }else{
		//		        layerUtils.iMsg(-1,"推荐人编号格式不正确");
		//		        return false;
		//		    }

		var gloabexs = true;
		// 行业职业互斥判断
		var isExistParam = {
			"funcNo": 1001025,
			"tradeCode": $(_pageId + " #selectProfession").val(), // 行业
			"professionCode": $(_pageId + " #selectOccupation").val(), // 职业
			"clientinfo": appUtils.getSStorageInfo("clientinfo"),
			"jsessionid": appUtils.getSStorageInfo("jsessionid")
		};
		appUtils.invokeServer(global.serverPath, isExistParam, function(data) {
			if (data.error_no == 0) {
				var isexs = data.results[0].isexs;
				if ("false" == isexs) {
					gloabexs = false;
					layerUtils.iMsg(-1, "您选择的行业中未包括当前选择的职业，请重新选择职业。");
					return false;
				}
			} else {
				layerUtils.iAlert(data.error_info);
			}
		}, true, false);

		if (gloabexs) {
			$(_pageId + " #idCardNo").attr("borthday", idCardNo.substring(6, 10) + "-" + idCardNo.substring(10, 12) + "-" + idCardNo.substring(12, 14));
			return true;
		}

	}

	// add by sy 全角转半角字符
	function ToCDB(str) {
		var tmp = "";
		for (var i = 0; i < str.length; i++) {
			if (str.charCodeAt(i) > 65248 && str.charCodeAt(i) < 65375) {
				tmp += String.fromCharCode(str.charCodeAt(i) - 65248);
			} else {
				tmp += String.fromCharCode(str.charCodeAt(i));
			}
		}
		return tmp;
	}

	// add by sy 字符串去全空格（中间也去）
	function trimAll(str, is_global) {
		var result;
		result = str.replace(/(^\s+)|(\s+$)/g, "");
		result = result.replace(/[\u3000]/g, "");
		if (is_global.toLowerCase() == "g")
			result = result.replace(/\s/g, "");
		return result;
	}

	function destroy() {
		// 清理界面元素
		//		$(_pageId+" #name").val("");
		//		$(_pageId+" #idCardNo").val("");
		//		$(_pageId+" #signDepartment").val("");
		//		$(_pageId+" #idCardAddress").val("");
		//		$(_pageId+" #address").val("");
		//		$(_pageId+" #idBeginDate").val("");
		//		$(_pageId+" #idEndDate").val("");
		//		$(_pageId+" #zipCode").val("");
		//		$(_pageId+" #selectOccupation").text("请选择职业");
		//		$(_pageId+" #selectDegree").text("请选择学历");
		//		$(_pageId+" #selectProfession").text("请选择行业");
		//		$(_pageId+" #recommenderName").val("");
		//		$(_pageId+" #recommenderNo").val("");
		//		$(_pageId+" #selectBranch").text("请选择营业部");
	}

	// 根据推荐人身份证查询营业部编号
	function queryBranch(recommenderNo) {
		var queryBranchParam = {
			"funcNo": 1001001,
			"idno": recommenderNo,
			"userid": appUtils.getSStorageInfo("user_id"),
			"clientinfo": appUtils.getSStorageInfo("clientinfo"),
			"jsessionid": appUtils.getSStorageInfo("jsessionid")
		};
		appUtils.invokeServer(global.serverPath, queryBranchParam, function(data) {
			if (data.error_no == 0) {
				if (data.results[0] && data.results[0].branch_no.length > 0) {
					// 营业部编号
					var branchNo = data.results[0].branch_no,
						branchObj = $(_pageId + " .branch ul li span[value='" + branchNo + "']");
					$(_pageId + " #selectBranch").attr("value", branchNo);
					$(_pageId + " #selectBranch").text(branchObj.text());
				}
			} else {
				layerUtils.iAlert(data.error_info);
			}
		});
	}

	function fillOccupation() {
		// 获取职业
		var occupationalParam = {
			"funcNo": 501501,
			"enum_type": "occupational",
			"clientinfo": appUtils.getSStorageInfo("clientinfo"),
			"jsessionid": appUtils.getSStorageInfo("jsessionid")
		};
		appUtils.invokeServer(global.serverPath, occupationalParam, function(data) {
			if (data.error_no == 0) {
				var occupational = data.results;
				// 首先移除数据
				$(_pageId + " .sel_list:eq(0) ul li").remove();
				for (var i = 0; i < occupational.length; i++) {
					var str = "<li><span id='occupation0" + i + "' value='" + occupational[i].item_value + "'>" + occupational[i].item_name + "</span></li>";
					$(_pageId + " .sel_list:eq(0) ul").append(str);
					BindSelectOccupation(i);
					// 预绑定选择职业的事件
				}
				fillDegree();
			} else {
				layerUtils.iLoading(false);
				layerUtils.iAlert(data.error_info);
			}
		}, false);
	}

	function fillDegree() {
		// 获取学历
		var adapterParam = {
			"funcNo": 501501,
			"enum_type": "adapter",
			"clientinfo": appUtils.getSStorageInfo("clientinfo"),
			"jsessionid": appUtils.getSStorageInfo("jsessionid")
		};
		appUtils.invokeServer(global.serverPath, adapterParam, function(data) {
			if (data.error_no == 0) {
				// 首先移除原有的数据
				$(_pageId + " .sel_list:eq(1) ul li").remove();
				var adapter = data.results;
				for (var i = 0; i < adapter.length; i++) {
					var str = "<li><span id='degree0" + i + "' value='" + adapter[i].item_value + "'>" + adapter[i].item_name + "</span></li>";
					$(_pageId + " .sel_list:eq(1) ul").append(str);
					BindSelectDegree(i);
					// 预绑定选择学历的事件
				}
				fillProfession();
			} else {
				layerUtils.iLoading(false);
				layerUtils.iAlert(data.error_info);
			}
		}, false);
	}

	function fillProfession() {
		// 获取行业
		var professionParam = {
			"funcNo": 501501,
			"enum_type": "trade",
			"clientinfo": appUtils.getSStorageInfo("clientinfo"),
			"jsessionid": appUtils.getSStorageInfo("jsessionid")
		};
		appUtils.invokeServer(global.serverPath, professionParam, function(data) {
			if (data.error_no == 0) {
				var profession = data.results;
				// 首先移除原有的数据
				$(_pageId + " .sel_list:eq(3) ul li").remove();
				var adapter = data.results;
				for (var i = 0; i < adapter.length; i++) {
					var str = "<li><span id='profession0" + i + "' value='" + profession[i].item_value + "'>" + profession[i].item_name + "</span></li>";
					$(_pageId + " .sel_list:eq(3) ul").append(str);
					BindSelectProfession(i);
					// 预绑定选择行业的事件
				}
				fillBranch();
			} else {
				layerUtils.iLoading(false);
				layerUtils.iAlert(data.error_info);
			}
		}, false);
	}

	function fillBranch() {
		// 获取营业部
		var branchParam = {
			"funcNo": 501503,
			"clientinfo": appUtils.getSStorageInfo("clientinfo"),
			"jsessionid": appUtils.getSStorageInfo("jsessionid")
		};
		appUtils.invokeServer(global.serverPath, branchParam, function(data) {
			if (data.error_no == 0) {
				var branchStr = "",
					branchList = data.branchList;
				for (var i = 0; i < branchList.length; i++) {
					var str = "<li><span id='branch0" + i + "' value='" + branchList[i].branchcode + "'>" + branchList[i].branchname + "</span></li>";
					$(_pageId + " .sel_list:eq(2) ul").append(str);
					BindSelectBranch(i);
					// 预绑定选择学历的事件
				}
			} else {
				layerUtils.iAlert(data.error_info);
			}
		});
	}

	function setSubmitData() {
		if ($(_pageId + " #recommenderName").val() != "" && $(_pageId + " #recommenderName").val().length > 16) {
			var recommenderName = $(_pageId + " #recommenderName").val().substr(0, 16); //推荐人姓名
		} else {
			var recommenderName = $(_pageId + " #recommenderName").val(); //推荐人姓名
		}
		var param = {
			"funcNo": 501528,
			"user_id": appUtils.getSStorageInfo("user_id"),
			// 信息来源渠道，电脑、手机、平板 0：pc，2：pad，3：手机  数据字典定义
			"infocolect_channel": iBrowser.pc ? 0 : 3,
			// 证件类别，数据字典中定义的是 00
			"idtype": "00",
			"idno": $(_pageId + " #idCardNo").val(),
			"custname": $(_pageId + " #name").val(),
			"borthday": $(_pageId + " #idCardNo").attr("borthday"),
			"idbegindate": $(_pageId + " #idBeginDate").val(),
			"idenddate": $(_pageId + " #idEndDate").val(),
			// 证件地址
			"native": $(_pageId + " #idCardAddress").val(),
			// 签发机关
			"policeorg": $(_pageId + " #signDepartment").val(),
			// 用户性别，男 0 女 1
			"usersex": appUtils.getPageParam("gender") == "男" ? "0" : "1",
			// 国籍地区，必须写 156
			"nationality": "156",
			// 联系地址
			"addr": $(_pageId + " #address").val(),
			// 邮政编码
			"postid": $(_pageId + " #zipCode").val(),
			"edu": $(_pageId + " #selectDegree").val(),
			// 职业
			"profession_code": $(_pageId + " #selectOccupation").val(),
			"branchno": $(_pageId + " #selectBranch").val(),
			"provinceno": "",
			"cityno": "",
			"ipaddr": appUtils.getSStorageInfo("ip"),
			"macaddr": appUtils.getSStorageInfo("mac"),
			// 行业
			"profession": $(_pageId + " #selectProfession").val(),
			"recommender_name": recommenderName,
			"recommender_no": trimAll(ToCDB($(_pageId + " #recommenderNo").val()), "g"),
			"clientinfo": appUtils.getSStorageInfo("clientinfo"),
			"jsessionid": appUtils.getSStorageInfo("jsessionid")
		};
		return param;
	}

	var personInfo = {
		"init": init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};

	module.exports = personInfo;
});