/**
 * 设置密码
 */
define("project/scripts/account/setPwd",function(require, exports, module){ 
	var appUtils = require("appUtils"),
		global = require("gconfig").global,
		validatorUtil = require("validatorUtil"),
		shellPlugin = require("plugins/native/scripts/native"),
		layerUtils = require("layerUtils"),
		utils = require("utils"),
		_pageId = "#account_setPwd";
	
	function init(){
		window.getInput = getInput;
	}
	
	function bindPageEvent(){
		
		// 绑定FAQ常见问题按钮
		appUtils.bindEvent($(_pageId+" #a_faq"),function(){
			var webUrl = global.FAQurl;
			var param = {
				"url" : webUrl
			};
			shellPlugin.callShellMethod("webViewPlugin", null,null,param);
		});
		appUtils.bindEvent($(_pageId),function(){
			$(_pageId+" .header_icon").hide();
		});
		
		appUtils.bindEvent($(_pageId+" #a_setting"),function(event){
			$(_pageId+" .header_icon").toggle();
			event.stopPropagation();
		});
		
		appUtils.bindEvent($(_pageId+" #a_phone"),function(){
			utils.callKHRXPhone("4000-188-288");
		});
		
		appUtils.bindEvent($(_pageId+" #recommenderInfo"),function(){
			
			shellPlugin.callShellMethod("recommenderPlugin", null,null,null);
			
		});
		
		
//		appUtils.bindEvent($(_pageId+" input"),function(){
//			var keyboardParam = {
//					"isShow" : true,
//					"oldPwd" : $(this).val(),
//					"selector" : $(this).attr("id")
//				};
//			shellPlugin.callShellMethod("softKeyboardPlugin",null,null,keyboardParam);
//		}, "click");
//		
//		appUtils.bindEvent($(_pageId),function(){
//			var keyboardParam = {
//					"isShow" : false,
//					"oldPwd" : "",
//					"selector" : ""
//			};
//			shellPlugin.callShellMethod("softKeyboardPlugin",null,null,keyboardParam);
//		});
		
		appUtils.bindEvent($(_pageId+" .header .icon_back"),function(){
			appUtils.pageBack();
		});
		
		appUtils.bindEvent($(_pageId+" input"),function(){
			utils.dealIPhoneMaxLength(this,6);
		},"input");
		
		//是否设置资金密码与交易密码一致（隐藏显示）
		appUtils.bindEvent($(_pageId+" .mt15 .icon_check"),function(){
			$(_pageId+" .user_form h5:eq(1)").toggle();
			$(_pageId+" .user_form .circular:eq(1)").toggle();
			$(_pageId+" .user_form .mt10").toggle();
			$(this).toggleClass("checked");
		});
		
		// 密码框绑定失去焦点事件
		appUtils.bindEvent($(_pageId+" #pass1"),function(){
			validatePassword($(this));
		},"blur");
		
		appUtils.bindEvent($(_pageId+" #pass3"),function(){
			validatePassword($(this));
		},"blur");
		
		// 密码框绑定检验二次密码是否匹配事件
		appUtils.bindEvent($(_pageId+" #pass2"),function(){
			if(validatePassword($(this))){
				validateSecondPassword("1");
			}
		},"blur");
		
		appUtils.bindEvent($(_pageId+" #pass4"),function(){
			if(validatePassword($(this))){
				validateSecondPassword("2");
			}
		},"blur");
		
		//继续开户
		appUtils.bindEvent($(_pageId+" .ct_btn"),function(){
			if($(_pageId+" #pass2").attr("readonly"))
			{
				appUtils.pageInit("account/setPwd","account/thirdDepository",{});
				return;
			}
			
			// 对于密码只能输入数字的控制
			var	password1 =  $(_pageId+" #pass1").val().trim();
			var password3 =  $(_pageId+" #pass3").val().trim(); 
			if($(_pageId+" .mt15 .icon_check").hasClass("checked"))
			{
				if(!validatorUtil.isNumeric(password1)){
					layerUtils.iMsg(-1,"请输入6位数字密码");
					obj.val("");
					return;	
				}
			}else{
				if(!validatorUtil.isNumeric(password1) || !validatorUtil.isNumeric(password3)){
					layerUtils.iMsg(-1,"请输入6位数字密码");
					obj.val("");
					return;	
				}
			}
		
			if(validatePost()){
				//postPassword();//提交数据
				postPasswordTemp();//新版的数据
			}
		});
	}
	
	
	function destroy(){
		// 清理所有的密码框
//		$(_pageId+" .input_text input").val("");
		// 隐藏设置资金密码
//		$(_pageId+" .input_form:eq(1)").hide();
//		$(_pageId+" .user_form h5:eq(1)").hide();
//		$(_pageId+" .user_form .mt10").show();
//		$(_pageId+" .mt15 .icon_check").addClass("checked");
	}
	// 对外暴露的模块方法 end
	
	/***
	 * 密码提交时校验
	 */
	function validatePost()
	{
		var pass1 = $(_pageId+" #pass1").val().trim();
		var pass2 = $(_pageId+" #pass2").val().trim();
		var pass3 = $(_pageId+" #pass3").val().trim();
		var pass4 = $(_pageId+" #pass4").val().trim();
		if($(_pageId+" .mt15 .icon_check").hasClass("checked")){
			if(validatorUtil.isEmpty(pass1)||validatorUtil.isEmpty(pass2)){
				layerUtils.iMsg(-1,"请完成密码设置!");
				return false;	
			}
		}else{
			if((validatorUtil.isEmpty(pass1)||validatorUtil.isEmpty(pass2))
				&&(validatorUtil.isEmpty(pass3)||validatorUtil.isEmpty(pass4))){
				layerUtils.iMsg(-1,"请完成密码设置!");
				return false;	
			}else if(validatorUtil.isEmpty(pass1)||validatorUtil.isEmpty(pass2)){
				layerUtils.iMsg(-1,"请完成交易密码设置!");
				return false;	
			}else if(validatorUtil.isEmpty(pass3)||validatorUtil.isEmpty(pass4)){
				layerUtils.iMsg(-1,"请完成资金密码设置!");
				return false;	
			}
		}
		if(pass1.length!="6")
		{
			layerUtils.iMsg(-1,"请输入6位数字交易密码，请重新输入!");
			return false;	
		}
		else if(pass1!=pass2)
		{
			layerUtils.iMsg(-1,"交易密码与第一次不符，请重新输入!");
			$(_pageId+" #pass2").val("");
			return false;	
		}
		if(!$(_pageId+" .mt15 .icon_check").hasClass("checked")){
			if(pass3.length!="6")
			{
				layerUtils.iMsg(-1,"请输入6位数字资金密码，请重新输入!");
				return false;	
			}
			else if(pass3 != pass4)
			{
				layerUtils.iMsg(-1,"资金密码与第一次不符，请重新输入!");
				$(_pageId+" #pass4").val("");
				return false;	
			}
		}else{
			$(_pageId+" #pass3").val(pass1);
			$(_pageId+" #pass4").val(pass1);
		}
		return true;
	}
	/**
	 * 提交交易密码，资金密码 两次单独请求
	 * 接口号 501535
	 * 第一次提交设置交易密码 若失败 直接返回；若成功则锁定交易密码设置
	 * 第二次提交设置资金密码 若失败 程序停止，交易密码设置锁定；
	 * pwd_type 1:资金密码 2:交易密码
	 */
	function postPassword()
	{
		var tpassword = $(_pageId+" #pass1").val().trim();
		var fpassword = $(_pageId+" #pass3").val().trim();
		var userid = appUtils.getSStorageInfo("user_id");
		var clientinfo = appUtils.getSStorageInfo("clientinfo");
		var jsessionid = appUtils.getSStorageInfo("jsessionid");
		var tradePasswordParam = {"funcNo":501535,"user_id":userid,"acct_clientid":"","password":tpassword,"pwd_type":"2","clientinfo":clientinfo,"jsessionid":jsessionid};
		var fundPasswordParam  = {"funcNo":501535,"user_id":userid,"acct_clientid":"","password":fpassword,"pwd_type":"1","clientinfo":clientinfo,"jsessionid":jsessionid};
		appUtils.invokeServer(global.serverPath,tradePasswordParam,function(data){
			var errorNo   = data.error_no;
			var errorInfo = data.error_info;
			if(errorNo==0)	//交易密码设置成功，锁定交易密码设置框
			{
				$(_pageId+" #pass1").attr("readonly","readonly");
				$(_pageId+" #pass2").attr("readonly","readonly");
				//第二次调用接口，提交资金密码
				appUtils.invokeServer(global.serverPath,fundPasswordParam,function(data){
					if( data.error_no==0)	//交易密码设置成功，锁定交易密码设置框
					{
						$(_pageId+" #pass3").attr("readonly","readonly");
						$(_pageId+" #pass4").attr("readonly","readonly");
						if($(_pageId+" #pass1").attr("readonly"))
						{
							BindPromptSuccess();
						}
						appUtils.pageInit("account/setPwd","account/thirdDepository",{});
					}
					else
					{
						layerUtils.iAlert(data.error_info);
					}
				});
			}
			else
			{
				layerUtils.iAlert(errorInfo);
				return false;
			}
		});
	}
	
	
	function postPasswordTemp(){
		var tpassword = $(_pageId+" #pass1").val().trim();
		var fpassword = $(_pageId+" #pass3").val().trim();
		var userid = appUtils.getSStorageInfo("user_id");
		var clientinfo = appUtils.getSStorageInfo("clientinfo");
		var jsessionid = appUtils.getSStorageInfo("jsessionid");
		var params = {
			"funcNo":1004060,
			"user_id":userid,
			"acct_clientid":"",
			"tradepwd":tpassword,
			"fundpwd":fpassword,
			"clientinfo":clientinfo,
			"jsessionid":jsessionid
			};
		appUtils.invokeServer(global.serverPath,params,function(data){
		if( data.error_no==0)	//交易密码设置成功，锁定交易密码设置框
			{
				$(_pageId+" #pass3").attr("readonly","readonly");
				$(_pageId+" #pass4").attr("readonly","readonly");
				if($(_pageId+" #pass1").attr("readonly"))
				{
					BindPromptSuccess();
				}
				appUtils.pageInit("account/setPwd","account/thirdDepository",{});
			}
			else
			{
				layerUtils.iAlert(data.error_info);
			}
		});
		
	};
	
	
	
	/**
	 * 验证密码 6位数字
	 */
	function validatePassword(obj)
	{
		var password = obj.val().trim();
		if(!validatorUtil.isNumeric(password) || password.length !=6)
		{
			layerUtils.iMsg(-1,"请输入6位数字密码");
			obj.val("");
			return;
		}
		// 增加弱密校验
		/**
		 * 1、出生日期的一部分
		 * 2、证件号码的一部分
		 * 3、某一字符出现的概率不能占总长度的一半以上
		 * 4、顺序递增或者递减
		 * 5、弱密表的控制值
		 * 6、移动电话的一部分
		 * 7、固定电话的一部分
		 */
		var idCardNo = appUtils.getSStorageInfo("idCardNo")?appUtils.getSStorageInfo("idCardNo"):"",
			mobileNo = appUtils.getSStorageInfo("mobileNo")?appUtils.getSStorageInfo("mobileNo"):"";
		// 判断是不是出生日期的一部分
		if(password == idCardNo.substring(6,12) || password == idCardNo.substring(8,14))
		{
			layerUtils.iAlert("密码不能是出生日期的一部分！",-1);
			// 将密码清除
			obj.val("");
			return;
		}
		// 判断是不是证件号码的一部分
		if(idCardNo.indexOf(password) != -1)
		{
			layerUtils.iAlert("密码不能是证件号码的一部分！",-1);
			// 将密码清除
			obj.val("");
			return;
		}
		// 判断某一字符出现的次数
		for(var i=0;i<password.length;i++)
		{
			var oneChar = password.charAt(i),
				count = 0;
			var firstPosition = 0;
			for(var j=0;j<password.length;j++)
			{
				if(oneChar == password.charAt(j))
				{
					count++;
				}
			}
			if(count >= 3)
			{
				layerUtils.iAlert("密码中&nbsp;"+oneChar+"&nbsp;出现的次数超过了三次！",-1);
				// 将密码清除
				obj.val("");
				return;
			}
			
		}
		// 判断顺序递增或者递减
		var orderArray = ['012345',123456,234567,345678,456789,987654,876543,765432,654321,543210];
		if(orderArray.indexOf(password) != -1)
		{
			layerUtils.iAlert("密码不能是顺序递增或者递减！",-1);
			// 将密码清除
			obj.val("");
			return;
		}
		// 判断是否是移动电话的一部分
		if(mobileNo.indexOf(password) != -1)
		{
			layerUtils.iAlert("密码不能是移动电话的一部分！",-1);
			// 将密码清除
			obj.val("");
			return;
		}
		return true;
	}
	
	/**
	 * 验证二次输入密码是否相同
	 */
	function validateSecondPassword(i)
	{
		if(i=="1")//交易密码
		{
			var pass1 = $(_pageId+" #pass1").val().trim();
			var pass2 = $(_pageId+" #pass2").val().trim();
			if(pass1.length != 6)
			{
				layerUtils.iMsg(-1,"请输入6位数字交易密码，请重新输入!");
			}
			else if(pass1 != pass2 && pass2 != "")
			{
				layerUtils.iMsg(-1,"交易密码与第一次不符，请重新输入!");
				$(_pageId+" #pass2").val("");
			}
		}
		else	//资金密码
		{
			var pass3 = $(_pageId+" #pass3").val().trim();
			var pass4 = $(_pageId+" #pass4").val().trim();
			if(pass3.length != 6)
			{
				layerUtils.iMsg(-1,"请输入6位数字资金密码，请重新输入!");
			}
			else if(pass3 != pass4 && pass4 != "")
			{
				layerUtils.iMsg(-1,"资金密码与第一次不符，请重新输入!");
				$(_pageId+" #pass4").val("");
			}
		}
	}
	
	function getInput(data)
	{
		data = JSON.parse(data);
		$(_pageId+" #"+data.selector).val(data.value);
	}
	
	function BindPromptSuccess()
	{
		appUtils.bindEvent($(_pageId+" input"),function(){
			layerUtils.iAlert("密码设置成功不可再次设置！");
		});
	}
	
	var setPwd = {
		"init" : init,
		"bindPageEvent" : bindPageEvent,
		"destroy" : destroy
	};
	
	module.exports = setPwd;
});