/**
* 查看协议
*/
define("project/scripts/account/showProtocol",function(require,exports,module){
	var appUtils = require("appUtils"),
		global = require("gconfig").global,
		shellPlugin = require("plugins/native/scripts/native"),
		utils = require("utils"),
		_pageId = "#account_showProtocol";
		
	
	function init(){
		// 清除原有数据
		$(_pageId+" #contenttxt").text("");
		$(_pageId+" .top_title p:eq(0)").text("");
		// 获取页面入参 protocol_id
		var protocol_id = appUtils.getPageParam("protocol_id"),
			queryProtocolParam = {
				"funcNo" : 501524,
				"protocol_id" : protocol_id,
				"clientinfo" : appUtils.getSStorageInfo("clientinfo"),
				"jsessionid" : appUtils.getSStorageInfo("jsessionid")
			};
		if(appUtils.getSStorageInfo("_prePageCode") == "account/thirdDepository")
		{
			// 三方存管传一个标识给后台
			queryProtocolParam.identification = "thirdDepository";
		}
		appUtils.invokeServer(global.serverPath,queryProtocolParam,function(data){
			$(_pageId+" #contenttxt").append(data.results[0].contenttxt);
			$(_pageId+" .top_title p:eq(0)").text(data.results[0].protocol_name);
		});
	}
	function bindPageEvent(){
		
		// 绑定FAQ常见问题按钮
		appUtils.bindEvent($(_pageId+" #a_faq"),function(){
			var webUrl = global.FAQurl;
			var param = {
				"url" : webUrl
			};
			shellPlugin.callShellMethod("webViewPlugin", null,null,param);
		});
		appUtils.bindEvent($(_pageId),function(){
			$(_pageId+" .header_icon").hide();
		});
		
		appUtils.bindEvent($(_pageId+" #a_setting"),function(event){
			$(_pageId+" .header_icon").toggle();
			event.stopPropagation();
		});
		
		appUtils.bindEvent($(_pageId+" #a_phone"),function(){
			utils.callKHRXPhone("4000-188-288");
		});
		
		appUtils.bindEvent($(_pageId+" #recommenderInfo"),function(){
			
			shellPlugin.callShellMethod("recommenderPlugin", null,null,null);
			
		});
		
		// 绑定返回
		appUtils.bindEvent($(_pageId+" .header .icon_back"),function(){
			appUtils.pageBack();
		});
		
		// 绑定继续开户
		appUtils.bindEvent($(_pageId+" .ct_btn a"),function(){
			appUtils.pageBack();
			//appUtils.pageInit("account/showProtocol","account/signProtocol",{});
		});
	}
	function destroy(){
		// 将协议内容置空
		$(_pageId+" #contenttxt").text("");
		$(_pageId+" .top_title p:eq(0)").text("");
	}
	
	var showProtocol = {
		"init" : init,
		"bindPageEvent" : bindPageEvent,
		"destroy" : destroy
	};
	
	module.exports = showProtocol;
});