/**
 * 签署协议
 */
define("project/scripts/account/signProtocol",function(require, exports, module){ 
	var appUtils = require("appUtils"),
		global = require("gconfig").global,
		layerUtils = require("layerUtils"),
		shellPlugin = require("plugins/native/scripts/native"),
		utils = require("utils"),
		_pageId = "#account_signProtocol";
	var lastDetectMsg="";
	
	function init()
	{
		appUtils.setSStorageInfo("signProtocolFlg",'false');
		fillStockAccount();
	}
	
	function fillStockAccount()
	{
		var allOpenAccountStr = "";
		// 清除原有 开通证券账户
		$(_pageId+" .radio_list ul li").remove();
		// 获取 开通证券账户 枚举
		var openAccountEnumParam = {
			"funcNo" : 501501,
			"enum_type" : "zqzhlx",
			"clientinfo" : appUtils.getSStorageInfo("clientinfo"),
			"jsessionid" : appUtils.getSStorageInfo("jsessionid")
		};
		appUtils.invokeServer(global.serverPath,openAccountEnumParam,function(data){
			if(data.error_no == 0 && data.results.length>0)
			{
				var openAccountEnum = data.results;
				for(var i = 0;i<openAccountEnum.length;i++)
				{
					allOpenAccountStr += "<li><a href=\"javascript:;\" class=\"icon_radio\" id=\"selectAccount0"+i+
						"\" value=\""+openAccountEnum[i].item_value+"\">"+openAccountEnum[i].item_name+"</a></li>";
				}
				// 填充 开通证券账户
				$(_pageId+" .radio_list ul").append(allOpenAccountStr);
				//账号绑定提醒事件，数据填充完毕才绑定事件
				appUtils.bindEvent($(_pageId+" .radio_list ul li a"),function(e){
					confrimOpenAccount(this);
					e.stopPropagation();
				});
				var login_flag = appUtils.getSStorageInfo("login_flag");
				if(login_flag=="1"){
					$(_pageId+" .radio_list2").show();
					appUtils.bindEvent($(_pageId+" #chuangye"),function(e){
						if($(this).hasClass("checked"))
						{
							var accountName = $(this).html();
							layerUtils.iConfirm("不开通\""+accountName+"\"账户，将影响您该项正常交易,请您慎重选择!",function(){
								$(_pageId+" #chuangye").removeClass("checked");
								$(_pageId+" .rule_list ul li a[val='Gem_protocol']").hide();
							},null);
						}
						else
						{
							// 选中当前开通账户
							$(_pageId+" #chuangye").addClass("checked");
							$(_pageId+" .rule_list ul li a[val='Gem_protocol']").show();
						}
						e.stopPropagation();
					});
				}
				queryEnterprise();
			}
			else
			{
				layerUtils.iLoading(false);
				layerUtils.iAlert(data.error_info);
			}
		},false);
	}
	
	// 查询创业板的开关
	function queryEnterprise()
	{
		var queryEnterpriseParam = {
				"funcNo" : 1001014,
				"userid" : appUtils.getSStorageInfo("user_id"),
				"clientinfo" : appUtils.getSStorageInfo("clientinfo"),
				"jsessionid" : appUtils.getSStorageInfo("jsessionid")
			};
			appUtils.invokeServer(global.serverPath,queryEnterpriseParam,function(data){
				if(data.error_no == 0 && data.results.length>0)
				{
					if(data.results[0].gemflag == "0")
					{
						// 创业板提示信息
						$(_pageId+" #enterpriseTips").html(data.results[0].tips);
					}
					else
					{
						$(_pageId+" #enterpriseTips").parent().hide();
					}
					fillProtocols();
				}
				else
				{
					layerUtils.iLoading(false);
					layerUtils.iAlert(data.error_info);
				}
			},false);
		
	}
	
	function fillProtocols()
	{
		// 进入页面时，先删除协议列表原有的内容
		$(_pageId+" .rule_list ul li").remove();
		appUtils.invokeServer(global.serverPath,{"funcNo" : 501531},function(data){
			if(data.error_no == 0 && data.results.length>0)
			{
				appUtils.setSStorageInfo("signProtocolFlg",'true');
				var results = data.results,
					allProtocols01 = "",
					allProtocols02 = "";
				var login_flag = appUtils.getSStorageInfo("login_flag");
				for(var i=0;i<results.length;i++)
				{
					if(results[i].en_name=="Gem_protocol" && login_flag=="0"){
						continue;
					}
					if(results[i].protocol_group == 1)
					{
						if(results[i].en_name=="Gem_protocol"){
							allProtocols01 += "<li><a href=\"javascript:;\" protocol-id=\""+results[i].protocol_id+"\" id=\"protocol0"+i+"\" val=\""+results[i].en_name+"\" >《"+
							results[i].protocol_name+"》</a></li>";
						}else{
							allProtocols01 += "<li><a href=\"javascript:;\" protocol-id=\""+results[i].protocol_id+"\" id=\"protocol0"+i+"\">《"+
							results[i].protocol_name+"》</a></li>";
						}
					}
					else
					{
						allProtocols02 += "<li><a href=\"javascript:;\" protocol-id=\""+results[i].protocol_id+"\" id=\"protocol0"+i+"\">《"+
							results[i].protocol_name+"》</a></li>";
					}
					// 预绑定查看协议的事件
					appUtils.preBindEvent($(_pageId+" .rule_list"),"#protocol0"+i,function(e){
						appUtils.pageInit("account/signProtocol","account/showProtocol",{"protocol_id" : $(this).attr("protocol-id")});
						e.stopPropagation();
					});
				}
				$(_pageId+" .rule_list ul:eq(0)").append(allProtocols01);
				$(_pageId+" .rule_list ul:eq(1)").append(allProtocols02);
				// 初始化证券账户的选择
				$(_pageId+" .radio_list ul li a").addClass("checked");
			}
			else
			{
				layerUtils.iAlert(data.error_info);
			}
		});
	}
	
	function bindPageEvent(){
		
		// 绑定FAQ常见问题按钮
		appUtils.bindEvent($(_pageId+" #a_faq"),function(){
			var webUrl = global.FAQurl;
			var param = {
				"url" : webUrl
			};
			shellPlugin.callShellMethod("webViewPlugin", null,null,param);
		});
		appUtils.bindEvent($(_pageId),function(){
			$(_pageId+" .header_icon").hide();
		});
		
		appUtils.bindEvent($(_pageId+" #a_setting"),function(event){
			$(_pageId+" .header_icon").toggle();
			event.stopPropagation();
		});
		
		appUtils.bindEvent($(_pageId+" #a_phone"),function(){
			utils.callKHRXPhone("4000-188-288");
		});
		
		appUtils.bindEvent($(_pageId+" #recommenderInfo"),function(){
			
			shellPlugin.callShellMethod("recommenderPlugin", null,null,null);
			
		});
		
		appUtils.bindEvent($(_pageId+" .header .icon_back"),function(){
			appUtils.pageBack();
		});
		
		// 绑定签署协议
		appUtils.bindEvent($(_pageId+" .rule_check .icon_check"),function(){
			// 设置样式
			$(this).toggleClass("checked");
		});
		
		appUtils.bindEvent($(_pageId+" #enterpriseTips"),function(){
			// 设置样式
			$(this).toggleClass("checked");
		});
		
		// 继续开户（下一步）
		appUtils.bindEvent($(_pageId+" .fix_bot .ct_btn"),function(){
			if(appUtils.getSStorageInfo("signProtocolFlg")=='false'){
				return;
			}
			// 检查是否勾选签署协议
			if($(_pageId+" .rule_check #signProFlag").hasClass("checked"))
			{
				//增加提示
				var detectMsg=detectAccount();
				if(detectMsg!=""){
					if(detectMsg!=lastDetectMsg){
						//第一次提醒
						layerUtils.iAlert(detectMsg);
						lastDetectMsg=detectMsg;
						return;
					}else{
						//第二次提醒
						detectMsg2=detectMsg.replace(/请勾选/,"您未勾选").replace(/否则您将无法/,"您将不能");
						layerUtils.iConfirm(detectMsg2, function() {
							openGdAccount();
							return;
						},null);
					}
				}else{
					openGdAccount();
				}
			}
			else
			{
				layerUtils.iMsg(-1,"请阅读并勾选同意签署以上全部协议！");
			}
		});
		
	}
	
	//增加提示
	function detectAccount(){
		var returnMsg="";
		var AccNameTemp=["深A","沪A"],
		    AccMsgTemp=["深市","沪市"];
		var AccNameArry=[],AccMsgArry=[];
		var AccNum=$(_pageId+" .radio_list ul li a").length;
		var infoNum=0;
		for(var i=0;i<AccNum;i++){
			var jqDom=$($(_pageId+" .radio_list ul li a")[i]);
			if(!jqDom.hasClass("checked")){
				var option=jqDom.text();
				var pos=$.inArray(option,AccNameTemp);
				if(pos!=-1){
					//添加到提醒列表
					AccNameArry.push(AccNameTemp[pos]);
					AccMsgArry.push(AccMsgTemp[pos]);
					infoNum++;
				}
			}
		}
		//拼接报错信息
		if(infoNum>0){
			returnMsg='请勾选"'+AccNameArry.join('"账户、"')+'"账户，否则您将无法购买'+AccMsgArry.join('、')+'的股票和基金';
		}
		return returnMsg;
	}
	
	function destroy(){
		
	}
	
	/**
	 * 提示用户若不开通某账号将影响正常交易
	 * @param {Object} obj
	 * @memberOf {TypeName} 
	 */
	function confrimOpenAccount(obj)
	{
		if($(obj).hasClass("checked"))
		{
			var accountName = $(obj).html();
			layerUtils.iConfirm("不开通\""+accountName+"\"账户，将影响您该项正常交易,请您慎重选择!",function(){
				$(obj).removeClass("checked");
			},null);
		}
		else
		{
			// 选中当前开通账户
			$(obj).addClass("checked");
		}
	}
	
	function openGdAccount()
	{
		var openAccountParam = {
				"funcNo" : 501534,
				"user_id" : appUtils.getSStorageInfo("user_id"),
				// 深A开通情况
				"sza_str" : "",
				// 沪A开通情况
				"sha_str" : "",
				"clientinfo" : appUtils.getSStorageInfo("clientinfo"),
				"jsessionid" : appUtils.getSStorageInfo("jsessionid")
			};
		// 深 A 的开通状况
		if($(_pageId+" .radio_list ul li a[value='1']").hasClass("checked"))
		{
			openAccountParam.sza_str = "1";
		}
		// 沪 A 的开通状况
		if($(_pageId+" .radio_list ul li a[value='3']").hasClass("checked"))
		{
			openAccountParam.sha_str = "1";
		}
		var login_flag = appUtils.getSStorageInfo("login_flag");
		if(login_flag=="0"){
			var isOpenEnterprise = false;
		}else if(login_flag=="1"){
			var isOpenEnterprise = $(_pageId+" #chuangye").hasClass("checked");
		}		
		appUtils.invokeServer(global.serverPath,openAccountParam,function(data){
			if(data.error_no == 0)
			{
				if(isOpenEnterprise)
				{
					// 开通创业板
					openEnterprise("2");
				}
				else
				{
					if(login_flag=="1"){
						openEnterprise("");
					}else if(login_flag=="0"){
						// 取消协议勾选
						$(_pageId+" .rule_check a").removeClass("checked");
						//跳转设置密码页面
						appUtils.pageInit("account/signProtocol","account/setPwd",{});
					}
				}
			}
			else
			{
				layerUtils.iLoading(false);
				layerUtils.iAlert(data.error_info);
			}
		},!isOpenEnterprise);
	}
	
	function openEnterprise(isOk)
	{
		var openEnterpriseParam = {
				"funcNo" : 1001015,
				"userid" : appUtils.getSStorageInfo("user_id"),
				"is_thegem" : isOk,
				"clientinfo" : appUtils.getSStorageInfo("clientinfo"),
				"jsessionid" : appUtils.getSStorageInfo("jsessionid")
			};
		appUtils.invokeServer(global.serverPath,openEnterpriseParam,function(data){
			if(data.error_no == 0)
			{
				// 取消协议勾选
				//$(_pageId+" .rule_check a").removeClass("checked");
				//跳转设置密码页面
				appUtils.pageInit("account/signProtocol","account/setPwd",{});
			}
			else
			{
				layerUtils.iAlert(data.error_info);
			}
		});
	}
	
	var signProtocol = {
		"init" : init,
		"bindPageEvent" : bindPageEvent,
		"destroy" : destroy
	};
	
	module.exports = signProtocol;
});