/**
 * 新开户(转户)须知
 */
define("project/scripts/account/welcome",function(require, exports, module){ 
	var appUtils = require("appUtils"),
		shellPlugin = require("plugins/native/scripts/native"),
		gconfig = require("gconfig"),
		global = gconfig.global,
		utils=require("utils"),
		currVersion = null, // 当前版本号
		layerUtils = require("layerUtils"),
	    _pageId = "#account_welcome";
	
	function init()
	{
		//弹出式广告
		showAds();
		// 解决 iPhone 4 和 iPhone 4s 页面不在一屏的问题
		if($(document).height() > $(window).height())
		{
			//$(_pageId+" .ness_box").css("padding","10px");
			//$(_pageId+" .main").css("padding-bottom","5px");
		}
		
		if(appUtils.getSStorageInfo("_isStarted") != "true")
		{
			queryVersAndAddr(); // 查询服务器上的版本号和下载地址
			appUtils.setSStorageInfo("_isStarted", "true");
		}	
		setRecommendInfo();	
	}
	
	//公告弹窗
	function showAds(){
		$.ajax({
		         type : "get",
		         async : false,
		         url : "http://sis-pa18-content.paic.com.cn/main/huodong/khgg/khad.jsonp",  //生产
		         //url:"http://1.nativeapp.sinaapp.com/jsons/khad.jsonp", //FAT     
		         dataType : "jsonp",
		         jsonp : "callback",
		         jsonpCallback : "getAd",
		         success : function(ads) {
		            if(ads){
		            	var endFlag=true;
		            	if(ads.endDate!=""){
		            		var endDateT=ads.endDate.replace(/-/g,"/");
            				var currDate=new Date();
		            		var endDate=new Date(endDateT);
		            		if(endDate<currDate){
		            			endFlag=false;
		            		}
		            	}
		            	//在日期范围内，且包含当前渠道channel：5：app 6：pc  7.保单app 8.新开web 9.保单web
		            	var channelArr=ads.channel.split(",");
		            	if(jQuery.inArray("5", channelArr)!=-1&&endFlag){
		            		var adsContent="<div id='adsContent' style='padding:0 20px;color:#ccc;'>"+ads.content+"<div style='text-align:right;margin-top:10px;'>"+ads.footer+"</div></div>";
		            		layerUtils.iAlert(ads.title+adsContent,'','',"知道了");
		            		var resetCss =  setInterval(function(){
								if($("#adsContent").length>0){
									if($("#adsContent").height()>66){
										$("#adsContent").css("text-align","left");
									}
									clearInterval(resetCss);
								}
							 },10);
		            	}
            		}
		         }
		    });
	}
	
	function setRecommendInfo() {
		var aid = global.aid;
		var sid = global.sid;
		var ouid = global.ouid;
		var recommenderNo = global.recommenderNo;
		$(_pageId + " #aid").html(aid);
		$(_pageId + " #sid").html(sid);
		$(_pageId + " #ouid").html(ouid);
		$(_pageId + " #recommenderNo").html(recommenderNo);
	}
	
	/**
	 * IOS禁用页面选择
	 */
	function disablePageSelect() {
		if(gconfig.platform == "2" ) {
			document.onselectstart = function() {
				return false;
			};
		}
	}

	function bindPageEvent(){
		//ios禁用页面选择
		disablePageSelect();

		var queryAllUrl=global.serverPath;
		var queryUrl=global.serverPath.substring(0,queryAllUrl.length-12)+"query/queryStatus.html?WT.mc_id=KHJD01&WT.srch=1&aid=57&sid=685&ouid=KHJD01";
		// 绑定FAQ常见问题按钮
		appUtils.bindEvent($(_pageId+" #a_faq"),function(){
			var webUrl = global.FAQurl;
			var param = {
				"url" : webUrl
			};
			shellPlugin.callShellMethod("webViewPlugin", null,null,param);
		});
		//联系电话
		
		appUtils.bindEvent($(_pageId),function(){
			$(_pageId+" .header_icon").hide();
		});
		
		appUtils.bindEvent($(_pageId+" #a_setting"),function(event){
			$(_pageId+" .header_icon").toggle();
			event.stopPropagation();
		});
		
		appUtils.bindEvent($(_pageId+" #a_phone"),function(){
			utils.callKHRXPhone("4000-188-288");
		});
		
		appUtils.bindEvent($(_pageId+" #recommenderInfo"),function(){
			
			shellPlugin.callShellMethod("recommenderPlugin", null,null,null);
			
		});
		
		
		
		// 查询进度
		appUtils.bindEvent($(_pageId+" #queryOpenAccount"),function(){
			var webUrl = queryUrl;
			var param = {
				"url" : webUrl,
				"title" : "平安证券-开户进度查询"
			};
			shellPlugin.callShellMethod("webViewPlugin", null,null,param);
		});
		
		appUtils.bindEvent($(_pageId+" #version"),function(){
			$(_pageId+" .recommenderNo").toggle();
		});
		
		appUtils.bindEvent($(_pageId+" #openNewAccount"),function(){
			appUtils.setSStorageInfo("login_flag", "0");
			openAndTransferAccount(0);
		});
		
		appUtils.bindEvent($(_pageId+" #transferAccount"),function(){
			appUtils.setSStorageInfo("login_flag", "1");
			openAndTransferAccount(1);
		});
	}
	
	function openAndTransferAccount(type){		
		if(gconfig.platform == 3){
			var terminal_type;
			if(gconfig.platform == "1"){
				terminal_type = "android_new";
			}else{
				terminal_type = "ios_new";
			}
			var queryParam = {
				"funcNo" : 501560,
				"terminal_type" : terminal_type // 类型
			};		
			appUtils.invokeServer(global.serverPath, queryParam, function(data){
				if(data.error_no == 0)
				{
					if(data.results.length != 0 && data.results[0].update_url != undefined)  // 服务器有数据返回时
					{
						var results_n = data.results;
						//if(results_n[0].enforcement == 1){
						//	execUpdate(results_n);
						//}else{
							appUtils.pageInit("account/welcome","account/openAccount",{});
						//}
					}else{
						appUtils.pageInit("account/welcome","account/openAccount",{});
					}
				}
				else  // 查询地址失败
				{
					layerUtils.iAlert("版本检查失败，请稍后重试！");
				}
			});				
		}
		else
		{
			var terminal_type;
			if(gconfig.platform == "1"){
				terminal_type = "android_new";
			}else{
				terminal_type = "ios_new";
			}
			var queryParam = {
				"funcNo" : 501560,
				"terminal_type" : terminal_type  // 类型
			};
			appUtils.invokeServer(global.serverPath, queryParam, function(data){
				if(data.error_no == 0)
				{
					if(data.results.length != 0 && data.results[0].update_url != undefined)  // 服务器有数据返回时
					{
						var results_n = data.results;
						//if(results_n[0].enforcement == 1){
						//	execUpdate(results_n);
						//}else{
							appUtils.pageInit("account/welcome","account/openAccount",{});
						//}
					}else{
						appUtils.pageInit("account/welcome","account/openAccount",{});
					}
				}
				else  // 查询地址失败
				{
					layerUtils.iAlert("版本检查失败，请稍后重试！");
				}
			});
		}		
	}	
	
	function destroy()
	{
	}
	
	// 查询服务器上的版本号和下载地址
	function queryVersAndAddr()
	{
		var terminal_type;
		if(gconfig.platform == "1"){
			terminal_type = "android_new";
		}else{
			terminal_type = "ios_new";
		}
		// 查询服务器上最新的版本号
		var queryParam = {
				"funcNo" : 501560,
				"terminal_type" : terminal_type   // 类型
		};
		appUtils.invokeServer(global.serverPath, queryParam, function(data){
			if(data.error_no == 0)
			{
				if(data.results.length != 0 && data.results[0].update_url != undefined)  // 服务器有数据返回时
				{
					var results_n = data.results;
					if(results_n[0].enforcement == 1){
						//execUpdate(results_n);
					}
				}
			}
			else  // 查询地址失败
			{
				layerUtils.iAlert("版本检查失败，请稍后重试！");
			}
		});
	}
	
	/*IOS 自动更新的提示*/
	function updateTipsForIOS(results)
	{
		var length = results.length;
		var	versionLatest = results[0].version;  // 最新版本号  
		var	versionLowest = results[0].version == results[length-1].version ? "0.0.0" : results[length-1].version;  // 只有一条记录取 0
		var	firstEnforcement = results[0].enforcement;  // 第一条记录是否是强制更新
		if((!compareCurrAndOther(currVersion, versionLatest) && firstEnforcement == 1) || !compareCurrAndOther(currVersion,versionLowest))  // 如果第一条记录是强制更新或者当前版本小于最低版本
		{
			layerUtils.iAlert("您的当前版本过低，无法正常使用，请升级安装新版【V"+versionLatest+"】。",-1,function(){
				//execUpdate(results);  // 执行升级
			},"升级");
		}
		// 当前版本大于最低版本，小于最新版本
		else if(compareCurrAndOther(currVersion, versionLowest) && !compareCurrAndOther(currVersion, versionLatest))
		{
			layerUtils.iConfirm("检测到新版本,是否更新?", function(){
				//execUpdate(results);  // 执行升级
			},null, "升级", "忽略");
		}
	}
	
	/**
	 * 比较当前版本其他版本
	 * 当前版本比其他版大或者相等返回 true ，否则返回 false 
	 */
	function compareCurrAndOther(currVersion, otherVersion)
	{
		var currVersionArr = currVersion.split("."),
			otherVersionArr = otherVersion.split(".");  // 最低版本拆分后
		if(currVersionArr[0] > otherVersionArr[0])
		{
			return true;
		}
		else if(currVersionArr[0] < otherVersionArr[0])
		{
			return false;
		}
		else
		{
			currVersionArr.shift(); // 移除数组中第一个元素
			otherVersionArr.shift(); // 移除数组中第一个元素
			var currVersionNum = Number(currVersionArr.join(".")); // 去除第一组数字后的版本号数值表示
			var otherVersionNum = Number(otherVersionArr.join(".")); // 去除第一组数字后的版本号数值表示
			if(currVersionNum >= otherVersionNum)
			{
				return true;
			}
			else
			{
				return false;
			}
		}
		return false;  // 上述条件都不符合，返回 false
	}
	
	
	// 执行更新
	function execUpdate(results)
	{
		var length = results.length,
			updateParam = {
				"url" : results[0].update_url,  // 更新地址
				"versionLatest" : results[0].version,  // 最新版本号  
				// 只有一条记录取 0
				"versionLowest" : results[0].version == results[length-1].version ? "0" : results[length-1].version,  
				"firstEnforcement" : results[0].enforcement  // 第一条记录是否是强制更新
		};
		shellPlugin.callShellMethod("updateManagerPlugin", null, function(data){
			layerUtils.iAlert("调用版本更新插件失败，失败原因：" + data);
		},updateParam);
	}
	
	var welcome = {
		"init" : init,
		"bindPageEvent" : bindPageEvent,
		"destroy" : destroy
	};
	
	module.exports = welcome;
});